<?php
namespace Payroll\Repository;

use Application\Repository\HrisRepository;
use Payroll\Model\SalarySheetEmpDetail;
use Zend\Db\Adapter\AdapterInterface;

class SalSheEmpDetRepo extends HrisRepository {

    public function __construct(AdapterInterface $adapter) {
        parent::__construct($adapter, SalarySheetEmpDetail::TABLE_NAME);
    }

    public function fetchOneBy($by) {
        return $this->tableGateway->select($by)->current();
    }
    
    public function fetchOneByWithEmpDetails($monthId,$employeeId){
             $boundedParameter = [];
        $boundedParameter['monthId'] = $monthId;
        $boundedParameter['employeeId'] = $employeeId;

        $sql="SELECT 
        SSD.*
        ,E.ID_PROVIDENT_FUND_NO
        ,E.ID_PAN_NO
        ,E.ID_RETIREMENT_NO
		,E.EMPLOYEE_CODE
		,E.ID_ACCOUNT_NO
        FROM HRIS_SALARY_SHEET_EMP_DETAIL SSD
        LEFT JOIN HRIS_EMPLOYEES E ON SSD.EMPLOYEE_ID=E.EMPLOYEE_ID
        WHERE
        SSD.MONTH_ID=? AND SSD.EMPLOYEE_ID=?";
       
        $statement = $this->adapter->query($sql);
        $result=$statement->execute($boundedParameter);
        return $result->current();
    }
    
    
}
