<?php

namespace Appraisal\Form;

use Zend\Form\Annotation;

class  AppraisalEmpForm {

    /**
     * @Annotation\Type("Zend\Form\Element\Text")
     * @Annotation\Required(false)
     * @Annotation\Filter({"name":"StringTrim","name":"StripTags"})
     * @Annotation\Options({"label":"Employee Code"})
     * @Annotation\Attributes({ "id":"employeeCode", "class":"form-control" })
     */
    public $employeeCode;
    public $employeeId;

    /**
     * @Annotation\Type("Zend\Form\Element\Select")
     * @Annotation\Required(true)
     * @Annotation\Options({"disable_inarray_validator":"true","label":"Company"})
     * @Annotation\Attributes({ "id":"companyId","class":"form-control"})
     */
    public $companyId;

    
    /**
     * @Annotation\Type("Zend\Form\Element\Text")
     * @Annotation\Required(true)
     * @Annotation\Filter({"name":"StringTrim","name":"StripTags"})
     * @Annotation\Options({"label":"Full Name"})
     * @Annotation\Attributes({ "id":"fullName", "class":"form-control" })
     */
    public $fullName;
    
    /**
     * @Annotation\Type("Zend\Form\Element\Select")
     * @Annotation\Required(true)
     * @Annotation\Options({"disable_inarray_validator":"true","label":"Appraisal Id"})
     * @Annotation\Attributes({ "id":"appraisalId","class":"form-control"})
     */
    public $appraisalId;

    /**
     * @Annotation\Type("Zend\Form\Element\Text")
     * @Annotation\Required(true)
     * @Annotation\Filter({"name":"StringTrim","name":"StripTags"})
     * @Annotation\Options({"label":"Appraisal From Date"})
     * @Annotation\Attributes({ "id":"appraisalFromDate", "class":"form-control" })
     */
    public $appraisalFromDate;

    /**
     * @Annotation\Type("Zend\Form\Element\Text")
     * @Annotation\Required(true)
     * @Annotation\Filter({"name":"StringTrim","name":"StripTags"})
     * @Annotation\Options({"label":"Appraisal To Date"})
     * @Annotation\Attributes({ "class":"form-control", "id":"appraisalToDate" })
     */
    public $appraisalToDate;

    /**
     * @Annotation\Type("Zend\Form\Element\Select")
     * @Annotation\Required(true)
     * @Annotation\Options({"disable_inarray_validator":"true","label":"Position"})
     * @Annotation\Attributes({ "id":"positionId","class":"form-control"})
     */
    public $positionId;

    /**
     * @Annotation\Type("Zend\Form\Element\Select")
     * @Annotation\Required(true)
     * @Annotation\Options({"disable_inarray_validator":"true","label":"Functional Level Id"})
     * @Annotation\Attributes({ "id":"functionalLevelId","class":"form-control"})
     */
    public $functionalLevelId;
    
    
    /**
     * @Annotation\Type("Zend\Form\Element\Select")
     * @Annotation\Required(true)
     * @Annotation\Options({"disable_inarray_validator":"true","label":"Department"})
     * @Annotation\Attributes({ "id":"departmentId","class":"form-control"})
     */
    public $departmentId;

    /**
     * @Annotation\Type("Zend\Form\Element\Select")
     * @Annotation\Required(true)
     * @Annotation\Options({"disable_inarray_validator":"true","label":"Location"})
     * @Annotation\Attributes({ "id":"locationId","class":"form-control"})
     */
    public $locationId;

    /**
     * @Annotation\Type("Zend\Form\Element\Select")
     * @Annotation\Required(true)
     * @Annotation\Options({"disable_inarray_validator":"true","label":"Service Group "})
     * @Annotation\Attributes({ "id":"serviceGroupId","class":"form-control"})
     */
    public $serviceGroupId;
    
    /**
     * @Annotation\Type("Zend\Form\Element\Select")
     * @Annotation\Required(true)
     * @Annotation\Options({"disable_inarray_validator":"true","label":"Supervisor"})
     * @Annotation\Attributes({ "id":"supervisorId","class":"form-control"})
     */
    public $supervisorId;

    /**
     * @Annotation\Type("Zend\Form\Element\Select")
     * @Annotation\Required(true)
     * @Annotation\Options({"disable_inarray_validator":"true","label":"Reviewer"})
     * @Annotation\Attributes({ "id":"reviewerId","class":"form-control"})
     */
    public $reviewerId;


    /**
     * @Annotation\Type("Zend\Form\Element\Select")
     * @Annotation\Required(true)
     * @Annotation\Options({"disable_inarray_validator":"true","label":"Branch"})
     * @Annotation\Attributes({ "id":"branchId","class":"form-control"})
     */
    public $branchId;




    /**
     * @Annotation\Type("Zend\Form\Element\Text")
     * @Annotation\Required(true)
     * @Annotation\Filter({"name":"StringTrim","name":"StripTags"})
     * @Annotation\Options({"label":"Appraisal Requested Date"})
     * @Annotation\Attributes({ "class":"form-control", "id":"requestedDate" })
     */
    public $requestedDate;

}
