<?php

namespace AttendanceManagement\Form;

use Zend\Form\Annotation;

/**
 * @Annotation\Hydrator("Zend\Hydrator\ObjectPropertyHydrator")
 * @Annotation\Name("AttendanceOverride")
 */
class AttendanceOverrideForm {

    /**
     * @Annotation\Type("Zend\Form\Element\Select")
     * @Annotation\Required(false)
     * @Annotation\Filter({"name":"StringTrim","name":"StripTags"})
     * @Annotation\Options({"disable_inarray_validator":"true","label":"Employee"})
     * @Annotation\Attributes({ "id":"employeeId","class":"form-control"})
     */
    public $employeeId;

    /**
     * @Annotation\Type("Zend\Form\Element\Text")
     * @Annotation\Required(false)
     * @Annotation\Filter({"name":"StringTrim","name":"StripTags"})
     * @Annotation\Options({"label":"Attendance Date"})
     * @Annotation\Attributes({ "id":"attendanceDate","class":"form-control" })
     */
    public $attendanceDt;

    /**
     * @Annotation\Type("Zend\Form\Element\DateTimeLocal")
     * @Annotation\Required(false)
     * @Annotation\Filter({"name":"StringTrim","name":"StripTags"})
     * @Annotation\Validator({"name":"StringLength", "options":{"max":"500"}})
     * @Annotation\Options({"label":"In Time"})
     * @Annotation\Attributes({ "id":"inTime","class":"form-control"})
     */
    public $inTime;

    /**
     * @Annotation\Type("Zend\Form\Element\Text")
     * @Annotation\Required(false)
     * @Annotation\Filter({"name":"StringTrim","name":"StripTags"})
     * @Annotation\Validator({"name":"StringLength", "options":{"max":"500"}})
     * @Annotation\Options({"label":"In Remarks"})
     * @Annotation\Attributes({ "id":"inRemarks","class":"form-control"})
     */
    public $inRemarks;

    /**
     * @Annotation\Type("Zend\Form\Element\DateTimeLocal")
     * @Annotation\Required(false)
     * @Annotation\Filter({"name":"StringTrim","name":"StripTags"})
     * @Annotation\Validator({"name":"StringLength", "options":{"max":"500"}})
     * @Annotation\Options({"label":"Out Time"})
     * @Annotation\Attributes({ "id":"outTime","class":"form-control"})
     */
    public $outTime;

    /**
     * @Annotation\Type("Zend\Form\Element\Text")
     * @Annotation\Required(false)
     * @Annotation\Filter({"name":"StringTrim","name":"StripTags"})
     * @Annotation\Validator({"name":"StringLength", "options":{"max":"500"}})
     * @Annotation\Options({"label":"Out Remarks"})
     * @Annotation\Attributes({ "id":"outRemarks","class":"form-control"})
     */
    public $outRemarks;

    /**
     * @Annotation\Type("Zend\Form\Element\Submit")
     * @Annotation\Attributes({"value":"Submit","class":"btn btn-success", "id":"submit"})
     */
    public $submit;

}
