<?php
namespace AttendanceManagement\Repository;

use Application\Helper\EntityHelper;
use Application\Helper\Helper;
use Application\Model\Model;
use Application\Repository\RepositoryInterface;
use AttendanceManagement\Model\Attendance;
use AttendanceManagement\Model\AttendanceDetail;
use Setup\Model\HrEmployees;
use Zend\Db\Adapter\AdapterInterface;
use Zend\Db\Sql\Expression;
use Zend\Db\Sql\Sql;
use Zend\Db\TableGateway\TableGateway;

class AttendancePullApiRepository implements RepositoryInterface {

    private $tableGateway;
    private $adapter;

    public function __construct(AdapterInterface $adapter) {
        $this->tableGateway = new TableGateway(AttendanceDetail::TABLE_NAME, $adapter);
        $this->adapter = $adapter;
    }

    public function add(Model $model) {
        $this->tableGateway->insert($model->getArrayCopyForDB());
    }

    public function edit(Model $model, $id) {
        $array = $model->getArrayCopyForDB();
        $this->tableGateway->update($array, [AttendanceDetail::ID => $id]);
    }

    public function fetchAll() {
    
    }

    public function fetchById($id) {
    
    }

    public function delete($id) {
    
    }

    public function getDeviceName(){
        $sql = "
        SELECT * FROM HRIS_ATTENDANCE_DEVICES WHERE STATUS='E'
                ";
        return EntityHelper::rawQueryResult($this->adapter, $sql);
    }

    public function getEmployeeList() {
        $sql = "SELECT EMPLOYEE_ID, EMPLOYEE_CODE, FULL_NAME FROM HRIS_EMPLOYEES WHERE STATUS = 'E'";
        return EntityHelper::rawQueryResult($this->adapter, $sql);
    }

    public function getEmployeeThumb($empId){
        $sql="SELECT ID_THUMB_ID FROM HRIS_EMPLOYEES WHERE EMPLOYEE_ID=$empId";
        return EntityHelper::rawQueryResult($this->adapter, $sql);
    }
}
