<?php

namespace Loan\Repository;

use Zend\Db\TableGateway\TableGateway;
use Zend\Db\Sql\Sql;
use Zend\Db\Sql\Select;
use Application\Repository\RepositoryInterface;
use Setup\Model\HrEmployees;
use Application\Repository\HrisRepository;
use Application\Helper\EntityHelper;

class LoanReportRepository extends HrisRepository{

    public function __construct(\Zend\Db\Adapter\AdapterInterface $adapter) {
        $this->adapter = $adapter;
    }

    public function add(\Application\Model\Model $model) {
        
    }

    public function delete($id) {
        
    }

    public function edit(\Application\Model\Model $model, $id) {
        
    }

    public function fetchAll() {
        
    }

    public function fetchById($id) {
        
    }

    // public function fetchEmployeeLoanDetails($data){
    //     $fromDate = $data['fromDate'];
    //     $toDate = $data['toDate'];
    //     $employeeId = $data['employeeId'];
    //     $companyId = $data['companyId'];
    //     $branchId = $data['branchId'];
    //     $departmentId = $data['departmentId'];
    //     $designationId = $data['designationId'];
    //     $positionId = $data['positionId'];
    //     $serviceTypeId = $data['serviceTypeId'];
    //     $serviceEventTypeId = $data['serviceEventTypeId'];
    //     $loanId = $data['loanId'];
    //     $loanRequestStatusId = $data['loanRequestStatusId'];
    //     $employeeTypeId = $data['employeeTypeId'];
    //     $loanStatus = $data['loanStatus'];
    //     $searchCondition = EntityHelper::getSearchConditon($companyId, $branchId, $departmentId, $positionId, $designationId, $serviceTypeId, $serviceEventTypeId, $employeeTypeId, $employeeId);
    //     $sql = "SELECT DISTINCT
    //     e.employee_code,
    //     e.full_name,
    //     initcap(l.loan_name) AS loan_name,
    //     lr.requested_amount,
    //     lr.loan_request_id,
    //     ((
    //         SELECT
    //         IFNULL(SUM(amount), 0)
    //         FROM
    //             hris_loan_payment_detail
    //         WHERE
    //                 paid_flag = 'Y'
    //             AND
    //                 loan_request_id = lr.loan_request_id
    //     ) + (
    //         SELECT
    //         IFNULL(SUM(principle_amount), 0)
    //         FROM
    //             hris_loan_cash_payment
    //         WHERE
    //         loan_req_id = lr.loan_request_id
    //     )) AS paid_amount,
    //     ( 
    //         SELECT
    //             ROUND(SUM(amount))
    //         FROM
    //             hris_loan_payment_detail
    //         WHERE
    //                 paid_flag = 'N'
    //             AND
    //                 loan_request_id = lr.loan_request_id
    //     )  AS balance,
    //     (select amount from hris_loan_payment_detail where loan_request_id = lr.loan_request_id
    //     and from_date = to_date(month(current_date))) AS current_installment,
    //     initcap(TO_CHAR(lr.loan_date,'DD-MON-YYYY') ) AS loan_date_ad,
    //     bs_date((lr.loan_date) ) AS loan_date_bs,
    //     initcap(TO_CHAR(lr.requested_date,'DD-MON-YYYY') ) AS requested_date_ad,
    //     bs_date((lr.requested_date) ) AS requested_date_bs,
    //     lr.loan_status AS status,
    //     lr.employee_id AS employee_id
    // FROM
    //     hris_employee_loan_request lr
    //     LEFT OUTER JOIN hris_loan_master_setup l ON l.loan_id = lr.loan_id
    //     LEFT OUTER JOIN hris_employees e ON e.employee_id = lr.employee_id
    //     LEFT OUTER JOIN hris_loan_payment_detail hlpd ON hlpd.loan_request_id = lr.loan_request_id
    // WHERE
    //     1 = 1 {$searchCondition}";
    
    //     if ($fromDate != null) {
    //         $sql .= " AND LR.LOAN_DATE>=TO_DATE('" . $fromDate . "','DD-MM-YYYY')";
    //     }

    //     if ($toDate != null) {
    //         $sql .= "AND LR.LOAN_DATE<=TO_DATE('" . $toDate . "','DD-MM-YYYY')";
    //     }

    //     if ($loanStatus != 'BOTH') {
    //         $sql .= " AND LR.LOAN_STATUS = '".$loanStatus."'";
    //     }

    //     $sql .= " ORDER BY LR.LOAN_REQUEST_ID DESC";

    //     $statement = $this->adapter->query($sql); 
    //     return $statement->execute();
    // }

    public function fetchEmployeeLoanDetails($data){
        $fromDate = $data['fromDate'];
        $toDate = $data['toDate'];
        $employeeId = $data['employeeId'];
        $companyId = $data['companyId'];
        $branchId = $data['branchId'];
        $departmentId = $data['departmentId'];
        $designationId = $data['designationId'];
        $positionId = $data['positionId'];
        $serviceTypeId = $data['serviceTypeId'];
        $serviceEventTypeId = $data['serviceEventTypeId'];
        $loanId = $data['loanId'];
        $loanRequestStatusId = $data['loanRequestStatusId'];
        $employeeTypeId = $data['employeeTypeId'];
        $loanStatus = $data['loanStatus'];
        $searchCondition = EntityHelper::getSearchConditon($companyId, $branchId, $departmentId, $positionId, $designationId, $serviceTypeId, $serviceEventTypeId, $employeeTypeId, $employeeId);
        $sql = "SELECT DISTINCT
                    e.employee_code, e.full_name,
                    initcap(l.loan_name) AS loan_name,
                    lr.requested_amount,
                    lr.loan_request_id, 
                    (
                        (SELECT IFNULL(SUM(INSTALLMENT), 0) FROM HRIS_EMPLOYEE_EMI_DETAIL WHERE PAID_FLAG = 'Y' AND LOAN_REQUEST_ID = LR.LOAN_REQUEST_ID AND EMPLOYEE_ID = E.EMPLOYEE_ID GROUP BY EMPLOYEE_ID)
                    ) AS PAID_AMOUNT,

                    (SELECT IFNULL(SUM(PRINCIPAL_REPAID), 0) FROM HRIS_EMPLOYEE_EMI_DETAIL WHERE PAID_FLAG = 'Y' AND LOAN_REQUEST_ID = LR.LOAN_REQUEST_ID AND EMPLOYEE_ID = E.EMPLOYEE_ID GROUP BY EMPLOYEE_ID) AS PRINCIPAL_AMOUNT,
                    (SELECT IFNULL(SUM(INTEREST), 0) FROM HRIS_EMPLOYEE_EMI_DETAIL WHERE PAID_FLAG = 'Y' AND LOAN_REQUEST_ID = LR.LOAN_REQUEST_ID AND EMPLOYEE_ID = E.EMPLOYEE_ID GROUP BY EMPLOYEE_ID) AS INTEREST_AMOUNT,

                    (SELECT ROUND(MIN(remaining_principal),2) FROM HRIS_EMPLOYEE_EMI_DETAIL WHERE paid_flag = 'Y' AND LOAN_REQUEST_ID = LR.LOAN_REQUEST_ID AND EMPLOYEE_ID = E.EMPLOYEE_ID) AS REMAIN_BALANCE,

                    (SELECT INSTALLMENT FROM HRIS_EMPLOYEE_EMI_DETAIL WHERE LOAN_REQUEST_ID = LR.LOAN_REQUEST_ID AND PAID_FLAG = 'N' AND EMPLOYEE_ID = E.EMPLOYEE_ID AND 
                        SNO = (SELECT COUNT(*)+1 FROM HRIS_EMPLOYEE_EMI_DETAIL WHERE LOAN_REQUEST_ID = LR.LOAN_REQUEST_ID AND PAID_FLAG = 'Y' AND EMPLOYEE_ID = E.EMPLOYEE_ID)) AS CURRENT_INSTALLMENT,
                    
                    initcap(TO_CHAR(lr.loan_date,'DD-MON-YYYY') ) AS loan_date_ad,
                    bs_date((lr.loan_date) ) AS loan_date_bs,
                    initcap(TO_CHAR(lr.requested_date,'DD-MON-YYYY') ) AS requested_date_ad,
                    bs_date((lr.requested_date) ) AS requested_date_bs,
        
                    lr.loan_status AS loan_status,
                    lr.employee_id AS employee_id,
                    
                    CASE
                        WHEN lr.status = 'RQ' THEN 'PENDING'
                        WHEN lr.status = 'RC' THEN 'REQUESTED CANCEL'
                        WHEN lr.status = 'C'  THEN 'CANCELLED'
                        ELSE 'APPROVED'
                    END as status
                    

                
                FROM hris_employee_loan_request lr

                LEFT OUTER JOIN hris_loan_master_setup l ON l.loan_id = lr.loan_id
                LEFT OUTER JOIN hris_employees e ON e.employee_id = lr.employee_id
                LEFT OUTER JOIN hris_loan_payment_detail hlpd ON hlpd.loan_request_id = lr.loan_request_id
                
                WHERE
        1 = 1 {$searchCondition}";
    
        if ($fromDate != null) {
            $sql .= " AND LR.LOAN_DATE>=TO_DATE('" . $fromDate . "','DD-MM-YYYY')";
        }

        if ($toDate != null) {
            $sql .= "AND LR.LOAN_DATE<=TO_DATE('" . $toDate . "','DD-MM-YYYY')";
        }

        if ($loanStatus != 'BOTH') {
            $sql .= " AND LR.LOAN_STATUS = '".$loanStatus."'";
        }

        $sql .= " ORDER BY LR.LOAN_REQUEST_ID DESC";

        // echo "<pre>";
        // print_r($sql);
        // die;

        $statement = $this->adapter->query($sql); 
        return $statement->execute();
    }
  
    public function fetchLoanVoucher($emp_id, $fromDate, $toDate, $loanId){

        $employeeCondition = $emp_id == '' || $emp_id == null || $emp_id == -1? '' : " AND HELR.EMPLOYEE_ID = $emp_id";
        $loanCondition = $loanId == '' || $loanId == null || $loanId == -1? ' AND HELR.LOAN_ID IN (1,2,3,7) ' : " AND  HELR.LOAN_ID = $loanId" ;
        $loanRequestCondition = $emp_id == '' || $emp_id == null || $emp_id == -1? '' : " AND EMPLOYEE_ID = $emp_id" ;
        $loanRequestCondition2 = $loanId == '' || $loanId == null || $loanId == -1? ' AND LOAN_ID IN (1,2,3,7) ' : " AND loan_id = $loanId" ;
        $employeeCondition2 = $emp_id == '' || $emp_id == null || $emp_id == -1? '' : " AND EMPLOYEE_ID = $emp_id";

        $sql = "SELECT DT, particulars, debit_amount, credit_amount, balance FROM(
        SELECT LAST_DAY(HLPD.FROM_DATE) AS DT, 'Interest Due' as PARTICULARS,
        TRUNC(SUM(HLPD.INTEREST_AMOUNT), 2) AS DEBIT_AMOUNT, 
        0 AS CREDIT_AMOUNT, 0 AS BALANCE
        FROM 
        HRIS_LOAN_PAYMENT_DETAIL HLPD JOIN 
        HRIS_EMPLOYEE_LOAN_REQUEST HELR ON(HELR.LOAN_REQUEST_ID = HLPD.LOAN_REQUEST_ID)
            WHERE hlpd.PAID_FLAG = 'Y' {$loanCondition} AND trunc(HLPD.FROM_DATE, 'month') IN(
        select trunc(add_Months('{$fromDate}', level-1),'month') result
        from DUAL
        connect by level <= MONTHS_BETWEEN('{$toDate}', '{$fromDate}')+1
        ) {$employeeCondition}
        and (helr.loan_status = 'OPEN' or helr.modified_date >= '{$fromDate}' or 
        helr.loan_request_id in 
            (select loan_req_id from hris_loan_cash_payment)
             ) 
        GROUP BY HLPD.FROM_DATE
        
        UNION ALL
        
        SELECT LAST_DAY(HLPD.FROM_DATE) AS DT, 'Interest Paid' as PARTICULARS,
            0 AS DEBIT_AMOUNT,
            TRUNC(SUM(HLPD.INTEREST_AMOUNT), 2) AS CREDIT_AMOUNT, 0 AS BALANCE
        FROM 
        HRIS_LOAN_PAYMENT_DETAIL HLPD JOIN 
        HRIS_EMPLOYEE_LOAN_REQUEST HELR ON(HELR.LOAN_REQUEST_ID = HLPD.LOAN_REQUEST_ID)
            WHERE hlpd.PAID_FLAG = 'Y' {$loanCondition} AND trunc(HLPD.FROM_DATE, 'month') IN(
        select trunc(add_Months('{$fromDate}', level-1),'month') result
        from DUAL
        connect by level <= MONTHS_BETWEEN('{$toDate}', '{$fromDate}')+1
        ) {$employeeCondition}
        and (helr.loan_status = 'OPEN' or helr.modified_date >= '{$fromDate}' or 
        helr.loan_request_id in 
            (select loan_req_id from hris_loan_cash_payment)
             )
        GROUP BY HLPD.FROM_DATE
        
        UNION ALL
        
        SELECT LAST_DAY(HLPD.FROM_DATE) AS DT, 'Amount Paid' as PARTICULARS,
            0 AS DEBIT_AMOUNT,
            TRUNC(SUM(HLPD.AMOUNT), 2) AS CREDIT_AMOUNT, 0 AS BALANCE
        FROM 
        HRIS_LOAN_PAYMENT_DETAIL HLPD JOIN 
        HRIS_EMPLOYEE_LOAN_REQUEST HELR ON(HELR.LOAN_REQUEST_ID = HLPD.LOAN_REQUEST_ID)
        WHERE hlpd.PAID_FLAG = 'Y' {$loanCondition} AND trunc(HLPD.FROM_DATE, 'month') IN(
        select trunc(add_Months('{$fromDate}', level-1),'month') result
        from DUAL
        connect by level <= MONTHS_BETWEEN('{$toDate}', '{$fromDate}')+1
        ) {$employeeCondition}
        and (helr.loan_status = 'OPEN' or helr.modified_date >= '{$fromDate}' 
        or helr.loan_request_id in 
            (select loan_req_id from hris_loan_cash_payment)
              )
        GROUP BY HLPD.FROM_DATE
        ORDER BY DT, DEBIT_AMOUNT DESC, CREDIT_AMOUNT DESC)
                
        UNION ALL

        (SELECT
        LOAN_DATE AS dt,
        'Loan Taken' AS particulars,
        REQUESTED_AMOUNT AS debit_amount,
        0 AS credit_amount,
        0 AS balance
    FROM
        hris_employee_loan_request
    WHERE 1=1
        {$loanRequestCondition2}
        AND
            (LOAN_DATE BETWEEN '{$fromDate}' AND '{$toDate}')    
            and to_char(to_date(loan_date,'dd-mon-yy'),'mm') <> 7
            {$employeeCondition2}
            and loan_request_id not in (select new_loan_req_id from hris_loan_cash_payment))

            UNION ALL

        (SELECT
        PAYMENT_DATE AS dt,
        'Cash Interest Paid' AS particulars,
        INTEREST AS debit_amount,
        0 AS credit_amount,
        0 AS balance
        FROM
        HRIS_LOAN_CASH_PAYMENT
        WHERE
            LOAN_REQ_ID IN (SELECT LOAN_REQUEST_ID FROM hris_employee_loan_request
            WHERE 1=1 {$loanRequestCondition2} {$employeeCondition2})
        AND
            PAYMENT_DATE BETWEEN '{$fromDate}' AND '{$toDate}'    
        )

        UNION ALL

        (SELECT
        PAYMENT_DATE AS dt,
        'Cash Interest Paid' AS particulars,
        0 AS debit_amount,
        INTEREST AS credit_amount,
        0 AS balance
        FROM
        HRIS_LOAN_CASH_PAYMENT
        WHERE
            LOAN_REQ_ID IN (SELECT LOAN_REQUEST_ID FROM hris_employee_loan_request
            WHERE 1=1 {$loanRequestCondition2} {$employeeCondition2})
        AND
            PAYMENT_DATE BETWEEN '{$fromDate}' AND '{$toDate}'    
        )

        UNION ALL

        (SELECT
        PAYMENT_DATE AS dt,
        'Cash Amount Paid' AS particulars,
        0 AS debit_amount,
        PAYMENT_AMOUNT AS credit_amount,
        0 AS balance
        FROM
        HRIS_LOAN_CASH_PAYMENT
        WHERE
            LOAN_REQ_ID IN (SELECT LOAN_REQUEST_ID FROM hris_employee_loan_request
            WHERE 1=1 {$loanRequestCondition2} {$employeeCondition2})
        AND
            PAYMENT_DATE BETWEEN '{$fromDate}' AND '{$toDate}'    
        )

    ORDER BY
        dt,
        debit_amount DESC,
        credit_amount DESC
                ";        
        // echo "<pre>";print_r($sql); die;
        $statement = $this->adapter->query($sql); 
        return $statement->execute();
    }
    
    public function getLoanlist(){
        $sql = "SELECT LOAN_ID, LOAN_NAME FROM HRIS_LOAN_MASTER_SETUP ORDER BY LOAN_ID";
        $statement = $this->adapter->query($sql); 
        return $statement->execute();
    }

    public function getLoanlistById($emp_id){
        $sql = "SELECT 
                    HLMS.LOAN_ID, HLMS.LOAN_NAME, HELR.EMPLOYEE_ID, HELR.LOAN_REQUEST_ID
                FROM HRIS_LOAN_MASTER_SETUP HLMS
                LEFT JOIN HRIS_EMPLOYEE_LOAN_REQUEST HELR ON HELR.LOAN_ID = HLMS.LOAN_ID
                WHERE HELR.EMPLOYEE_ID = {$emp_id}
                ORDER BY HLMS.LOAN_ID ASC";
        return $this->rawQuery($sql);
    }

    public function getUnpaidLoanAmount($postData)
    {
        $sql = "SELECT
                    MAX(EMI.LOAN_AMOUNT) AS UNPAID_AMOUNT,
                    MAX(EMI.REPAYMENT_INSTALLMENTS) AS LEFT_REPAYMENT_INSTALLMENTS,
                    LR.REPAYMENT_INSTALLMENTS AS TOTAL_REPAYMENT_INSTALLMENTS,
                    LR.INTEREST_RATE
                FROM HRIS_EMPLOYEE_LOAN_REQUEST LR
                LEFT JOIN HRIS_EMPLOYEE_EMI_DETAIL EMI ON EMI.LOAN_REQUEST_ID = LR.LOAN_REQUEST_ID
                WHERE LR.EMPLOYEE_ID = {$postData['employeeId']} AND LR.LOAN_REQUEST_ID = {$postData['loanRequestId']} AND EMI.PAID_FLAG = 'N'
                GROUP BY LR.REPAYMENT_INSTALLMENTS, LR.INTEREST_RATE
               ";

        return $this->rawQuery($sql);
    }

    public function getUnpaidLoanDetail($postData)
    {
        // echo "<pre>";

        $sql = "SELECT 
                    REPAYMENT_MONTHS 
                FROM
                    HRIS_EMPLOYEE_LOAN_REQUEST HELR
                WHERE HELR.LOAN_REQUEST_ID = {$postData['loanRequestId']} AND HELR.EMPLOYEE_ID = {$postData['employeeId']}
                ";

        return $this->rawQuery($sql);
    }

    public function getEmployeeApprovedLoan() {

        $sql = "SELECT 
                    E.EMPLOYEE_ID, E.FULL_NAME, E.EMPLOYEE_CODE
                FROM HRIS_EMPLOYEES E
                LEFT JOIN HRIS_EMPLOYEE_LOAN_REQUEST HELR ON HELR.EMPLOYEE_ID = E.EMPLOYEE_ID
                WHERE HELR.STATUS = 'AP'";

        return $this->rawQuery($sql);


    }
      
    public function fetchOpeningBalance($emp_id, $fromDate, $loanId){
        $employeeCondition = $emp_id == '' || $emp_id == null || $emp_id == -1? '' : " AND HELR.EMPLOYEE_ID = $emp_id";
        $loanCondition = $loanId == '' || $loanId == null || $loanId == -1? ' AND HELR.LOAN_ID IN (1,2,3,7) ' : " AND  HELR.LOAN_ID = $loanId" ;
        $loanRequestCondition = $emp_id == '' || $emp_id == null || $emp_id == -1? '' : " AND EMPLOYEE_ID = $emp_id" ;
        $loanRequestCondition2 = $loanId == '' || $loanId == null || $loanId == -1? ' AND LOAN_ID IN (1,2,3,7) ' : " AND loan_id = $loanId" ;
        $employeeCondition2 = $emp_id == '' || $emp_id == null || $emp_id == -1? '' : " AND EMPLOYEE_ID = $emp_id";

        $sql = "SELECT 
    TRUNC(SUM(HLPD.PRINCIPLE_AMOUNT), 2) AS OPENING_BALANCE
    FROM 
    HRIS_LOAN_PAYMENT_DETAIL HLPD JOIN 
    HRIS_EMPLOYEE_LOAN_REQUEST HELR ON(HELR.LOAN_REQUEST_ID = HLPD.LOAN_REQUEST_ID)
        WHERE 
        to_char(to_date(hlpd.from_date,'dd-mon-yy'),'mm') = 7
        and HLPD.FROM_DATE >= trunc(TO_DATE('{$fromDate}'), 'month') 
        AND hlpd.paid_flag = 'Y'
        {$loanCondition}
        {$employeeCondition}
        AND HLPD.LOAN_REQUEST_ID IN(
            SELECT LOAN_REQUEST_ID FROM hris_employee_loan_request
        where 1=1 {$loanRequestCondition})
        and (helr.loan_status = 'OPEN' or helr.modified_date >= '{$fromDate}' or helr.loan_request_id in 
        (select loan_req_id from hris_loan_cash_payment)
        )
        
        ";
        //echo $sql; die;
        $statement = $this->adapter->query($sql); 
        return $statement->execute();
    }

    public function getCashPaymentsList($data) {
        $fromDate = $data['fromDate'];
        $toDate = $data['toDate'];
        $employeeId = $data['employeeId'];
        $companyId = $data['companyId'];
        $branchId = $data['branchId'];
        $departmentId = $data['departmentId'];
        $designationId = $data['designationId'];
        $positionId = $data['positionId'];
        $serviceTypeId = $data['serviceTypeId'];
        $serviceEventTypeId = $data['serviceEventTypeId'];
        $loanId = $data['loanId'];
        $loanRequestStatusId = $data['loanRequestStatusId'];
        $employeeTypeId = $data['employeeTypeId'];

        $sql = "SELECT
                e.employee_code AS employee_code,
                e.FULL_NAME AS FULL_NAME,
                HLCP.id,
                initcap(l.loan_name) AS LOAN_NAME,
                lr.requested_amount AS TOTAL_AMOUNT,
                HLCP.PAYMENT_AMOUNT AS PAID_AMOUNT,
                INITCAP(TO_CHAR(HLCP.payment_date, 'DD-MON-YYYY'))        AS PAID_DATE_AD,
                BS_DATE(TO_CHAR(HLCP.payment_date, 'DD-MON-YYYY'))        AS PAID_DATE_BS,
                HLCP.REMARKS AS REMARKS
                             
                FROM HRIS_EMPLOYEE_LOAN_REQUEST LR
                JOIN HRIS_LOAN_CASH_PAYMENT HLCP 
                ON LR.LOAN_REQUEST_ID = HLCP.LOAN_REQ_ID
                LEFT OUTER JOIN HRIS_LOAN_MASTER_SETUP L
                ON L.LOAN_ID=LR.LOAN_ID
                LEFT OUTER JOIN HRIS_EMPLOYEES E
                ON E.EMPLOYEE_ID=LR.EMPLOYEE_ID
                LEFT OUTER JOIN HRIS_EMPLOYEES E1
                ON E1.EMPLOYEE_ID=LR.RECOMMENDED_BY
                LEFT OUTER JOIN HRIS_EMPLOYEES E2
                ON E2.EMPLOYEE_ID=LR.APPROVED_BY
                LEFT OUTER JOIN HRIS_RECOMMENDER_APPROVER RA
                ON LR.EMPLOYEE_ID = RA.EMPLOYEE_ID
                LEFT OUTER JOIN HRIS_EMPLOYEES RECM
                ON RECM.EMPLOYEE_ID = RA.RECOMMEND_BY
                LEFT OUTER JOIN HRIS_EMPLOYEES APRV
                ON APRV.EMPLOYEE_ID = RA.APPROVED_BY
                WHERE L.STATUS   ='E'
                AND E.STATUS     ='E' ";

        if ($loanId != -1) {
            $sql .= " AND LR.LOAN_ID ='" . $loanId . "'";
        }

        if ($fromDate != null) {
            $sql .= " AND LR.LOAN_DATE>=TO_DATE('" . $fromDate . "','DD-MM-YYYY')";
        }

        if ($toDate != null) {
            $sql .= "AND LR.LOAN_DATE<=TO_DATE('" . $toDate . "','DD-MM-YYYY')";
        }

        if ($employeeTypeId != null && $employeeTypeId != -1) {
            $sql .= "AND E.EMPLOYEE_TYPE='" . $employeeTypeId . "' ";
        }

        if ($employeeId != -1) {
            $sql .= "AND E." . HrEmployees::EMPLOYEE_ID . " = $employeeId";
        }

        if ($companyId != -1) {
            $sql .= " AND E." . HrEmployees::EMPLOYEE_ID . " IN (SELECT " . HrEmployees::EMPLOYEE_ID . " FROM " . HrEmployees::TABLE_NAME . " WHERE " . HrEmployees::COMPANY_ID . "= $companyId)";
        }
        if ($branchId != -1) {
            $sql .= " AND E." . HrEmployees::EMPLOYEE_ID . " IN (SELECT " . HrEmployees::EMPLOYEE_ID . " FROM " . HrEmployees::TABLE_NAME . " WHERE " . HrEmployees::BRANCH_ID . "= $branchId)";
        }
        if ($departmentId != -1) {
            $sql .= " AND E." . HrEmployees::EMPLOYEE_ID . " IN (SELECT " . HrEmployees::EMPLOYEE_ID . " FROM " . HrEmployees::TABLE_NAME . " WHERE " . HrEmployees::DEPARTMENT_ID . "= $departmentId)";
        }
        if ($designationId != -1) {
            $sql .= " AND E." . HrEmployees::EMPLOYEE_ID . " IN (SELECT " . HrEmployees::EMPLOYEE_ID . " FROM " . HrEmployees::TABLE_NAME . " WHERE " . HrEmployees::DESIGNATION_ID . "= $designationId)";
        }
        if ($positionId != -1) {
            $sql .= " AND E." . HrEmployees::EMPLOYEE_ID . " IN (SELECT " . HrEmployees::EMPLOYEE_ID . " FROM " . HrEmployees::TABLE_NAME . " WHERE " . HrEmployees::POSITION_ID . "= $positionId)";
        }
        if ($serviceTypeId != -1) {
            $sql .= " AND E." . HrEmployees::EMPLOYEE_ID . " IN (SELECT " . HrEmployees::EMPLOYEE_ID . " FROM " . HrEmployees::TABLE_NAME . " WHERE " . HrEmployees::SERVICE_TYPE_ID . "= $serviceTypeId)";
        }
        if ($serviceEventTypeId != -1) {
            $sql .= " AND E." . HrEmployees::EMPLOYEE_ID . " IN (SELECT " . HrEmployees::EMPLOYEE_ID . " FROM " . HrEmployees::TABLE_NAME . " WHERE " . HrEmployees::SERVICE_EVENT_TYPE_ID . "= $serviceEventTypeId)";
        }

        $sql .= " ORDER BY LR.LOAN_REQUEST_ID DESC";
        //echo $sql; die;
        $statement = $this->adapter->query($sql);
        $result = $statement->execute();
        return $result;
    }

    public function fetchLoanSummary($emp_id, $fromDate, $toDate, $loanId){
        $employeeCondition = $emp_id == '' || $emp_id == null? '' : " AND HELR.EMPLOYEE_ID = $emp_id";
        $loanCondition = $loanId == '' || $loanId == null || $loanId == -1? ' AND HELR.LOAN_ID IN (1,2,3,7) ' : " AND  HELR.LOAN_ID = $loanId" ;
        $loanRequestCondition = $emp_id == '' || $emp_id == null? '' : " AND EMPLOYEE_ID = $emp_id" ;
        $loanRequestCondition2 = $loanId == '' || $loanId == null || $loanId == -1? ' AND LOAN_ID IN (1,2,3,7) ' : " AND loan_id = $loanId" ;
        $employeeCondition2 = $emp_id == '' || $emp_id == null? '' : " AND EMPLOYEE_ID = $emp_id";

        $sql = "select e.employee, opening_balance, dr_salary, dr_interest, cr_salary, dr_interest as cr_interest,
        (opening_balance + dr_salary - cr_salary) as balance
        from (
        select 
        nvl(sum(opening_balance), 0) as opening_balance,
        sum(dr_salary) as dr_salary,
        sum(dr_interest) as dr_interest,
        sum(cr_salary) as cr_salary
        from (
        SELECT
        0 as opening_balance,
        0 AS dr_salary,
        trunc(SUM(hlpd.interest_amount), 2) AS dr_interest,
        0 AS cr_salary
        FROM
        hris_loan_payment_detail     hlpd
        JOIN hris_employee_loan_request   helr ON ( helr.loan_request_id = hlpd.loan_request_id )
        WHERE
        hlpd.paid_flag = 'Y'
        {$loanCondition}
        AND trunc(hlpd.from_date, 'month') IN (
        SELECT
        trunc(add_months('{$fromDate}', level - 1), 'month') result
        FROM
        dual
        CONNECT BY
        level <= months_between('{$toDate}', '{$fromDate}') 
        )
        {$employeeCondition}
        AND ( helr.loan_status = 'OPEN' or helr.modified_date >= '{$fromDate}'
        OR helr.loan_request_id IN (
        SELECT
        loan_req_id
        FROM
        hris_loan_cash_payment
        ) 
        OR 
                (SELECT TO_CHAR(TO_DATE(FROM_DATE, 'DD-MM-YY'), 'MM') FROM HRIS_LOAN_PAYMENT_DETAIL 
                WHERE LOAN_REQUEST_ID = HELR.LOAN_REQUEST_ID AND SNO = (SELECT MAX(SNO) FROM 
                HRIS_LOAN_PAYMENT_DETAIL WHERE LOAN_REQUEST_ID = HELR.LOAN_REQUEST_ID)
              )  = 7)
        GROUP BY
        hlpd.from_date
        
        union all
        
        SELECT
        0 as opening_balance,
        0 AS dr_salary,
        0 AS dr_interest,
        trunc(SUM(hlpd.amount), 2) AS cr_salary
        FROM
        hris_loan_payment_detail     hlpd
        JOIN hris_employee_loan_request   helr ON ( helr.loan_request_id = hlpd.loan_request_id )
        WHERE
        hlpd.paid_flag = 'Y'
        {$loanCondition}
        AND trunc(hlpd.from_date, 'month') IN (
        SELECT
        trunc(add_months('{$fromDate}', level - 1), 'month') result
        FROM
        dual
        CONNECT BY
        level <= months_between('{$toDate}', '{$fromDate}')
        )
        {$employeeCondition}
        AND ( helr.loan_status = 'OPEN' or helr.modified_date >= '{$fromDate}'
        OR helr.loan_request_id IN (
        SELECT
        loan_req_id
        FROM
        hris_loan_cash_payment
        )
        OR 
                (SELECT TO_CHAR(TO_DATE(FROM_DATE, 'DD-MM-YY'), 'MM') FROM HRIS_LOAN_PAYMENT_DETAIL 
                WHERE LOAN_REQUEST_ID = HELR.LOAN_REQUEST_ID AND SNO = (SELECT MAX(SNO) FROM 
                HRIS_LOAN_PAYMENT_DETAIL WHERE LOAN_REQUEST_ID = HELR.LOAN_REQUEST_ID)
              )  = 7)
        
        GROUP BY
        hlpd.from_date
        
        union all
        
        SELECT
        0 as opening_balance,
        requested_amount AS dr_salary,
        0 AS dr_interest,
        0 AS cr_salary
        
        FROM
        hris_employee_loan_request
        WHERE
        1 = 1
        {$loanRequestCondition2}
        AND ( loan_date BETWEEN '{$fromDate}' AND '{$toDate}' )
        AND to_char(TO_DATE(loan_date, 'dd-mon-yy'), 'mm') <> 7
        {$employeeCondition2}
        AND loan_request_id NOT IN (
        SELECT
        new_loan_req_id
        FROM
        hris_loan_cash_payment
        )
        
        union all
        
        SELECT
            0 as opening_balance,
            0 AS dr_salary,
            0 AS dr_interest,
            payment_amount AS cr_salary
        FROM
            hris_loan_cash_payment
        WHERE
            loan_req_id IN (
                SELECT
                    loan_request_id
                FROM
                    hris_employee_loan_request
                WHERE
                    1 = 1
                    {$loanRequestCondition2}
                    {$employeeCondition2}
            )
            AND payment_date BETWEEN '{$fromDate}' AND '{$toDate}'
        
        union all
        
        SELECT
            trunc(SUM(hlpd.principle_amount), 2) as opening_balance,
            0 AS dr_salary,
            0 AS dr_interest,
            0 AS cr_salary
        FROM
            hris_loan_payment_detail     hlpd
            JOIN hris_employee_loan_request   helr ON ( helr.loan_request_id = hlpd.loan_request_id )
        WHERE
            to_char(to_date(hlpd.from_date, 'dd-mon-yy'), 'mm') = 7 AND
            hlpd.from_date >= trunc(to_date('$fromDate'), 'month')
            AND hlpd.paid_flag = 'Y'
            {$loanCondition}
            {$employeeCondition}
            AND hlpd.loan_request_id IN (
                SELECT
                    loan_request_id
                FROM
                    hris_employee_loan_request
                WHERE
                    1 = 1
                    {$employeeCondition2}
            )
        )) join 
        (select employee_id, employee_code || '-' || full_name as employee 
        from hris_employees where employee_id = {$emp_id}) e
        on 1=1
        ";
        //echo $sql; die;
        $statement = $this->adapter->query($sql); 
        return $statement->execute();
    }

    public function getAllEmployees(){
        $sql = "SELECT EMPLOYEE_ID, EMPLOYEE_CODE, EMPLOYEE_CODE || '-' || FULL_NAME AS FULL_NAME, FULL_NAME AS FULL_NAME_SCIENTIFIC, COMPANY_ID, 
        BRANCH_ID, DEPARTMENT_ID, 
        DESIGNATION_ID, POSITION_ID, SERVICE_TYPE_ID, SERVICE_EVENT_TYPE_ID, GENDER_ID, EMPLOYEE_TYPE, 
        GROUP_ID, FUNCTIONAL_TYPE_ID FROM HRIS_EMPLOYEES";
    
        $statement = $this->adapter->query($sql); 
        return $statement->execute();
    }

    public function getLoanPaymentReport($data){
        $searchCondition = EntityHelper::getSearchConditon($data['companyId'], $data['branchId'], $data['departmentId'], $data['positionId'], $data['designationId'], $data['serviceTypeId'], $data['serviceEventTypeId'], $data['employeeTypeId'], $data['employeeId']);
        $loanCondition = $data['loanId'] == "" ? "" : " and elr.loan_id = ".$data['loanId']." ";

        $sql = "
        select * from
        (select e.employee_code, e.full_name, lms.loan_name, 
        0 as paid_amount, 0 as interest,
        elr.requested_date as DATE_AD,
        BS_DATE(elr.requested_date) as DATE_BS, elr.requested_amount,
        'Loan Taken' as remarks,
        'A' as operation
        from hris_employee_loan_request elr         
        left join hris_loan_master_setup lms on (elr.loan_id = lms.loan_id)
        left join hris_employees e on (elr.employee_id = e.employee_id)
        where 1=1 
        {$searchCondition} {$loanCondition})
        union
        (select e.employee_code, e.full_name, lms.loan_name, 
        TO_DECIMAL(lpd.amount, 10, 2) as paid_amount, TO_DECIMAL(lpd.interest_amount, 10, 2) as interest,
        lpd.to_date as DATE_AD,
        BS_DATE(lpd.to_date) as DATE_BS, elr.requested_amount,
        (case when paid_flag = 'Y' then 'Deducted in payroll' else 'to be paid' end) as remarks,
        'D' as operation
        from hris_loan_payment_detail lpd 
        left join hris_employee_loan_request elr on (lpd.loan_request_id = elr.loan_request_id)
        left join hris_loan_master_setup lms on (elr.loan_id = lms.loan_id)
        left join hris_employees e on (elr.employee_id = e.employee_id)
        where 1=1 and paid_flag = 'Y'
        {$searchCondition} {$loanCondition})
        union
        (select e.employee_code, e.full_name, lms.loan_name, 
        TO_DECIMAL(lcp.principle_amount, 10, 2) as paid_amount, TO_DECIMAL(lcp.interest, 10, 2) as interest,
        lcp.payment_date as DATE_AD, 
        BS_DATE(lcp.payment_date) as DATE_BS, elr.requested_amount,
        'Paid in cash' as remarks,
        'D' as operation
        from hris_loan_cash_payment lcp
        left join hris_employee_loan_request elr on (lcp.loan_req_id = elr.loan_request_id)
        left join hris_loan_master_setup lms on (elr.loan_id = lms.loan_id)
        left join hris_employees e on (elr.employee_id = e.employee_id)
        where 1=1
        {$searchCondition} {$loanCondition})
        order by DATE_AD
        ";

        return $this->rawQuery($sql);
    }


    public function getCurrentMonth()
    {
        $sql = "SELECT MONTH_ID, MONTH_EDESC, FISCAL_YEAR_ID FROM HRIS_MONTH_CODE WHERE CURRENT_DATE BETWEEN FROM_DATE AND TO_DATE";

        $statement = $this->adapter->query($sql);
        $result = $statement->execute();
        return $result->current();

    }

    public function getCurrentFiscalYearMonth($fiscal_year)
    {
        $sql = "SELECT MONTH_ID, MONTH_EDESC, FISCAL_YEAR_ID FROM HRIS_MONTH_CODE WHERE FISCAL_YEAR_ID = {$fiscal_year}";

        return $this->rawQuery($sql);
    }

    public function fetchAllGroupLoanMonth($data)
    {
        $employeeId          = ($data['employeeId']) ? implode(',', $data['employeeId']) : '';
        $companyId           = $data['companyId'];
        $branchId            = ($data['branchId']) ? implode(',',$data['branchId']) : '';
        $departmentId        = ($data['departmentId']) ? implode(',',$data['departmentId']) : '';
        $designationId       = ($data['designationId']) ? implode(',', $data['designationId']) : '';
        $positionId          = ($data['positionId']) ? implode(',', $data['positionId']) : '';
        $serviceTypeId       = $data['serviceTypeId'];
        $serviceEventTypeId  = $data['serviceEventTypeId'];
        $loanId              = ($data['loanId']) ? implode(',', $data['loanId']) : '';
        $loanRequestStatusId = $data['loanRequestStatusId'];
        $employeeTypeId      = $data['employeeTypeId'];
        $loanStatus          = $data['loanStatus'];
        $fiscalYear          = $data['fiscalYear'];


        /** WITH LOAN **/
            $loanData = ($loanId) ? " AND LMS.LOAN_ID IN ({$loanId}) " : " ";
        /** WITH LOAN **/

        /** WITH BRANCH **/
            $branchIDData = ($branchId) ? " AND B.DEPARTMENT_ID IN ({$branchId}) " : " ";
        /** WITH BRANCH **/

        /** WITH DEPARTMENT **/
            $departmentIDData = ($departmentId) ? " AND HD.DEPARTMENT_ID IN ({$departmentId}) " : " ";
        /** WITH DEPARTMENT **/

        /** WITH DESIGNATION **/
            $designationIDData = ($designationId) ? " AND D.DESIGNATION_ID IN ({$designationId}) " : " ";
        /** WITH DESIGNATION **/

        /** WITH POSITION **/
            $positionIDData = ($positionId) ? " AND P.POSITION_ID IN ({$positionId}) " : " ";
        /** WITH POSITION **/

        /** WITH SERVICE EVENT TYPE **/
            $serviceTypeIDData = ($serviceTypeId > 0) ? " AND ST.SERVICE_TYPE_ID = {$serviceTypeId} " : " ";
        /** WITH SERVICE EVENT TYPE **/

        /** WITH SPECIFIC EMPLOYEE **/
            $employeeIDData = ($employeeId) ? " AND E.EMPLOYEE_ID IN ({$employeeId}) " : " ";
        /** WITH SPECIFIC EMPLOYEE **/

        /** WITH EMPLOYEE TYPES **/
            $employeeTypeData = ($employeeTypeId > 0) ? " AND E.EMPLOYEE_TYPE = '{$employeeTypeId}' " : " ";
        /** WITH EMPLOYEE TYPES **/



        /** LOAN STATUS **/
            $loanStatusData = ($loanStatus == 'BOTH') ? " " : (($loanStatus == 'OPEN') ? " AND ELR.LOAN_STATUS = 'OPEN' " : " AND ELR.LOAN_STATUS = 'CLOSED' ");
        /** LOAN STATUS **/


        /** FOR FISCAL YEAR  **/
        $fiscalMonthSql = "SELECT * FROM HRIS_MONTH_CODE 
                           WHERE FISCAL_YEAR_ID = {$fiscalYear} 
                           ORDER BY FISCAL_YEAR_MONTH_NO ASC";

        $fiscalMonthData = $this->rawQuery($fiscalMonthSql);

        $data = '';

        for ($i=0; $i < count($fiscalMonthData) ; $i++) {

            $data .= "MAX(CASE WHEN month_id = "
                  . $fiscalMonthData[$i]['MONTH_ID'] 
                  ." then INSTALLMENT END) AS "
                  .strtoupper($fiscalMonthData[$i]['MONTH_EDESC'])
                  .",";

        }

        $sql = "SELECT
                    
                    EMPLOYEE_CODE, EMPLOYEE_ID, 
                    DESIGNATION_TITLE, POSITION_NAME,
                    FUNCTIONAL_LEVEL_NO, ACTING_FUNCTIONAL_LEVEL_NO,
                    ORDER_ID, HEIR_FUNCTIONAL_ORDER, START_DATE,
                    FULL_NAME, LOAN_REQUEST_ID, LOAN_ID, LOAN_NAME, LOAN_STATUS, 
                    LOAN_DATE_AD, LOAN_DATE_BS,
                    APPLIED_LOAN, INTEREST_RATE, TOTAL_AMOUNT_PAID,

                    ROUND(((INTEREST_RATE * TOTAL_AMOUNT_PAID)/100),2) AS TOTAL_INTEREST_PAID,
                    ROUND((TOTAL_AMOUNT_PAID - ROUND(((INTEREST_RATE * TOTAL_AMOUNT_PAID)/100),2)),2) AS TOTAL_PRINCIPAL_PAID,
                    ROUND((APPLIED_LOAN - ROUND((TOTAL_AMOUNT_PAID - ROUND(((INTEREST_RATE * TOTAL_AMOUNT_PAID)/100),2)),2)),2) AS REMAINING_PRINCIPAL,".

                    $data."

                    -- MAX(CASE WHEN month_id = 85 then INSTALLMENT END) AS SHRAWAN,
                    -- MAX(CASE WHEN month_id = 86 then INSTALLMENT END) AS BHADRA,
                    -- MAX(CASE WHEN month_id = 87 then INSTALLMENT END) AS ASHWIN,
                    -- MAX(CASE WHEN month_id = 88 then INSTALLMENT END) AS KARTIK,
                    -- MAX(CASE WHEN month_id = 89 then INSTALLMENT END) AS MANGSIR,
                    -- MAX(CASE WHEN month_id = 90 then INSTALLMENT END) AS POUSH,
                    -- MAX(CASE WHEN month_id = 91 then INSTALLMENT END) AS MAGH,

                    NEXT_MONTH_INSTALLMENT  
                    
                    FROM (SELECT
                            E.FULL_NAME, E.EMPLOYEE_ID, E.EMPLOYEE_CODE,
                            ELR.LOAN_REQUEST_ID, ELR.LOAN_STATUS, ELR.APPLIED_LOAN,
                            LMS.LOAN_NAME, LMS.LOAN_ID, LMS.INTEREST_RATE,
                            EMI.INSTALLMENT,
                            MC.MONTH_EDESC, MC.MONTH_ID,
                            D.DESIGNATION_TITLE,
                            P.POSITION_NAME,
                            HFL.FUNCTIONAL_LEVEL_NO, HFL.ORDER_ID,
                                
                            HFLL.FUNCTIONAL_LEVEL_NO AS ACTING_FUNCTIONAL_LEVEL_NO,
                            
                            CASE 
                                WHEN HFLL.ORDER_ID IS NULL THEN 999
                                ELSE HFLL.ORDER_ID
                            END AS HEIR_FUNCTIONAL_ORDER,
                            
                            HJH.START_DATE,

                            INITCAP(TO_CHAR(ELR.LOAN_DATE, 'DD-MON-YYYY')) AS LOAN_DATE_AD,
                            BS_DATE(ELR.LOAN_DATE) AS LOAN_DATE_BS,

                            (SELECT 
                                SUM(PRINCIPAL_REPAID) 
                            FROM HRIS_EMPLOYEE_EMI_DETAIL 
                            WHERE EMPLOYEE_ID = E.EMPLOYEE_ID AND PAID_FLAG = 'Y' 
                            GROUP BY EMPLOYEE_ID) AS TOTAL_AMOUNT_PAID, 

                            (SELECT 
                                INSTALLMENT 
                            FROM HRIS_EMPLOYEE_EMI_DETAIL
                            WHERE LOAN_REQUEST_ID = ELR.LOAN_REQUEST_ID AND
                                  SNO = (SELECT 
                                            MIN(SNO) 
                                        FROM HRIS_EMPLOYEE_EMI_DETAIL
                                        WHERE LOAN_REQUEST_ID = ELR.LOAN_REQUEST_ID AND
                                            PAID_FLAG = 'N'
                                        )
                            ) AS NEXT_MONTH_INSTALLMENT
                          
                          FROM HRIS_EMPLOYEE_LOAN_REQUEST ELR

                          LEFT JOIN HRIS_LOAN_MASTER_SETUP LMS ON (LMS.LOAN_ID = ELR.LOAN_ID)
                          LEFT JOIN HRIS_EMPLOYEES E ON (E.EMPLOYEE_ID = ELR.EMPLOYEE_ID)
                          LEFT JOIN HRIS_EMPLOYEE_EMI_DETAIL EMI ON (EMI.LOAN_REQUEST_ID = ELR.LOAN_REQUEST_ID)
                          LEFT JOIN HRIS_MONTH_CODE MC ON (MC.MONTH_ID = EMI.PAYMENT_MONTH)
                          LEFT JOIN HRIS_SERVICE_TYPES ST ON (E.SERVICE_TYPE_ID = ST.SERVICE_TYPE_ID)
                          LEFT JOIN HRIS_POSITIONS P ON (E.POSITION_ID = P.POSITION_ID)
                          LEFT JOIN HRIS_DESIGNATIONS D ON (E.DESIGNATION_ID = D.DESIGNATION_ID)
                          LEFT JOIN HRIS_DEPARTMENTS HD ON (E.DEPARTMENT_ID = HD.DEPARTMENT_ID)
                          LEFT JOIN HRIS_BRANCHES B ON (E.BRANCH_ID = B.BRANCH_ID)
                          LEFT JOIN HRIS_FUNCTIONAL_LEVELS HFL ON E.FUNCTIONAL_LEVEL_ID = HFL.FUNCTIONAL_LEVEL_ID
                              
                          LEFT JOIN HRIS_FUNCTIONAL_LEVELS HFLL ON E.ACTING_FUNCTIONAL_LEVEL_ID = HFLL.FUNCTIONAL_LEVEL_ID

                          LEFT JOIN HRIS_JOB_HISTORY HJH ON (HJH.EMPLOYEE_ID = E.EMPLOYEE_ID 
                               AND HJH.START_DATE = (SELECT 
                                                        MAX(START_DATE)
                                                     FROM HRIS_JOB_HISTORY 
                                                     WHERE EMPLOYEE_ID = E.EMPLOYEE_ID AND SERVICE_EVENT_TYPE_ID IN (1,2)
                                                    ))

                          WHERE EMI.PAID_FLAG='Y' "
                          .$loanData
                          .$branchIDData
                          .$departmentIDData
                          .$designationIDData
                          .$serviceTypeIDData
                          .$positionIDData
                          .$employeeIDData
                          .$employeeTypeData
                          .$loanStatusData
                          ." 
                         ) A
                    
                    GROUP BY FULL_NAME, LOAN_REQUEST_ID, LOAN_STATUS,
                        LOAN_DATE_AD, LOAN_DATE_BS, DESIGNATION_TITLE, POSITION_NAME,
                        FUNCTIONAL_LEVEL_NO, ACTING_FUNCTIONAL_LEVEL_NO, ORDER_ID, HEIR_FUNCTIONAL_ORDER, START_DATE,
                        LOAN_NAME, LOAN_ID, EMPLOYEE_ID, NEXT_MONTH_INSTALLMENT, 
                        EMPLOYEE_CODE, APPLIED_LOAN, INTEREST_RATE, TOTAL_AMOUNT_PAID

                    ORDER BY LOAN_ID, HEIR_FUNCTIONAL_ORDER, ORDER_ID, START_DATE
                    
        ";

        return $this->rawQuery($sql);

    }

    public function salaryDetail($month_id, $pay_id, $employee_id)
    {
        
        $sql = "SELECT SS.*, SSD.*, E.FULL_NAME,
                    LR.LOAN_REQUEST_ID, LR.LOAN_STATUS,
                    M.MONTH_EDESC, M.FROM_DATE, M.TO_DATE, 
                    DAYS_BETWEEN(TO_DATE(M.FROM_DATE, 'YYYY-MM-DD'), TO_DATE(M.TO_DATE, 'YYYY-MM-DD')) + 1 AS DAYS
                FROM HRIS_SALARY_SHEET SS
                LEFT JOIN HRIS_MONTH_CODE M ON M.MONTH_ID = SS.MONTH_ID
                LEFT JOIN HRIS_SALARY_SHEET_DETAIL SSD ON SS.SHEET_NO = SSD.SHEET_NO
                LEFT JOIN HRIS_EMPLOYEES E ON E.EMPLOYEE_ID = SSD.EMPLOYEE_ID
                LEFT JOIN HRIS_EMPLOYEE_LOAN_REQUEST LR ON LR.EMPLOYEE_ID = SSD.EMPLOYEE_ID
                WHERE SS.SALARY_TYPE_ID = 1 AND SS.MONTH_ID IN ({$month_id}) AND 
                    SSD.PAY_ID = {$pay_id} AND SSD.EMPLOYEE_ID IN ({$employee_id})
                    AND SSD.VAL > 0 AND LR.LOAN_ID = 1 AND LR.LOAN_STATUS = 'OPEN'
                ORDER BY E.EMPLOYEE_ID, SS.MONTH_ID ASC";


        return $this->rawQuery($sql);
    }

    

    public function unpaidEmiDetail($data)
    {
        
        $sql = "SELECT *,
                       (SELECT 
                            MAX(PAYMENT_MONTH)
                        FROM HRIS_EMPLOYEE_EMI_DETAIL 
                        WHERE PAID_FLAG = 'Y' AND EMPLOYEE_ID = {$data['EMPLOYEE_ID']} AND LOAN_REQUEST_ID = {$data['LOAN_REQUEST_ID']}
                        ) AS PREVIOUS_MONTH_NO,
                        (SELECT 
                            MAX(EMI_ID)
                        FROM HRIS_EMPLOYEE_EMI_DETAIL 
                        WHERE PAID_FLAG = 'Y' AND EMPLOYEE_ID = {$data['EMPLOYEE_ID']} AND LOAN_REQUEST_ID = {$data['LOAN_REQUEST_ID']}
                        ) AS PAID_EMI_ID
                FROM HRIS_EMPLOYEE_EMI_DETAIL
                WHERE EMPLOYEE_ID = {$data['EMPLOYEE_ID']} AND LOAN_REQUEST_ID = {$data['LOAN_REQUEST_ID']} AND
                      INSTALLMENT = {$data['EMI']} AND PAID_FLAG = 'N'
                ORDER BY SNO ASC LIMIT 1";

        // echo "<pre>";
        // print_r($sql);
        // die;
        $statement = $this->adapter->query($sql);
        $result = $statement->execute();
        return $result->current();  
    }

    public function paidEmiDetail($data)
    {
        
        $sql = "SELECT *,
                       (SELECT 
                            MIN(PAYMENT_MONTH)
                        FROM HRIS_EMPLOYEE_EMI_DETAIL 
                        WHERE PAID_FLAG = 'N' AND EMPLOYEE_ID = {$data['EMPLOYEE_ID']} AND LOAN_REQUEST_ID = {$data['LOAN_REQUEST_ID']}
                        ) AS PREVIOUS_MONTH_NO,
                        (SELECT 
                            MIN(EMI_ID)
                        FROM HRIS_EMPLOYEE_EMI_DETAIL 
                        WHERE PAID_FLAG = 'N' AND EMPLOYEE_ID = {$data['EMPLOYEE_ID']} AND LOAN_REQUEST_ID = {$data['LOAN_REQUEST_ID']}
                        ) AS UNPAID_EMI_ID
                FROM HRIS_EMPLOYEE_EMI_DETAIL
                WHERE EMPLOYEE_ID = {$data['EMPLOYEE_ID']} AND LOAN_REQUEST_ID = {$data['LOAN_REQUEST_ID']} AND
                      INSTALLMENT = {$data['EMI']} AND PAID_FLAG = 'Y'
                ORDER BY SNO DESC LIMIT 1";

        // echo "<pre>";
        // print_r($sql);
        // die;
        $statement = $this->adapter->query($sql);
        $result = $statement->execute();
        return $result->current();  
    }


    public function updateEMIDetail($data) {

        $sql = "UPDATE HRIS_EMPLOYEE_EMI_DETAIL
                SET (PAID_FLAG, PAYMENT_MONTH, SHEET_NO) = ('".$data['PAID_FLAG']."',{$data['PAYMENT_MONTH']},{$data['SHEET_NO']})
                WHERE EMI_ID = {$data['EMI_ID']} ";

        return $this->rawQuery($sql); 
        // return true;

    }

    public function paymentDetail($data)
    {
        
        $sql = "SELECT *,
                       (SELECT 
                            MAX(MONTH_NO)
                        FROM HRIS_LOAN_PAYMENT_DETAIL 
                        WHERE PAID_FLAG = 'Y' AND EMPLOYEE_ID = {$data['EMPLOYEE_ID']} AND LOAN_REQUEST_ID = {$data['LOAN_REQUEST_ID']}
                        ) AS PREVIOUS_MONTH_NO
                FROM HRIS_LOAN_PAYMENT_DETAIL
                WHERE EMPLOYEE_ID = {$data['EMPLOYEE_ID']} AND LOAN_REQUEST_ID = {$data['LOAN_REQUEST_ID']} AND
                      PAID_FLAG = 'N' AND EMI_ID = {$data['EMI_ID']}
                ORDER BY SNO ASC LIMIT 1";

        $statement = $this->adapter->query($sql);
        $result = $statement->execute();
        return ($result) ? $result->current() : false;  
        
    }

    public function insertEMIDetail($data)
    {
        $sql = "INSERT INTO HRIS_LOAN_PAYMENT_DETAIL
                (PAYMENT_ID, LOAN_REQUEST_ID, SNO, FROM_DATE, TO_DATE, AMOUNT, PAID_FLAG, MONTH_NO, INTEREST_AMOUNT, PRINCIPLE_AMOUNT, DAYS, 
                 SHEET_NO, STATUS, CREATED_DT, EMI_ID, EMPLOYEE_ID)
                VALUES 
                (
                    (SELECT MAX(PAYMENT_ID) + 1 FROM HRIS_LOAN_PAYMENT_DETAIL),
                    {$data['LOAN_REQUEST_ID']},
                    {$data['SNO']},
                    '".$data['FROM_DATE']."',
                    '".$data['TO_DATE']."',
                    {$data['AMOUNT']},
                    '".$data['PAID_FLAG']."',
                    {$data['MONTH_NO']},
                    {$data['INTEREST_AMOUNT']},
                    {$data['PRINCIPLE_AMOUNT']},
                    {$data['DAYS']},
                    {$data['SHEET_NO']},
                    'E',
                    '".$data['CREATED_DT']."',
                    {$data['EMI_ID']},
                    {$data['EMPLOYEE_ID']}
                )";

        // echo "<pre>";
        // print_r($sql);
        // die;
        return $this->rawQuery($sql);
        // return true;
        
    }

    public function fetchAllLoanWise($data)
    {
        $employeeId          = ($data['employeeId']) ? implode(',', $data['employeeId']) : '';
        $companyId           = $data['companyId'];
        $branchId            = ($data['branchId']) ? implode(',',$data['branchId']) : '';
        $departmentId        = ($data['departmentId']) ? implode(',',$data['departmentId']) : '';
        $designationId       = ($data['designationId']) ? implode(',', $data['designationId']) : '';
        $positionId          = ($data['positionId']) ? implode(',', $data['positionId']) : '';
        $serviceTypeId       = $data['serviceTypeId'];
        $serviceEventTypeId  = $data['serviceEventTypeId'];
        // $loanId              = ($data['loanId']) ? implode(',', $data['loanId']) : '';
        $loanId              = $data['loanId'];
        // $loanRequestStatusId = $data['loanRequestStatusId'];
        // $employeeTypeId      = $data['employeeTypeId'];
        $loanStatus          = $data['loanStatus'];
        // $fiscalYear          = $data['fiscalYear'];



        /** WITH LOAN **/
            $loanData = ($loanId) ? " AND LMS.LOAN_ID IN ({$loanId}) " : " ";
        /** WITH LOAN **/

        /** WITH BRANCH **/
            $branchIDData = ($branchId) ? " AND B.DEPARTMENT_ID IN ({$branchId}) " : " ";
        /** WITH BRANCH **/

        /** WITH DEPARTMENT **/
            $departmentIDData = ($departmentId) ? " AND HD.DEPARTMENT_ID IN ({$departmentId}) " : " ";
        /** WITH DEPARTMENT **/

        /** WITH DESIGNATION **/
            $designationIDData = ($designationId) ? " AND D.DESIGNATION_ID IN ({$designationId}) " : " ";
        /** WITH DESIGNATION **/

        /** WITH POSITION **/
            $positionIDData = ($positionId) ? " AND P.POSITION_ID IN ({$positionId}) " : " ";
        /** WITH POSITION **/

        /** WITH SERVICE EVENT TYPE **/
            $serviceTypeIDData = ($serviceTypeId > 0) ? " AND ST.SERVICE_TYPE_ID = {$serviceTypeId} " : " ";
        /** WITH SERVICE EVENT TYPE **/

        /** WITH SPECIFIC EMPLOYEE **/
            $employeeIDData = ($employeeId) ? " AND E.EMPLOYEE_ID IN ({$employeeId}) " : " ";
        /** WITH SPECIFIC EMPLOYEE **/

        /** WITH EMPLOYEE TYPES **/
            $employeeTypeData = ($employeeTypeId > 0) ? " AND E.EMPLOYEE_TYPE = '{$employeeTypeId}' " : " ";
        /** WITH EMPLOYEE TYPES **/



        /** LOAN STATUS **/
            $loanStatusData = ($loanStatus == 'BOTH') ? " " : (($loanStatus == 'OPEN') ? " AND ELR.LOAN_STATUS = 'OPEN' " : " AND ELR.LOAN_STATUS = 'CLOSED' ");
        /** LOAN STATUS **/


        /** FOR FISCAL YEAR  **/
        // $fiscalMonthSql = "SELECT * FROM HRIS_MONTH_CODE 
        //                    WHERE FISCAL_YEAR_ID = {$fiscalYear} 
        //                 --    WHERE FISCAL_YEAR_ID = 8 
        //                    ORDER BY FISCAL_YEAR_MONTH_NO ASC";

        // $fiscalMonthData = $this->rawQuery($fiscalMonthSql);

        // $data = '';

        // for ($i=0; $i < count($fiscalMonthData) ; $i++) {

        //     $data .= "MAX(CASE WHEN month_id = "
        //           . $fiscalMonthData[$i]['MONTH_ID'] 
        //           ." then INSTALLMENT END) AS "
        //           .strtoupper($fiscalMonthData[$i]['MONTH_EDESC'])
        //           .",";

        // }

       
        // for ($i=0; $i < count($fiscalMonthData) ; $i++) {

        //     $month_id .= $fiscalMonthData[$i]['MONTH_ID'].",";

        // }

        // $monthID = substr($month_id, 0, -1);

        $sql = "SELECT 
                    ELR.*,
                    ELR.LOAN_DATE AS LOAN_DATE_AD,
                    ELR.CREDIT_AMOUNT AS CREDIT_LOAN_AMOUNT,
                    BS_DATE(ELR.LOAN_DATE) AS LOAN_DATE_BS,
                    LMS.LOAN_NAME AS LOAN_NAME,
                    D.DEPARTMENT_NAME AS DEPARTMENT,
                    E.FULL_NAME,
                    LMS.ISSUED_BY AS LOAN_ISSUED_BY,
                    LMS.INTEREST_RATE,
                    (SELECT 
                        INSTALLMENT 
                    FROM HRIS_EMPLOYEE_EMI_DETAIL 
                    WHERE 
                        EMI_ID = (SELECT 
                                    MIN(EMI_ID) 
                                  FROM HRIS_EMPLOYEE_EMI_DETAIL 
                                  WHERE PAID_FLAG='N' AND EMPLOYEE_ID = E.EMPLOYEE_ID)
                    ) AS MONTHLY_INSTALLMENT,
                    -- (SELECT
                    --     SUM(INTEREST)
                    -- FROM HRIS_EMPLOYEE_EMI_DETAIL
                    -- WHERE 
                    --     PAID_FLAG = 'Y' AND 
                    --     EMPLOYEE_ID = E.EMPLOYEE_ID AND 
                    --     PAYMENT_MONTH IN ({$monthID})
                    -- ) AS INTEREST_RATE,
                    (SELECT
                        SUM(PRINCIPAL_REPAID)
                    FROM HRIS_EMPLOYEE_EMI_DETAIL
                    WHERE 
                        PAID_FLAG = 'Y' AND 
                        EMPLOYEE_ID = E.EMPLOYEE_ID 
                        -- AND PAYMENT_MONTH IN ({$monthID})
                    ) AS PRINCIPAL_PAID
                    
                FROM HRIS_EMPLOYEE_LOAN_REQUEST ELR
                LEFT JOIN HRIS_LOAN_MASTER_SETUP LMS ON LMS.LOAN_ID = ELR.LOAN_ID
                LEFT JOIN HRIS_EMPLOYEES E ON E.EMPLOYEE_ID = ELR.EMPLOYEE_ID
                LEFT JOIN HRIS_DEPARTMENTS D ON D.DEPARTMENT_ID = E.DEPARTMENT_ID


                WHERE 
                    ELR.LOAN_ID = {$loanId} 
                    -- AND ELR.LOAN_STATUS = 'OPEN' 
                ".
                $employeeIDData.
                $loanStatusData
                ." 

                ORDER BY
                    E.FIRST_NAME ASC";
        // return $sql;
        return $this->rawQuery($sql);

    }


    public function getLoanlistBy($issuedBy)
    {
        $sql = "SELECT * FROM HRIS_LOAN_MASTER_SETUP WHERE ISSUED_BY = '$issuedBy'";
            return $this->rawQuery($sql);
    }


    
    public function date($date)
    {
        $sql = "SELECT AD_DATE('{$date}') AS DATE_AD FROM DUMMY";
            return $this->rawQuery($sql);
    }

    public function getEmployeeId($employeeCode){

        $sql = "SELECT EMPLOYEE_ID FROM HRIS_EMPLOYEES WHERE EMPLOYEE_CODE LIKE '%{$employeeCode}%' AND LENGTH(EMPLOYEE_CODE) < 8";

        return $this->adapter->query($sql)->execute()->current()['EMPLOYEE_ID'];
     }

     public function getInstallment($employeeId, $mthId){

        $sql = "SELECT MTH_VALUE FROM HRIS_MONTHLY_VALUE_DETAIL WHERE EMPLOYEE_ID = {$employeeId} AND MTH_ID = {$mthId} AND MONTH_ID = 96";

        return $this->adapter->query($sql)->execute()->current()['MTH_VALUE'];

     }

     public function errorRevert($loanRequestId){

        $sql = "
            delete from hris_employee_emi_detail where loan_request_id = {$loanRequestId}
        ";

        $this->adapter->query($sql)->execute();

        $sql = "
            delete from hris_employee_loan_request where loan_request_id = {$loanRequestId}
        ";

        $this->adapter->query($sql)->execute();

     }

}
