<?php

namespace ManagerService\Controller;

use Application\Controller\HrisController;
use Application\Helper\EntityHelper as ApplicationHelper;
use Application\Model\Model;
use Application\Model\HrisQuery;
use Application\Helper\Helper;
use AttendanceManagement\Repository\AttendanceStatusRepository;
use Exception;
use ManagerService\Repository\UpdateProfileApproveRepository;
use Notification\Controller\HeadNotification;
use Setup\Model\HrEmployees;
use Setup\Model\Company;
use Setup\Form\HrEmployeesFormTabEight;
use Setup\Form\HrEmployeesFormTabFive;
use Setup\Form\HrEmployeesFormTabFour;
use Setup\Form\HrEmployeesFormTabNine;
use Setup\Form\HrEmployeesFormTabOne;
use Setup\Form\HrEmployeesFormTabSeven;
use Setup\Form\HrEmployeesFormTabSix;
use Setup\Form\HrEmployeesFormTabThree;
use Setup\Form\HrEmployeesFormTabTwo;
use Notification\Model\NotificationEvents;
use SelfService\Form\UpdateProfileForm;
use SelfService\Form\UpdateControlForm;
use SelfService\Model\UpdateControlModel;
use SelfService\Model\UpdateProfileModel;
use Setup\Model\EmployeeQualification;

use Setup\Repository\EmployeeRepository;
use Setup\Repository\EmployeeQualificationRepository;
use Setup\Repository\EmployeeExperienceRepository;
use Setup\Repository\EmployeeTrainingRepository;

use Zend\Authentication\Storage\StorageInterface;
use Zend\Db\Adapter\AdapterInterface;
// use Zend\Form\Form;
use Zend\Form\Element\Select;
use Zend\View\Model\JsonModel;
use Zend\Form\Annotation\AnnotationBuilder;
use Recruitment\Repository\UserApplicationRepository;


class UpdateProfileApproveController extends HrisController {

    private $formOne;
    private $formTwo;
    private $formThree;
    private $formFour;
    private $formFive;
    private $formSix;
    private $formSeven;
    private $formEight;
    private $formNine;


    private $controlForm;
    private $profileForm;

    public function __construct(AdapterInterface $adapter, StorageInterface $storage) {
        parent::__construct($adapter, $storage);
        $this->empRepository = new EmployeeRepository($adapter);
        $this->initializeRepository(UpdateProfileApproveRepository::class);
        // $this->initializeForm(UpdateProfileForm::class);
    }

    public function initializeMultipleForm() {
        $builder = new AnnotationBuilder();
        $formTabOne = new HrEmployeesFormTabOne();
        $formTabTwo = new HrEmployeesFormTabTwo();
        $formTabThree = new HrEmployeesFormTabThree();
        $formTabFour = new HrEmployeesFormTabFour();
        $formTabFive = new HrEmployeesFormTabFive();
        $formTabSix = new HrEmployeesFormTabSix();
        $formTabSeven = new HrEmployeesFormTabSeven();
        $formTabEight = new HrEmployeesFormTabEight();
        $formTabNine = new HrEmployeesFormTabNine();
        if (!$this->formOne) {
            $this->formOne = $builder->createForm($formTabOne);
            $genderId = $this->formOne->get('genderId');
            $bloodGroupId = $this->formOne->get('bloodGroupId');
            $religionId = $this->formOne->get('religionId');
            $ethnicityId = $this->formOne->get('ethnicityId');
            $addrPermZoneId = $this->formOne->get('addrPermZoneId');
            $addrTempZoneId = $this->formOne->get('addrTempZoneId');
            $companyId = $this->formOne->get('companyId');
            $countryId = $this->formOne->get('countryId');
            $addrPermProvinceId = $this->formOne->get('addrPermProvinceId');
            $addrTempProvinceId = $this->formOne->get('addrTempProvinceId');

            $genderList = ApplicationHelper::getTableKVList($this->adapter, \Setup\Model\Gender::TABLE_NAME, \Setup\Model\Gender::GENDER_ID, [\Setup\Model\Gender::GENDER_NAME], null, null, true);
            $bloodGroupList = ApplicationHelper::getTableKVList($this->adapter, 'HRIS_BLOOD_GROUPS', 'BLOOD_GROUP_ID', ['BLOOD_GROUP_CODE'], NULL, NULL, TRUE);
            $zoneList = ApplicationHelper::getTableKVList($this->adapter, \Setup\Model\Zones::TABLE_NAME, \Setup\Model\Zones::ZONE_ID, [\Setup\Model\Zones::ZONE_NAME], null, null, true);
            $religionList = ApplicationHelper::getTableKVList($this->adapter, 'HRIS_RELIGIONS', 'RELIGION_ID', ['RELIGION_NAME'], null, null, true);
            $companyList = ApplicationHelper::getTableKVListWithSortOption($this->adapter, "HRIS_COMPANY", "COMPANY_ID", ["COMPANY_NAME"], ["STATUS" => "E"], "COMPANY_NAME", "ASC", null, false, true);
            $provinceList = ApplicationHelper::getTableKVListWithSortOption($this->adapter, "HRIS_PROVINCES", "PROVINCE_ID", ["PROVINCE_NAME"], null ,"PROVINCE_ID", "ASC", "-", true, true, null);
            $ethnicityList = ApplicationHelper::getTableKVList($this->adapter, 'HRIS_ETHNICITIES', 'ETHNICITY_ID', ['ETHNICITY'], null, null, true);

            $genderId->setValueOptions($genderList);
            $bloodGroupId->setValueOptions($bloodGroupList);
            $religionId->setValueOptions($religionList);
            $ethnicityId->setValueOptions($ethnicityList);
            $addrPermZoneId->setValueOptions($zoneList);
            $addrTempZoneId->setValueOptions($zoneList);
            $companyId->setValueOptions($companyList);
            $countryId->setValueOptions($this->getCountryList());
            $addrPermProvinceId->setValueOptions($provinceList);
            $addrTempProvinceId->setValueOptions($provinceList);
        }
        if (!$this->formTwo) {
            $this->formTwo = $builder->createForm($formTabTwo);
        }
        if (!$this->formThree) {
            $this->formThree = $builder->createForm($formTabThree);
            // $idAccCode = $this->formThree->get('idAccCode');
            // $bankAccountList = $this->repository->fetchBankAccountList($this->erpCompanyCode);
            // $bankAccountKVList = $this->listValueToKV($bankAccountList, "ACC_CODE", "ACC_EDESC");
            // $idAccCode->setValueOptions($bankAccountKVList);
            
            // $empowerCompanyList = $this->repository->fetchEmpowerCompany();
            // $empowerBranchList = $this->repository->fetchEmpowerBranch($this->erpCompanyCode);
            // $empowerCompanyCodeKVList = $this->listValueToKV($empowerCompanyList, "COMPANY_CODE", "COMPANY_EDESC",true);
            // $empowerBranchKVList = $this->listValueToKV($empowerBranchList, "BRANCH_CODE", "BRANCH_EDESC",true);
            

            //  $empowerCompanyCode = $this->formThree->get('empowerCompanyCode');
            //  $empowerBranchCode = $this->formThree->get('empowerBranchCode');
            //  $empowerCompanyCode->setValueOptions($empowerCompanyCodeKVList);
            //  $empowerBranchCode->setValueOptions($empowerBranchKVList);

            //  $bankId = $this->formThree->get('bankId');
            //  $bankNameList = ApplicationHelper::getTableKVListWithSortOption($this->adapter, "HRIS_BANKS", "BANK_ID", ["BANK_NAME"], "STATUS = 'E'" ,"BANK_ID", "ASC", "-", true, true, null);
            //  $bankId->setValueOptions($bankNameList);
        }
        if (!$this->formFour) {
            $this->formFour = $builder->createForm($formTabFour);
        }
        if (!$this->formSix) {
            $this->formSix = $builder->createForm($formTabSix);
        }
        if (!$this->formSeven) {
            $this->formSeven = $builder->createForm($formTabSeven);
        }
        if (!$this->formEight) {
            $this->formEight = $builder->createForm($formTabEight);
        }
        if (!$this->formNine) {
            $this->formNine = $builder->createForm($formTabNine);
        }

        // print_r($formOne);die;
    }

    public function indexAction() {

        $request = $this->getRequest();
        $ra=0;
        if ($request->isPost()) {
            try {
                $rawList = $this->repository->getAllRequest();
                return new JsonModel(['success' => true, 'data' => $rawList, 'error' => '']);
            } catch (Exception $e) {
                return new JsonModel(['success' => false, 'data' => [], 'error' => $e->getMessage()]);
            }
        }
        
        return Helper::addFlashMessagesToArray($this, [
            'test' => $ra
        ]);
    }


    public  function initializeBasicForm(){
        $builder = new AnnotationBuilder();
        $formTabOne = new HrEmployeesFormTabOne();
        $formTabTwo = new HrEmployeesFormTabTwo();
        if (!$this->formOne) {
            $this->formOne = $builder->createForm($formTabOne);
        }
        if (!$this->formTwo) {
            $this->formTwo = $builder->createForm($formTabTwo);
        }
    }

    public  function initializeBasicForm1(){
        $builder = new AnnotationBuilder();
        $profileForm1 = new UpdateControlForm();
        if (!$this->controlForm) {
            $this->controlForm = $builder->createForm($profileForm1);
        }

        // print_r($profileForm);die;
    }

    public  function initializeBasicForm2(){
        $builder = new AnnotationBuilder();
        $profileForm1 = new UpdateProfileForm();
        if (!$this->profileForm) {
            $this->profileForm = $builder->createForm($profileForm1);
        }

        // print_r($profileForm);die;
    }

    public function getCountryList() {
        if (!isset($this->countryList)) {
            $this->countryList = ApplicationHelper::getTableKVList($this->adapter, 'HRIS_COUNTRIES', 'COUNTRY_ID', ['COUNTRY_NAME'], null, null, true);
        }
        return $this->countryList;
    }
    
    private function makeDecisionApprovedReject($id, $updateId, $approve, $remarks = null,$tableName) {
        $notificationEvent = null;
        $message = null;
        $model = new UpdateControlModel();
        $this->initializeBasicForm2();
        $model->updateId = $updateId;
        $model->approvedBy=$this->employeeId;
        $model->approvedDate=date('Y-m-d');
        $model->approvedRemarks=$remarks;

        if($approve=='Approve'){
            $model->updateStatus='AP';
        }
        else{
            $model->updateStatus='C';
        }
        // print_r($model);die;
        // //to update update_status in update_controller
        $this->repository->edit($model, $updateId);

        switch($tableName){
            case "HRIS_UPDATE_PROFILE":
                $employeeData1 =  $this->repository->fetchById1($id,$updateId)[0];
                $this->repository->updateData($employeeData1,$id);
                return $this->redirect()->toRoute('updateprofileapprove', ['action' => 'index']);

                break;

            case 'HRIS_EMPLOYEE_QUALIFICATIONS_UPDATE':
                    $this->repository->softDelete($id,$tableName);
                    $empQualificationDtl = $this->repository->getByEmpIdQualification($id,$updateId);
                    $empQualificationModel = new EmployeeQualification();
                    foreach ($empQualificationDtl as $qualificationDtl){
                        $academicDegreeId = $qualificationDtl['ACADEMIC_DEGREE_ID'];
                        $academicUniversityId = $qualificationDtl['ACADEMIC_UNIVERSITY_ID'];
                        $academicProgramId = $qualificationDtl['ACADEMIC_PROGRAM_ID'];
                        $academicCourseId = $qualificationDtl['ACADEMIC_COURSE_ID'];
                        $rankType = $qualificationDtl['RANK_TYPE'];
                        $rankValue = $qualificationDtl['RANK_VALUE'];
                        $passedYr = $qualificationDtl['PASSED_YR'];
                        $employeeId = $qualificationDtl['EMPLOYEE_ID'];
    
    
    
                        $empQualificationModel->employeeId = $employeeId;
                        $empQualificationModel->academicDegreeId = $academicDegreeId;
                        $empQualificationModel->academicUniversityId = $academicUniversityId;
                        $empQualificationModel->academicProgramId = $academicProgramId;
                        $empQualificationModel->academicCourseId = $academicCourseId;
                        $empQualificationModel->rankType = $rankType;
                        $empQualificationModel->rankValue = $rankValue;
                        $empQualificationModel->passedYr = $passedYr;
                        $empQualificationModel->createdDt = Helper::getcurrentExpressionDate();
                        $empQualificationModel->status = 'E';
    
                        $empQualificationModel->id = Helper::getMaxId($this->adapter, EmployeeQualification::TABLE_NAME, EmployeeQualification::ID) + 1;
                        // echo "<pre>";
                        // print_r($empQualificationModel);die;
                        $this->repository->addQualification($empQualificationModel,$tableName);
                    }
        return $this->redirect()->toRoute('updateprofileapprove', ['action' => 'index']);
                    
                    break;
                CASE 'HRIS_EMPLOYEE_RELATION_UPDATE':
                    
                
        }


    }
    

        public function viewpracAction() {
            $id = (int) $this->params()->fromRoute('id');
            $updateId =(int) $this->params()->fromRoute('role');

            // if (0 === $id) {
            //     return $this->redirect()->toRoute('employee', ['action' => 'index']);
            // }

            $this->initializeMultipleForm();

            // controlform initialization
            $this->initializeBasicForm1();
                        
            $test1=$this->repository->wTableUp($updateId);
            $test=$test1[0];


            if($test['IS_PERSONAL_INFORMATION']==1){
                $a= new UpdateProfileModel();
                $data = array();
                // to get the id from model
                // original data
                $employeeData = $this->repository->getById($id);
                // $employeeDataOriginal=$employeeData;
                $employeeDataOriginal=$employeeData[0];

                //modified data
                $employeeData1 =  $this->repository->fetchById($id,$updateId);
                $employeeDataMod=$employeeData1[0];

                foreach ($employeeDataMod as $key => $value) {
                    if($value != $employeeDataOriginal[$key]){
                        if (stripos($key, "_ID") !== false) {
                            $parts = explode("_ID", $key);
                            $key_o=$parts[0].'_NAME';
                        }
                        else{
                            $key_o=$key;
                        }
                        $data[$key]= $employeeDataOriginal[$key_o]?$employeeDataOriginal[$key_o]:'NO DATA';
                    }
                }


                // echo '<pre>';
                // print_r($employeeDataMod);
                // print_r('###############################');
                // print_r($employeeDataOriginal);
                // print_r('###############################');
                // print_r($data);die;

                $a->exchangeArrayFromDB($data);
                // this is on the assumption that id of each element in form is mapped according to the model
                unset($a->mappings);
                unset($a->updateId);

                // echo '<pre>';
                // print_r($a);die;
                foreach($a as $key => $value){
                    if($value!=null || $value!=''){
                        $adata[$key]=$value;
                    }
                }

                // print_r($adata);die;

                $status=$employeeDataMod['UPDATE_STATUS'];
                $tableName="HRIS_UPDATE_PROFILE";
                // print_r($employeeData['UPDATE_STATUS']);die;
            }
            elseif($test['IS_QUALIFICATION']==1){
                $empQualificationDtl = $this->repository->getByEmpIdQualification($id,$updateId);
                $role=$empQualificationDtl[0]['ROLE'];
                $status=$empQualificationDtl[0]['UPDATE_STATUS'];
                $tableName="HRIS_EMPLOYEE_QUALIFICATIONS_UPDATE";
            }
            elseif($test['IS_EXPERIENCE']==1){
                
                $empExperienceList = $this->repository->getByEmpIdExperience($id,$updateId);
                // print_r($empExperienceList);die;
                $role=$empExperienceList[0]['ROLE'];
                $status=$empExperienceList[0]['UPDATE_STATUS'];
                $tableName="HRIS_EMPLOYEE_EXPERIENCES_UPDATE";
            }
            elseif($test['IS_TRAINING']==1){

            }

            // print_r($id);die;

            //original Data ##############################################################
            $empQualificationRepo = new EmployeeQualificationRepository($this->adapter);
            $empExperienceRepo = new EmployeeExperienceRepository($this->adapter);
            $empTrainingRepo = new EmployeeTrainingRepository($this->adapter);

            $empQualificationDtlOriginal = $empQualificationRepo->getByEmpId($id);
            $empExperienceListOriginal = $empExperienceRepo->getByEmpId($id);
            $empTrainingListOriginal = $empTrainingRepo->getByEmpId($id);

            //original Data ENDS HERE ##############################################################

                            //   print_r($authRecommender);die;
                            $request = $this->getRequest();
                            if ($request->isPost()) {
                                $postedData = (array) $request->getPost();

                                // print_r($postedData);
                                // print_r('-----------');
                                // print_r($id);
                                // print_r('-----------');

                                // print_r($updateId);
                                // print_r('-----------');
                                // print_r($tableName);

                                // die;
                                $action = $postedData['submit'];
                                // print_r($action);die;
                                $this->makeDecisionApprovedReject($id, $updateId, $action, $postedData,$tableName);
                                // return $this->redirect()->toRoute("updateprofileapprove");
                            }
                
                
                // $client_name = $this->repository->getClientDetail()['CLIENT'];
                return Helper::addFlashMessagesToArray($this, [
                        'formOne' => $this->formOne,
                        'formOne1' => $this->controlForm,
                        'formTwo' => $this->formTwo,
                        'formThree' => $this->formThree,
                        'formFour' => $this->formFour,
                        'formSix' => $this->formSix,
                        "formSeven" => $this->formSeven,
                        'formEight' => $this->formEight,
                        'setup' => new Company(),
                        "id" => $id,
                        "updateId"=>$updateId,
                        "role"=>$role,
                        "status1"=>$status,
                        'profilePictureId' => $profilePictureId,
                        'employeeDataOriginal' => $employeeDataOriginal,
                        'employeeDataMod' => $employeeDataMod,
                        'filePath' => $filePath,
                        'empQualificationList' => $empQualificationDtl,
                        'empQualificationListOriginal' =>$empQualificationDtlOriginal,
                        'empExperienceList' => $empExperienceList,
                        'empExperienceListOriginal'=>$empExperienceListOriginal,
                        'empTrainingList' => $empTrainingList,
                        'empTrainingListOriginal' => $empTrainingListOriginal,
                        'jobHistoryList' => $jobHistoryList,
                        "employeeFile" => $employeeFile,
                        "assetDetails" => $assetDetails,
                        "relationDetails" => $relationDetails,
                        'acl' => $this->acl,
                        'clientName' => $client_name,
                        'test' => $test,
                        'adata'=>$adata
                    ]);
        }   

        public function viewAction() {
            $id = (int) $this->params()->fromRoute('id');
            $updateId =(int) $this->params()->fromRoute('role');

            // if (0 === $id) {
            //     return $this->redirect()->toRoute('employee', ['action' => 'index']);
            // }

            $test1=$this->repository->wTableUp($updateId);
            $test=$test1[0];


            // echo "<pre>";
            // print_r($employeeDataMod);
            // echo "<br><br><br><br><br><br><br><br>";

            $employeeData = (array) $this->empRepository->getById($id);

            // print_r($test);die;

            $this->initializeMultipleForm();
            $empQualificationRepo = new EmployeeQualificationRepository($this->adapter);
            $empExperienceRepo = new EmployeeExperienceRepository($this->adapter);
            $empTrainingRepo = new EmployeeTrainingRepository($this->adapter);
    
            $employeeData = (array) $this->empRepository->getById($id);
            // print_r($employeeData);die;
            // $profilePictureId = $employeeData[HrEmployees::PROFILE_PICTURE_ID];
            // $filePathArray = ApplicationHelper::getTableKVList($this->adapter, EmployeeFileModel::TABLE_NAME, null, [EmployeeFileModel::FILE_PATH], [EmployeeFileModel::FILE_CODE => $profilePictureId], null);
            // $filePath = empty($filePathArray) ? $this->config->getApplicationConfig()['default-profile-picture'] : $filePathArray[0];
    
            $perVdcMunicipalityDtl = $this->empRepository->getVdcMunicipalityDtl($employeeData[HrEmployees::ADDR_PERM_VDC_MUNICIPALITY_ID]);
            $perDistrictDtl = $this->empRepository->getDistrictDtl($employeeData[HrEmployees::ADDR_PERM_DISTRICT_ID]);
            $perZoneDtl = $this->empRepository->getZoneDtl($employeeData[HrEmployees::ADDR_PERM_ZONE_ID]);
            $perProvinceDtl = $this->empRepository->getProvinceDtl($id)['PERM_PROVINCE'];

            
            $tempVdcMunicipalityDtl = $this->empRepository->getVdcMunicipalityDtl($employeeData[HrEmployees::ADDR_TEMP_VDC_MUNICIPALITY_ID]);
            $tempDistrictDtl = $this->empRepository->getDistrictDtl($employeeData[HrEmployees::ADDR_TEMP_DISTRICT_ID]);
            $tempZoneDtl = $this->empRepository->getZoneDtl($employeeData[HrEmployees::ADDR_TEMP_ZONE_ID]);
            $tempProvinceDtl = $this->empRepository->getProvinceDtl($id)['TEMP_PROVINCE'];
            
            $empQualificationDtl = $empQualificationRepo->getByEmpId($id);
            $empExperienceList = $empExperienceRepo->getByEmpId($id);
            $empTrainingList = $empTrainingRepo->getByEmpId($id);
    
            // $jobHistoryRepo = new JobHistoryRepository($this->adapter);
            // $jobHistoryList = $jobHistoryRepo->filter(null, null, $id);
            
            // $employeeFileRepo = new EmployeeFile($this->adapter);
            // $employeeFile = $employeeFileRepo->fetchByEmpId($id);
    
            // $assetRepo = new IssueRepository($this->adapter);
            // $assetDetails = $assetRepo->fetchAssetByEmployee($id);
            
            // $relationRepo = new \Setup\Repository\EmployeeRelationRepo($this->adapter);
            // $relationDetails = $relationRepo->getByEmpId($id);
    
            // $client_name = $this->repository->getClientDetail()['CLIENT'];
            return Helper::addFlashMessagesToArray($this, [
                    'formOne' => $this->formOne,
                    'formTwo' => $this->formTwo,
                    'formThree' => $this->formThree,
                    'formFour' => $this->formFour,
                    'formSix' => $this->formSix,
                    "formSeven" => $this->formSeven,
                    'formEight' => $this->formEight,
                    "id" => $id,
                    "updateId"=>$updateId,
                    'profilePictureId' => $profilePictureId,
                    'employeeData' => $employeeData,
                    'filePath' => $filePath,
                    'perDistrictName' => $perDistrictDtl['DISTRICT_NAME'],
                    'perZoneName' => $perZoneDtl['ZONE_NAME'],
                    'tempDistrictName' => $tempDistrictDtl['DISTRICT_NAME'],
                    'tempZoneName' => $tempZoneDtl['ZONE_NAME'],
                    'empQualificationList' => $empQualificationDtl,
                    'empExperienceList' => $empExperienceList,
                    'empTrainingList' => $empTrainingList,
                    'jobHistoryList' => $jobHistoryList,
                    "employeeFile" => $employeeFile,
                    "assetDetails" => $assetDetails,
                    "relationDetails" => $relationDetails,
                    'acl' => $this->acl,
                    'tempProvinceName' => $tempProvinceDtl,
                    'perProvinceName' => $perProvinceDtl,
                    'clientName' => $client_name,
                    'test' => $test

            ]);
        }



        public function compareAction(){
            $id = (int) $this->params()->fromRoute('id');
            $updateId =(int) $this->params()->fromRoute('role');

            //actual 
            $employeeData = (array) $this->empRepository->getById($id);

            //modified
            $employeeData1 =  $this->repository->fetchById($id,$updateId);
            $employeeDatamod=$employeeData1[0];


            
        }
}