<?php

namespace ManagerService\Repository;

use Application\Helper\EntityHelper;
use Application\Helper\Helper;

use Application\Model\Model;
use Application\Repository\HrisRepository;
use SelfService\Model\UpdateProfileModel;
use SelfService\Model\UpdateEmployeeQualification;
use SelfService\Model\UpdateEmployeeExperience;
use SelfService\Model\UpdateControlModel;
use Traversable;
use Zend\Db\Adapter\AdapterInterface;
use Zend\Db\Sql\Expression;
use Zend\Db\Sql\Sql;
use Setup\Model\HrEmployees;
use Zend\Db\TableGateway\TableGateway;
use Setup\Model\AcademicDegree;
use Setup\Model\AcademicUniversity;
use Setup\Model\AcademicCourse;
use Setup\Model\AcademicProgram;



class UpdateProfileApproveRepository extends HrisRepository {

     protected $adapter;
     protected $updateGateway;
     protected $employeeGateway;
     protected $qualificationGateway;
     protected $experienceGateway;
     protected $trainingGateway;


    public function __construct(AdapterInterface $adapter, $tableName = null) {
     //    if ($tableName == null) {
     //        $tableName = UpdateProfileModel::TABLE_NAME;
     //    }
        parent::__construct($adapter, $tableName);
        $this->adapter = $adapter;
        $this->updateGateway = new TableGateway('HRIS_UPDATE_CONTROLLER', $adapter);
        $this->employeeGateway = new TableGateway('HRIS_EMPLOYEES', $adapter);
        $this->qualificationGateway = new TableGateway('HRIS_EMPLOYEE_QUALIFICATIONS', $adapter);
        $this->experienceGateway = new TableGateway('HRIS_EMPLOYEE_EXPERIENCES', $adapter);
        $this->trainingGateway = new TableGateway('HRIS_EMPLOYEE_TRAININGS', $adapter);
    }

    public function getAllRequest(){
        $sql="select
   e.full_name as full_name,
   HUc.APPROVED_BY AS APPROVED_BY,
   HUc.APPROVED_REMARKS AS APPROVED_REMARKS,
   HUc.UPDATE_ID AS UPDATE_ID,
   HUc.EMPLOYEE_ID AS EMPLOYEE_ID,
   E.EMPLOYEE_CODE AS EMPLOYEE_CODE,
   case when HUc.UPDATE_STATUS='RQ' then 'Pending'
   when HUc.UPDATE_STATUS='AP' then 'Approved' 
   when UPDATE_STATUS='R' then 'Rejected'
   end as UPDATE_STATUS,
   case when huc.is_personal_information=1 
then 'Personal Information' when huc.is_qualification=1 
then 'Qualification' when huc.is_experience=1 
then 'Experience' 
end as MOD 
from hris_update_controller HUC 
left join hris_employees E on E.employee_id=HUc.employee_id 
left join hris_employees E1 on E1.employee_id=HUc.approved_by 
where huc.update_status='RQ'
               ";
               return $this->rawQuery($sql);

               }

     public function getAllRequestQualification($ID){
          $sql="SELECT
                    INITCAP(TO_CHAR(HUP.APPROVED_DATE,
                    'DD-MON-YYYY')) AS APPROVED_DATE,
                    HUP.APPROVED_BY AS APPROVED_BY,
                    HUP.APPROVED_REMARKS AS APPROVED_REMARKS,
                    HUP.UPDATE_ID AS UPDATE_ID,
                    HUP.EMPLOYEE_ID AS EMPLOYEE_ID,
                    E.EMPLOYEE_CODE AS EMPLOYEE_CODE,
                    HUP.UPDATE_ID AS UPDATE_ID,
                    HUP.UPDATE_STATUS AS UPDATE_STATUS,
                    CASE WHEN ALR.R_A_ID IS NOT NULL 
               THEN ALR.R_A_ID 
               ELSE RA.RECOMMEND_BY 
               END AS RECOMMENDER_ID,
                    CASE WHEN ALA.R_A_ID IS NOT NULL 
               THEN ALA.R_A_ID 
               ELSE RA.RECOMMEND_BY 
               END AS APPROVER_ID,
                    CASE WHEN ALR_E.FULL_NAME IS NOT NULL 
               THEN ALR_E.FULL_NAME 
               ELSE INITCAP(RECM.FULL_NAME) 
               END AS RECOMMENDER_NAME,
                    CASE WHEN ALA_E.FULL_NAME IS NOT NULL 
               THEN ALA_E.FULL_NAME 
               ELSE INITCAP(APRV.FULL_NAME) 
               END AS APPROVER_NAME,
                    REC_APP_ROLE({$ID},
               CASE WHEN ALR.R_A_ID IS NOT NULL 
               AND ALR.R_A_ID = {$ID} 
               THEN ALR.R_A_ID 
               ELSE RA.RECOMMEND_BY 
               END,
                    CASE WHEN ALA.R_A_ID IS NOT NULL 
               AND ALA.R_A_ID = {$ID} 
               THEN ALA.R_A_ID 
               ELSE RA.APPROVED_BY 
               END) AS ROLE,
                    REC_APP_ROLE_NAME({$ID},
               CASE WHEN ALR.R_A_ID IS NOT NULL 
               THEN ALR.R_A_ID 
               ELSE RA.RECOMMEND_BY 
               END,
                    CASE WHEN ALA.R_A_ID IS NOT NULL 
               THEN ALA.R_A_ID 
               ELSE RA.APPROVED_BY 
               END) AS YOUR_ROLE,
                    CASE WHEN ( ALR.R_A_ID IS NOT NULL 
               OR ALA.R_A_ID IS NOT NULL ) 
               THEN 'SECONDARY' 
               ELSE 'PRIMARY' 
               END AS PRI_SEC,
                    INITCAP(E.FULL_NAME) AS FULL_NAME,
                    INITCAP(E2.FULL_NAME) AS RECOMMENDED_BY_NAME,
                    INITCAP(E3.FULL_NAME) AS APPROVED_BY_NAME 
               FROM HRIS_UPDATE_PROFILE HUP 
               LEFT JOIN HRIS_EMPLOYEES E ON E.EMPLOYEE_ID=HUP.EMPLOYEE_ID 
               LEFT JOIN HRIS_EMPLOYEES E2 ON E2.EMPLOYEE_ID=HUP.RECOMMENDED_BY 
               LEFT JOIN HRIS_EMPLOYEES E3 ON E3.EMPLOYEE_ID=HUP.APPROVED_BY 
               LEFT JOIN HRIS_RECOMMENDER_APPROVER RA ON RA.EMPLOYEE_ID=HUP.EMPLOYEE_ID 
               LEFT JOIN HRIS_EMPLOYEES RECM ON RECM.EMPLOYEE_ID=RA.RECOMMEND_BY 
               LEFT JOIN HRIS_EMPLOYEES APRV ON APRV.EMPLOYEE_ID=RA.APPROVED_BY 
               LEFT JOIN HRIS_ALTERNATE_R_A ALR ON ALR.R_A_FLAG='R' 
               AND ALR.EMPLOYEE_ID=HUP.EMPLOYEE_ID 
               AND ALR.R_A_ID= {$ID} 
               LEFT JOIN HRIS_ALTERNATE_R_A ALA ON ALA.R_A_FLAG='A' 
               AND ALA.EMPLOYEE_ID=HUP.EMPLOYEE_ID 
               AND ALR.R_A_ID= {$ID} 
               LEFT JOIN HRIS_EMPLOYEES ALR_E ON ALR.R_A_ID=ALR_E.EMPLOYEE_ID 
               LEFT JOIN HRIS_EMPLOYEES ALA_E ON ALA.R_A_ID=ALA_E.EMPLOYEE_ID 
               WHERE (((RA.RECOMMEND_BY= {$ID} 
                         OR ALR.R_A_ID= {$ID}) 
                    AND HUP.UPDATE_STATUS='RQ') 
               OR ((RA.APPROVED_BY= {$ID} 
                         OR ALA.R_A_ID= {$ID}) 
                    AND HUP.UPDATE_STATUS='RC') ) 
               AND E.STATUS='E' 
               AND E.RETIRED_FLAG='N' 
               ORDER BY E.FIRST_NAME ASC  
               ";

     // print_r($sql);die;

     return $this->rawQuery($sql);

 }


    public function getById($employeeId){
        $sql="SELECT
      E.*,
      (B.BRANCH_NAME) AS BRANCH_NAME,
      (C.COMPANY_NAME) AS COMPANY_NAME,
      INITCAP(G.GENDER_NAME) AS GENDER_NAME,
      BG.BLOOD_GROUP_CODE AS BLOOD_GROUP_CODE,
      INITCAP(RG.RELIGION_NAME) AS RELIGION_NAME,
      INITCAP(ETH.ETHNICITY) AS ETHNICITY_NAME,
      INITCAP(CN.COUNTRY_NAME) AS COUNTRY_NAME,
                     INITCAP(VM.VDC_MUNICIPALITY_NAME) AS ADDR_PERM_VDC_MUNICIPALITY_NAME,
                     VM1.VDC_MUNICIPALITY_NAME AS ADDR_TEMP_VDC_MUNICIPALITY_NAME,
                     dis1.district_name as addr_perm_district_name,
                     dis2.district_name as addr_temp_district_name,
                     z1.zone_name as addr_perm_zone_name,
                     z2.zone_name as addr_temp_zone_name,
                     pro.province_name as ADDR_PERM_PROVINCE_NAME,
                     pro1.province_name as ADDR_TEMP_PROVINCE_NAME,
      (D1.DEPARTMENT_NAME) AS DEPARTMENT_NAME,
      (DES1.DESIGNATION_TITLE) AS DESIGNATION_TITLE,
      (P1.POSITION_NAME) AS POSITION_NAME,
      P1.LEVEL_NO AS LEVEL_NO,
      INITCAP(S1.SERVICE_TYPE_NAME) AS SERVICE_TYPE_NAME,
      INITCAP(SE1.SERVICE_EVENT_TYPE_NAME) AS SERVICE_EVENT_TYPE_NAME
FROM HRIS_EMPLOYEES E 
LEFT JOIN HRIS_BRANCHES B ON E.BRANCH_ID=B.BRANCH_ID 
LEFT JOIN HRIS_COMPANY C ON E.COMPANY_ID=C.COMPANY_ID 
LEFT JOIN HRIS_GENDERS G ON E.GENDER_ID=G.GENDER_ID 
LEFT JOIN HRIS_BLOOD_GROUPS BG ON E.BLOOD_GROUP_ID=BG.BLOOD_GROUP_ID 
LEFT JOIN HRIS_RELIGIONS RG ON E.RELIGION_ID=RG.RELIGION_ID 
LEFT JOIN HRIS_ETHNICITIES ETH ON E.ETHNICITY_ID=ETH.ETHNICITY_ID 
LEFT JOIN HRIS_COUNTRIES CN ON E.COUNTRY_ID=CN.COUNTRY_ID 
LEFT JOIN HRIS_VDC_MUNICIPALITIES VM ON E.ADDR_PERM_VDC_MUNICIPALITY_ID=VM.VDC_MUNICIPALITY_ID 
LEFT JOIN HRIS_VDC_MUNICIPALITIES VM1 ON E.ADDR_TEMP_VDC_MUNICIPALITY_ID=VM1.VDC_MUNICIPALITY_ID 
               left join hris_districts dis1 on e.addr_perm_district_id=dis1.district_id
               left join hris_districts dis2 on e.addr_temp_district_id=dis2.district_id
               left join hris_zones Z1 on e.addr_perm_zone_id=z1.zone_id
               left join hris_zones Z2 on e.addr_temp_zone_id=z2.zone_id
               left join hris_provinces pro on e.ADDR_PERM_PROVINCE_ID=pro.province_id 
               left join hris_provinces pro1 on e.ADDR_TEMP_PROVINCE_ID=pro1.province_id
LEFT JOIN HRIS_DEPARTMENTS D1 ON E.DEPARTMENT_ID=D1.DEPARTMENT_ID 
LEFT JOIN HRIS_DESIGNATIONS DES1 ON E.DESIGNATION_ID=DES1.DESIGNATION_ID 
LEFT JOIN HRIS_POSITIONS P1 ON E.POSITION_ID=P1.POSITION_ID 
LEFT JOIN HRIS_SERVICE_TYPES S1 ON E.SERVICE_TYPE_ID=S1.SERVICE_TYPE_ID 
LEFT JOIN HRIS_SERVICE_EVENT_TYPES SE1 ON E.SERVICE_EVENT_TYPE_ID=SE1.SERVICE_EVENT_TYPE_ID
WHERE E.EMPLOYEE_ID = {$employeeId}";

// print_r($sql);die;



        // print_r($this->rawQuery($sql));die;
        // var_dump(Helper::extractDbData($this->rawQuery($sql), false));die;

        return $this->rawQuery($sql);

    }

    public function fetchById($id,$updateId) {

        $sql=" SELECT
                     ot.*,
                     INITCAP(E.FULL_NAME) AS FULL_NAME,
                     (C.COMPANY_NAME) AS COMPANY_NAME,
                     INITCAP(G.GENDER_NAME) AS GENDER_NAME,
                     BG.BLOOD_GROUP_CODE AS BLOOD_GROUP_CODE,
                     INITCAP(RG.RELIGION_NAME) AS RELIGION_NAME,
                     INITCAP(ETH.ETHNICITY) AS ETHNICITY_NAME,
                     INITCAP(CN.COUNTRY_NAME) AS COUNTRY_NAME,
                     INITCAP(VM.VDC_MUNICIPALITY_NAME) AS ADDR_PERM_VDC_MUNICIPALITY_NAME,
                     VM1.VDC_MUNICIPALITY_NAME AS ADDR_TEMP_VDC_MUNICIPALITY_NAME,
                     dis1.district_name as addr_perm_district_name,
                     dis2.district_name as addr_temp_district_name,
                     z1.zone_name as addr_perm_zone_name,
                     z2.zone_name as addr_temp_zone_name,
                     pro.province_name as ADDR_PERM_PROVINCE_NAME,
                     pro1.province_name as ADDR_TEMP_PROVINCE_NAME,
                     (D1.DEPARTMENT_NAME) AS DEPARTMENT_NAME,
                     (DES1.DESIGNATION_TITLE) AS DESIGNATION_TITLE,
                     (P1.POSITION_NAME) AS POSITION_NAME,
                     P1.LEVEL_NO AS LEVEL_NO,
                     huc.* 
               FROM hris_update_profile OT 
               left join hris_update_controller huc on ot.update_id=huc.update_id 
               LEFT JOIN HRIS_EMPLOYEES E ON E.EMPLOYEE_ID=OT.EMPLOYEE_ID 
               LEFT JOIN HRIS_COMPANY C ON ot.COMPANY_ID=C.COMPANY_ID 
               LEFT JOIN HRIS_GENDERS G ON ot.GENDER_ID=G.GENDER_ID 
               LEFT JOIN HRIS_BLOOD_GROUPS BG ON ot.BLOOD_GROUP_ID=BG.BLOOD_GROUP_ID 
               LEFT JOIN HRIS_RELIGIONS RG ON ot.RELIGION_ID=RG.RELIGION_ID 
               LEFT JOIN HRIS_ETHNICITIES ETH ON ot.ETHNICITY_ID=ETH.ETHNICITY_ID 
               LEFT JOIN HRIS_COUNTRIES CN ON ot.COUNTRY_ID=CN.COUNTRY_ID 
               LEFT JOIN HRIS_VDC_MUNICIPALITIES VM ON ot.ADDR_PERM_VDC_MUNICIPALITY_ID=VM.VDC_MUNICIPALITY_ID 
               LEFT JOIN HRIS_VDC_MUNICIPALITIES VM1 ON ot.ADDR_TEMP_VDC_MUNICIPALITY_ID=VM1.VDC_MUNICIPALITY_ID 
               left join hris_districts dis1 on ot.addr_perm_district_id=dis1.district_id
               left join hris_districts dis2 on ot.addr_temp_district_id=dis2.district_id
               left join hris_zones Z1 on ot.addr_perm_zone_id=z1.zone_id
               left join hris_zones Z2 on ot.addr_temp_zone_id=z2.zone_id
               left join hris_provinces pro on ot.ADDR_PERM_PROVINCE_ID=pro.province_id 
               left join hris_provinces pro1 on ot.ADDR_TEMP_PROVINCE_ID=pro1.province_id 
               LEFT JOIN HRIS_DEPARTMENTS D1 ON e.DEPARTMENT_ID=D1.DEPARTMENT_ID 
               LEFT JOIN HRIS_DESIGNATIONS DES1 ON E.DESIGNATION_ID=DES1.DESIGNATION_ID 
               LEFT JOIN HRIS_POSITIONS P1 ON E.POSITION_ID=P1.POSITION_ID 
               WHERE OT.UPDATE_ID = {$updateId} 
       ";
    return $this->rawQuery($sql);
    }

    //FOR INSERT ONLY
    public function fetchById1($id,$updateId) {

          $sql="   SELECT
                    *
                    FROM hris_update_profile
                    WHERE UPDATE_ID = {$updateId} 
          ";
          //     print_r($sql);die;
          return $this->rawQuery($sql);
     }

     public function edit(Model $model, $updateId) {
          // echo '<pre>';
          $m=$model->getArrayCopyForDB();
          $this->updateGateway->update($m, ['UPDATE_ID' => $updateId]);
     }

     public function wTableUp($updateId){
          $sql="select * from hris_update_controller where update_id={$updateId}";
          return $this->rawQuery($sql);
     }


public function getByEmpIdQualification($employeeId,$updateId){
     $sql = "SELECT
     EQ.*,
     AD.ACADEMIC_DEGREE_NAME AS ACADEMIC_DEGREE_NAME,
     AC.ACADEMIC_COURSE_NAME AS ACADEMIC_COURSE_NAME,
     AP.ACADEMIC_PROGRAM_NAME AS ACADEMIC_PROGRAM_NAME,
     AU.ACADEMIC_UNIVERSITY_NAME AS ACADEMIC_UNIVERSITY_NAME,
    REC_APP_ROLE($employeeId,RA.RECOMMEND_BY,RA.APPROVED_BY)      AS ROLE,
    REC_APP_ROLE_NAME($employeeId,RA.RECOMMEND_BY,RA.APPROVED_BY) AS YOUR_ROLE,
    huc.*
FROM HRIS_EMPLOYEE_QUALIFICATIONS_UPDATE EQ 
LEFT JOIN HRIS_ACADEMIC_DEGREES AD ON EQ.ACADEMIC_DEGREE_ID=AD.ACADEMIC_DEGREE_ID 
LEFT JOIN HRIS_ACADEMIC_COURSES AC ON EQ.ACADEMIC_COURSE_ID=AC.ACADEMIC_COURSE_ID 
LEFT JOIN HRIS_ACADEMIC_PROGRAMS AP ON EQ.ACADEMIC_PROGRAM_ID=AP.ACADEMIC_PROGRAM_ID 
LEFT JOIN HRIS_ACADEMIC_UNIVERSITY AU ON EQ.ACADEMIC_UNIVERSITY_ID=AU.ACADEMIC_UNIVERSITY_ID 
LEFT JOIN HRIS_RECOMMENDER_APPROVER RA ON RA.EMPLOYEE_ID=EQ.EMPLOYEE_ID 
LEFT JOIN HRIS_UPDATE_CONTROLLER HUC ON EQ.UPDATE_ID=HUC.UPDATE_ID
WHERE EQ.EMPLOYEE_ID=$employeeId 
AND EQ.STATUS='E' 
AND EQ.UPDATE_ID=$updateId";
     $result=$this->rawQuery($sql);
     // print_r($result[0]);die;
     return $result;
 }


     public function getByEmpIdExperience($employeeId,$updateId){
          $sql = "SELECT
          INITCAP(TO_CHAR(EE.FROM_DATE,
          'DD-MON-YYYY')) AS FROM_DATE,
          INITCAP(TO_CHAR(EE.TO_DATE,
          'DD-MON-YYYY')) AS TO_DATE,
          EE.ID AS ID,
          EE.ORGANIZATION_TYPE AS ORGANIZATION_TYPE,
          EE.ORGANIZATION_NAME AS ORGANIZATION_NAME,
          EE.ADDRESS AS ADDRESS,
          EE.POSITION AS POSITION,
          REC_APP_ROLE($employeeId,RA.RECOMMEND_BY,RA.APPROVED_BY) AS ROLE,
          REC_APP_ROLE_NAME($employeeId,RA.RECOMMEND_BY,RA.APPROVED_BY) AS YOUR_ROLE,
          huc.*
    FROM HRIS_EMPLOYEE_EXPERIENCES_UPDATE EE 
    LEFT JOIN HRIS_RECOMMENDER_APPROVER RA ON RA.EMPLOYEE_ID=EE.EMPLOYEE_ID 
    left join hris_update_controller huc on huc.update_id=EE.update_id
    WHERE EE.EMPLOYEE_ID=$employeeId 
    AND EE.STATUS='E' 
    AND EE.UPDATE_ID=$updateId 
    ORDER BY EE.ID ASC
    ";
     $result=$this->rawQuery($sql);
     // print_r($result);die;
          return $result;
     }

     public function updateData($data,$id){
          // $tempArray = $model->getArrayCopyForDB();
          unset($data['UPDATE_ID']);
          unset($data['EMPLOYEE_CODE']);
          unset($data['COMPANY_ID']);

          // echo "<pre>";
          // print_r($data);die;
          $this->employeeGateway->update($data, ['EMPLOYEE_ID' => $id]);
     }

     public function softDelete($id,$tableName){
          if($tableName=="HRIS_EMPLOYEE_QUALIFICATIONS_UPDATE"){
               $tblName="HRIS_EMPLOYEE_QUALIFICATIONS";
          }
          $sql="update {$tblName} set status='D' where employee_id={$id}";
          $this->rawQuery($sql);

     }

     public function addQualification(Model $model) {
          $employeeData = $model->getArrayCopyForDB();
          // print_r($employeeData);die;
          $this->qualificationGateway->insert($employeeData);
     }
     
     public function addExperience(Model $model) {
          $employeeData = $model->getArrayCopyForDB();
          // print_r($employeeData);die;
          $this->experienceGateway->insert($employeeData);
     }

     public function addTraining(Model $model) {
          $employeeData = $model->getArrayCopyForDB();
          // print_r($employeeData);die;
          $this->trainingGateway->insert($employeeData);
     }

     public function getByEmpIdTraining($employeeId,$updateId){
                    $sql = "SELECT
                    INITCAP(TO_CHAR(ET.FROM_DATE,
               'DD-MON-YYYY')) AS FROM_DATE,
               INITCAP(TO_CHAR(ET.TO_DATE,
               'DD-MON-YYYY')) AS TO_DATE,
               ET.ID AS ID,
               INITCAP(ET.TRAINING_NAME) AS TRAINING_NAME,
               ET.TOTAL_DAYS AS TOTAL_DAYS,
               ET.LOCATION AS LOCATION,
               ET.DELIVERED_BY AS DELIVERED_BY,
               ET.FUNDING AS FUNDING,
               ET.CERTIFICATION AS CERTIFICATION,
               ET.DESCRIPTION AS DESCRIPTION ,
                    REC_APP_ROLE($employeeId,RA.RECOMMEND_BY,RA.APPROVED_BY) AS ROLE,
                    REC_APP_ROLE_NAME($employeeId,RA.RECOMMEND_BY,RA.APPROVED_BY) AS YOUR_ROLE,
                    huc.*
          FROM HRIS_EMPLOYEE_TRAININGS_UPDATE ET 
          LEFT JOIN HRIS_RECOMMENDER_APPROVER RA ON RA.EMPLOYEE_ID=ET.EMPLOYEE_ID 
          left join hris_update_controller huc on huc.update_id=ET.update_id
          WHERE ET.EMPLOYEE_ID=$employeeId
          AND ET.UPDATE_ID=$updateId
          AND ET.STATUS='E'  
          ORDER BY ET.ID ASC
          ";
     $result=$this->rawQuery($sql);
     // print_r($result);die;
          return $result;
     }

     public function getByEmpIdRelation($employeeId,$updateId){
                    $sql = "SELECT
                    INITCAP(TO_CHAR(ER.DOB,
                    'DD-MON-YYYY')) AS DOB,
                    ER.E_R_ID AS E_R_ID,
                    ER.EMPLOYEE_ID AS EMPLOYEE_ID,
                    ER.RELATION_ID AS RELATION_ID,
                    ER.PERSON_NAME AS PERSON_NAME,
                    ER.IS_NOMINEE AS IS_NOMINEE,
                    ER.IS_DEPENDENT AS IS_DEPENDENT,
                    ER.CONTACT_NO AS CONTACT_NO,
                    CASE ER.IS_NOMINEE WHEN 'Y' 
              THEN 1 WHEN 'N' 
              THEN 0 
              END AS IS_NOMINEE_DET,
                    CASE ER.IS_DEPENDENT WHEN 'Y' 
              THEN 1 WHEN 'N' 
              THEN 0 
              END AS IS_DEPENDENT_DET,
                    R.RELATION_NAME AS RELATION_NAME,
                    ER.STATUS AS STATUS,
                    R.* ,
                    REC_APP_ROLE($employeeId,RA.RECOMMEND_BY,RA.APPROVED_BY) AS ROLE,
                   REC_APP_ROLE_NAME($employeeId,RA.RECOMMEND_BY,RA.APPROVED_BY) AS YOUR_ROLE,
                   huc.*
              FROM HRIS_EMPLOYEE_RELATION_UPDATE ER 
              INNER JOIN HRIS_RELATIONS R ON ER.RELATION_ID=R.RELATION_ID 
                        LEFT JOIN HRIS_RECOMMENDER_APPROVER RA ON RA.EMPLOYEE_ID=ER.EMPLOYEE_ID 
                        left join hris_update_controller huc on huc.update_id=ER.update_id
              WHERE ER.EMPLOYEE_ID = $employeeId
              AND ER.UPDATE_ID=$updateId
              AND ER.STATUS = 'E'
              ORDER BY ER.E_R_ID ASC 
               ";
               $result=$this->rawQuery($sql);
               // print_r($result);die;
                    return $result;

     }

 
}