<?php

namespace ManagerService\Controller;

use Application\Controller\HrisController;
use Application\Helper\Helper;
use SelfService\Form\RetirementForm;
use SelfService\Model\RetirementModel;
use SelfService\Repository\RetirementRepository;
use Zend\Authentication\Storage\StorageInterface;
use Zend\Db\Adapter\AdapterInterface;
use Zend\View\Model\JsonModel;

class RetirementApproverController extends HrisController {

    public function __construct(AdapterInterface $adapter, StorageInterface $storage) {
        parent::__construct($adapter, $storage);
        $this->initializeRepository(RetirementRepository::class);
        $this->initializeForm(RetirementForm::class);
    }

    public function indexAction(){

        if($this->getRequest()->isPost()){
            $data = $this->repository->retirementToApprove($this->employeeId);
            return new JsonModel(['success'=>true, 'data'=>$data]);
        }

    }

    public function viewAction(){

        $id = (int) $this->params()->fromRoute('id');

        if ($id === 0) {
            return $this->redirect()->toRoute("retirementApprove");
        }

        $data = $this->repository->fetchById($id);
        $documents = iterator_to_array($this->repository->fetchImagesById($id), false);

        return Helper::addFlashMessagesToArray($this, [
            'data' => $data,
            'documents' => $documents,
        ]);

    }

    public function approveRejectAction(){
        $request = $this->getRequest();
        $data = $request->getPost();

        $this->repository->approveReject($data, $this->employeeId);

        return new JsonModel(['success' => true, 'message' => null]);
    }

}