<?php
namespace Payroll\Form;

use Zend\Form\Annotation;

/**
 * @Annotation\Hydrator("Zend\Hydrator\ObjectPropertyHydrator")
 * @Annotation\Name("BasicSalaryForm")
 */
class BasicSalaryForm {

    /**
     * @Annotation\Type("Zend\Form\Element\Hidden")
     * @Annotation\Required(false)
     * @Annotation\Attributes({ "id":"basicSalaryId" })
     */
    public $egcId;

    /**
     * @Annotation\Type("Zend\Form\Element\Select")
     * @Annotation\Required(false)
     * @Annotation\Options({"disable_inarray_validator":"true","label":"Functional Level"})
     * @Annotation\Attributes({ "id":"functionalLevel", "class":"form-control" })
     */
    public $functionalLevelId;

    /**
     * @Annotation\Type("Zend\Form\Element\Select")
     * @Annotation\Required(true)
     * @Annotation\Options({"disable_inarray_validator":"true","label":"Acting Position"})
     * @Annotation\Attributes({ "id":"actingPosition", "class":"form-control" })
     */
    public $positionId;

    /**
     * @Annotation\Type("Zend\Form\Element\Number")
     * @Annotation\Required(true)
     * @Annotation\Options({"label":"Basic Salary"})
     * @Annotation\Attributes({ "id":"basicSalary", "class":"form-control", "min":"0"})
     */
    public $basicSalary;

    /**
     * @Annotation\Type("Zend\Form\Element\Text")
     * @Annotation\Required(true)
     * @Annotation\Options({"label":"From Date"})
     * @Annotation\Attributes({ "id":"fromDate", "class":"form-control"})
     */
    public $fromDate;

    /**
     * @Annotation\Type("Zend\Form\Element\Text")
     * @Annotation\Required(false)
     * @Annotation\Options({"label":"To Date"})
     * @Annotation\Attributes({ "id":"toDate", "class":"form-control" })
     */
    public $toDate;

    /**
     * @Annotation\Type("Zend\Form\Element\Number")
     * @Annotation\Required(true)
     * @Annotation\Options({"label":"One Day Salary"})
     * @Annotation\Attributes({ "id":"oneDaySalary", "class":"form-control", "min":"0"})
     */
    public $oneDaySalary;

    /**
     * @Annotation\Type("Zend\Form\Element\Number")
     * @Annotation\Required(true)
     * @Annotation\Options({"label":"Grade Ceiling Number"})
     * @Annotation\Attributes({ "id":"gradeCeilingNo", "class":"form-control", "min":"0"})
     */
    public $gradeCeilingNo;

    /**
     * @Annotation\Type("Zend\Form\Element\Select")
     * @Annotation\Required(false)
     * @Annotation\Options({"disable_inarray_validator":"true","label":"Salary Type"})
     * @Annotation\Attributes({ "id":"salaryType", "class":"form-control" })
     */
    public $salaryType;

    /**
     * @Annotation\Type("Zend\Form\Element\Select")
     * @Annotation\Required(false)
     * @Annotation\Options({"disable_inarray_validator":"true","label":"Status"})
     * @Annotation\Attributes({ "id":"status", "class":"form-control" })
     */
    public $status;

    /**
     * @Annotation\Type("Zend\Form\Element\Submit")
     * @Annotation\Attributes({"value":"Submit","class":"btn btn-success","id":"btnSubmit"})
     */
    public $submit;

}