<?php
namespace Payroll\Form;

use Zend\Form\Annotation;

/**
 * @Annotation\Hydrator("Zend\Hydrator\ObjectPropertyHydrator")
 * @Annotation\Name("BasicSalaryForm")
 */
class PayrollSuspendForm {

    /**
     * @Annotation\Type("Zend\Form\Element\Hidden")
     * @Annotation\Required(false)
     * @Annotation\Attributes({ "id":"modificationId" })
     */
    public $modificationId;

    /**
     * @Annotation\Type("Zend\Form\Element\Select")
     * @Annotation\Required(false)
     * @Annotation\Options({"disable_inarray_validator":"true","label":"Employees"})
     * @Annotation\Attributes({ "id":"employeeId", "class":"form-control" })
     */
    public $employeeId;

    /**
     * @Annotation\Type("Zend\Form\Element\Select")
     * @Annotation\Required(false)
     * @Annotation\Options({"disable_inarray_validator":"true","label":"From Month"})
     * @Annotation\Attributes({ "id":"fromMonthId", "class":"form-control" })
     */
    public $fromMonthId;

    /**
     * @Annotation\Type("Zend\Form\Element\Select")
     * @Annotation\Required(false)
     * @Annotation\Options({"disable_inarray_validator":"true","label":"To Month"})
     * @Annotation\Attributes({ "id":"toMonthId", "class":"form-control" })
     */
    public $toMonthId;

    /**
     * @Annotation\Type("Zend\Form\Element\Select")
     * @Annotation\Required(false)
     * @Annotation\Options({"disable_inarray_validator":"true","label":"Value Type"})
     * @Annotation\Attributes({ "id":"valueType", "class":"form-control" })
     */
    public $valueType;

    /**
     * @Annotation\Type("Zend\Form\Element\Textarea")
     * @Annotation\Required(true)
     * @Annotation\Options({"label":"Reason"})
     * @Annotation\Attributes({ "id":"reason", "class":"form-control", "style":" height: 50px; font-size:12px"})
     */
    public $reason;

    /**
     * @Annotation\Type("Zend\Form\Element\Number")
     * @Annotation\Required(false)
     * @Annotation\Options({"label":"Value"})
     * @Annotation\Attributes({ "id":"value", "class":"form-control"})
     */
    public $value;

    /**
     * @Annotation\Type("Zend\Form\Element\Select")
     * @Annotation\Required(false)
     * @Annotation\Options({"disable_inarray_validator":"true","label":"Is Halted?"})
     * @Annotation\Attributes({ "id":"isHalted", "class":"form-control" })
     */
    public $isHalted;

    /**
     * @Annotation\Type("Zend\Form\Element\Submit")
     * @Annotation\Attributes({"value":"Submit","class":"btn btn-success","id":"btnSubmit"})
     */
    public $submit;

}