<?php
namespace Payroll\Repository;

use Application\Repository\HrisRepository;
use Payroll\Model\SalarySheetEmpDetail;
use Zend\Db\Adapter\AdapterInterface;

class SalSheEmpDetRepo extends HrisRepository {

    public function __construct(AdapterInterface $adapter) {
        parent::__construct($adapter, SalarySheetEmpDetail::TABLE_NAME);
    }

    public function fetchOneBy($by) {
        return $this->tableGateway->select($by)->current();
    }
    
    public function fetchOneByWithEmpDetails($monthId,$employeeId){
             $boundedParameter = [];
        $boundedParameter['monthId'] = $monthId;
        $boundedParameter['employeeId'] = $employeeId;

        $sql="SELECT 
        SSD.*
        ,E.ID_PROVIDENT_FUND_NO
        ,E.ID_PAN_NO
        ,E.ID_RETIREMENT_NO
		,E.EMPLOYEE_CODE
		,E.ID_ACCOUNT_NO
        FROM HRIS_SALARY_SHEET_EMP_DETAIL SSD
        LEFT JOIN HRIS_EMPLOYEES E ON SSD.EMPLOYEE_ID=E.EMPLOYEE_ID
        WHERE
        SSD.MONTH_ID=? AND SSD.EMPLOYEE_ID=?";
       
        $statement = $this->adapter->query($sql);
        $result=$statement->execute($boundedParameter);
        return $result->current();
    }

    //for report only 30th may
        public function fetchOneByWithEmpDetailsReport($monthId,$employeeId,$fiscalYearId){
        $boundedParameter = [];
        // $boundedParameter['monthId'] = $monthId;
        $boundedParameter['employeeId'] = $employeeId;
        if($monthId== null || $monthId==''){
            $dummy="select * from hris_month_code where fiscal_year_id=$fiscalYearId and month_id < (select month_id from hris_month_code where current_date between from_date and to_date);";
            $dummyre=$this->rawQuery($dummy);
            $mthId = array_column($dummyre, 'MONTH_ID');
            // print_r($mthId);die;
        }
        else{
            $mthId=[$monthId];
        }
        $allResult=[];

        foreach($mthId as $m){
        $sql="SELECT 
        SSD.*
        ,E.ID_PROVIDENT_FUND_NO
        ,E.ID_PAN_NO
        ,E.ID_RETIREMENT_NO
        ,E.EMPLOYEE_CODE
        ,E.ID_ACCOUNT_NO
        FROM HRIS_SALARY_SHEET_EMP_DETAIL SSD
        LEFT JOIN HRIS_EMPLOYEES E ON SSD.EMPLOYEE_ID=E.EMPLOYEE_ID
        WHERE
        SSD.MONTH_ID=$m AND SSD.EMPLOYEE_ID=?";

            $statement = $this->adapter->query($sql);
            $result=$statement->execute($boundedParameter);
            $result=$result->current();
            $allResult[$m] = $result ;   
        }
        return $allResult;

    }
    
    
}
