<?php

namespace Punishment;

use Application\Controller\ControllerFactory;
use Punishment\Controller\PunishmentController;
use Zend\Router\Http\Segment;

return [
    'router' => [
        'routes' => [
            'punishment' => [
                'type' => Segment::class,
                'options' => [
                    'route' => '/punishment[/:action[/:id]]',
                    'defaults' => [
                        'controller' => PunishmentController::class,
                        'action' => 'index'
                    ]
                ]
            ],
        ]
    ],
    'navigation' => [
        'punishment' => [
            [
                'label' => 'Punishment',
                'route' => 'punishment',
            ],
            [
                'label' => 'Punishment',
                'route' => 'punishment',
                'pages' => [
                    [
                        'label' => 'List',
                        'route' => 'punishment',
                        'action' => 'index',
                    ],
                ]
            ]
        ],
    ],
    'controllers' => [
        'factories' => [
            PunishmentController::class => ControllerFactory::class,
        ],
    ],
    'view_manager' => [
        'template_path_stack' => [
            __DIR__ . '/../view',
        ],
    ],
];


