<?php
namespace Recruitment\Form;

use Zend\Form\Annotation;

/**
 * @Annotation\Hydrator("Zend\Hydrator\ObjectPropertyHydrator")
 * @Annotation\Name("OpeningForm")
 */
class OpeningForm {    
    
    /**
     * @Annotion\Type("Zend\Form\Element\Number")
     * @Annotation\Required(true)
     * @Annotation\Filter({"name":"StringTrim","name":"StripTags"})
     * @Annotation\Options({"label":"Opening Number"})
     * @Annotation\Validator({"name":"StringLength", "options":{"max":"7"}})
     * @Annotation\Attributes({ "id":"OpeningNo", "class":"OpeningNo form-control" })
     */
    public $OpeningNo;
    
     /**
     * @Annotation\Type("Zend\Form\Element\Text")
     * @Annotation\Required({"required":"true"})
     * @Annotation\Filter({"name":"StringTrim","name":"StripTags"})
     * @Annotation\Options({"label":"Start Date"})
     * @Annotation\Attributes({ "id":"Start_dt", "class":"Start_dt form-control" })
     */
    public $Start_dt;

    /**
     * @Annotation\Type("Zend\Form\Element\Text")
     * @Annotation\Required(false)
     * @Annotation\Filter({"name":"StringTrim","name":"StripTags"})
     * @Annotation\Options({"label":"End Date"})
     * @Annotation\Attributes({ "id":"End_dt", "class":"End_dt form-control" })
     */
    public $End_dt;
    /**
     * @Annotation\Type("Zend\Form\Element\Text")
     * @Annotation\Required(false)
     * @Annotation\Filter({"name":"StripTags","name":"StringTrim"})
     * @Annotation\Options({"label":"Extended Date"})
     * @Annotation\Attributes({ "id":"Extended_dt", "class":"Extended_dt form-control" })
     */
    public $Extended_dt;
    /**
     * @Annotation\Type("Zend\Form\Element\Textarea")
     * @Annotation\Required(false)
     * @Annotation\Filter({"name":"StripTags","name":"StringTrim"})
     * @Annotation\Options({"label":"Instruction English"})
     * @Annotation\Attributes({ "id":"Instruction_Edesc", "class":"Instruction_Edesc form-control" })
     */
    public $Instruction_Edesc;
    /**
     * @Annotation\Type("Zend\Form\Element\Textarea")
     * @Annotation\Required(false)
     * @Annotation\Filter({"name":"StringTrim","name":"StripTags"})
     * @Annotation\Options({"label":"Instruction Nepali "})
     * @Annotation\Attributes({ "id":"Instruction_Ndesc", "class":"Instruction_Ndesc form-control" })
     */
    public $Instruction_Ndesc;
       
    /**
     * @Annotation\Type("Zend\Form\Element\Submit")
     * @Annotation\Attributes({"value":"Submit","class":"btn btn-success"})
     */
    public $submit;

}
