<?php
namespace Recruitment\Form;

use Zend\Form\Annotation;

/**
 * @Annotation\Hydrator("Zend\Hydrator\ObjectPropertyHydrator")
 * @Annotation\Name("RecruitmentVacancy")
 */
class RecruitmentVacancyForm {
    
    /**
     * @Annotation\Type("Zend\Form\Element\Textarea")
     * @Annotation\Required(true)
     * @Annotation\Filter({"name":"StringTrim","name":"StripTags"})
     * @Annotation\Options({"label":"Vacancy English Description"})
     * @Annotation\Attributes({ "id":"VacancyEdesc", "class":"VacancyEdesc form-control" })
     */
    public $VacancyEdesc;

    /**
     * @Annotation\Type("Zend\Form\Element\Textarea")
     * @Annotation\Required(false)
     * @Annotation\Filter({"name":"StringTrim","name":"StripTags"})
     * @Annotation\Options({"label":"Vacancy Nepali Description"})
     * @Annotation\Attributes({ "id":"VacancyNdesc", "class":"VacancyNdesc form-control" })
     */
    public $VacancyNdesc;
    /**
     * @Annotion\Type("Zend\Form\Element\Text")
     * @Annotation\Required(true)
     * @Annotation\Filter({"name":"StringTrim","name":"StripTags"})
     * @Annotation\Options({"label":"Ad No"})
     * @Annotation\Validator({"name":"StringLength", "options":{"max":"500"}})
     * @Annotation\Attributes({ "id":"AdNo", "class":"AdNo form-control" })
     */
    public $AdNo;
    
    /**
     *  @Annotation\Type("Zend\Form\Element\Select")
     * @Annotation\Required(true)
     * @Annotation\Options({"disable_inarray_validator":"true","label":"Level"})
     * @Annotation\Attributes({ "id":"LevelId", "class":"LevelId form-control" })
     */
    public $LevelId;
    /**
     * @Annotation\Type("Zend\Form\Element\Textarea")
     * @Annotation\Required(false)
     * @Annotation\Filter({"name":"StringTrim","name":"StripTags"})
     * @Annotation\Options({"label":"Job Specification"})
     * @Annotation\Validator({"name":"StringLength", "options":{"max":"500"}})
     * @Annotation\Attributes({ "id":"JobSpecification", "class":"JobSpecification form-control" })
     */
    public $JobSpecification;

    /**
     * @Annotation\Type("Zend\Form\Element\Select")
     * @Annotation\Required(false)
     * @Annotation\Options({"disable_inarray_validator":"true","label":"Qualification"})
     * @Annotation\Attributes({ "id":"QualificationId","class":"form-control"})
     */
    public $QualificationId;
    /**
     * @Annotation\Type("Zend\Form\Element\Textarea")
     * @Annotation\Required(false)
     * @Annotation\Filter({"name":"StringTrim","name":"StripTags"})
     * @Annotation\Options({"label":"Roles"})
     * @Annotation\Validator({"name":"StringLength", "options":{"max":"255"}})
     * @Annotation\Attributes({ "id":"Roles", "class":"Roles form-control" })
     */
    public $Roles;

    /**
     * @Annotation\Type("Zend\Form\Element\Textarea")
     * @Annotation\Required(false)
     * @Annotation\Filter({"name":"StringTrim","name":"StripTags"})
     * @Annotation\Options({"label":"Responsibility"})
     * @Annotation\Attributes({ "id":"Responsibility", "class":"Responsibility form-control" })
     */
    public $Responsibility;
    /**
     * @Annotation\Type("Zend\Form\Element\Select")
     * @Annotation\Required(false)
     * @Annotation\Options({"disable_inarray_validator":"true","label":"Position"})
     * @Annotation\Attributes({ "id":"PositionId","class":"form-control"})
     */
    public $PositionId;
    /**
     * @Annotation\Type("Zend\Form\Element\Select")
     * @Annotation\Required(true)
     * @Annotation\Options({"disable_inarray_validator":"true","label":"Service Types"})
     * @Annotation\Attributes({ "id":"ServiceTypesId","class":"form-control"})
     */
    public $ServiceTypesId;
    /**
     * @Annotation\Type("Zend\Form\Element\Select")
     * @Annotation\Required(true)
     * @Annotation\Options({"disable_inarray_validator":"true","label":"Service Event"})
     * @Annotation\Attributes({ "id":"ServiceEventsId","class":"form-control"})
     */
    public $ServiceEventsId;
    /**
     * @Annotation\Type("Zend\Form\Element\Select")
     * @Annotation\Required(true)
     * @Annotation\Options({"disable_inarray_validator":"true","label":"Inclusion"})
     * @Annotation\Attributes({ "id":"InclusionId","class":"form-control","multiple":"multiple"})
     */
    public $InclusionId;
    /**
     * @Annotation\Type("Zend\Form\Element\Select")
     * @Annotation\Required(false)
     * @Annotation\Options({"disable_inarray_validator":"true","label":"Department"})
     * @Annotation\Attributes({ "id":"DepartmentId","class":"form-control"})
     */
    public $DepartmentId;
     /**
     * @Annotation\Type("Zend\Form\Element\Text")
     * @Annotation\Required(true)
     * @Annotation\Filter({"name":"StringTrim","name":"StripTags"})
     * @Annotation\Options({"label":"Experiance"})
     * @Annotation\Attributes({ "id":"Experiance", "class":"Experiance form-control" })
     */
    public $Experiance;    
    /**
     * @Annotation\Type("Zend\Form\Element\Text")
     * @Annotation\Required(true)
     * @Annotation\Filter({"name":"StringTrim","name":"StripTags"})
     * @Annotation\Options({"label":"Quota Open"})
     * @Annotation\Attributes({ "id":"QuotaOpen", "class":"QuotaOpen form-control" })
     */
    public $QuotaOpen;
    /**
     * @Annotation\Type("Zend\Form\Element\Text")
     * @Annotation\Required(true)
     * @Annotation\Filter({"name":"StringTrim","name":"StripTags"})
     * @Annotation\Options({"label":"Quota Internal"})
     * @Annotation\Attributes({ "id":"QuotaInternal", "class":"QuotaInternal form-control" })
     */
    public $QuotaInternal;
    /**
     * @Annotation\Type("Zend\Form\Element\Text")
     * @Annotation\Required(false)
     * @Annotation\Filter({"name":"StringTrim","name":"StripTags"})
     * @Annotation\Options({"label":"Remark"})
     * @Annotation\Attributes({ "id":"Remarks", "class":"form-control" })
     */
    public $Remarks;
    /**
     * @Annotation\Type("Zend\Form\Element\Select")
     * @Annotation\Required(true)
     * @Annotation\Options({"disable_inarray_validator":"true","label":"Openings No"})
     * @Annotation\Attributes({ "id":"OpeningId","class":"form-control"})
     */
    public $OpeningId;    
    /**
     * @Annotation\Type("Zend\Form\Element\Submit")
     * @Annotation\Attributes({"value":"Submit","class":"btn btn-success"})
     */
    public $submit;

}
