<?php
namespace Recruitment\Controller;

use Application\Controller\HrisController;
use Recruitment\Form\PotentialCandidatesForm;
use Zend\Db\Adapter\AdapterInterface;
use Zend\Authentication\Storage\StorageInterface;
use Application\Helper\Helper;
use Zend\View\Model\ViewModel;
use Recruitment\Repository\UserApplicationRepository;
use Application\Helper\EntityHelper;
use Zend\View\Model\JsonModel;

class PotentialCandidatesController extends HrisController
{
    function __construct(AdapterInterface $adapter, StorageInterface $storage) {

            parent::__construct($adapter, $storage);
            $this->initializeRepository(UserApplicationRepository::class);
            // $this->initializeForm(PotentialCandidatesForm::class);
        
    }
    public function indexAction(){

        $request = $this->getRequest();
        
        if($request->isPost()){

            $searchData = $request->getPost();

            // $data = $this->repository->getPotentialCandidates($searchData);
            $data = iterator_to_array($this->repository->getPotentialCandidates($searchData), false);

            return new JsonModel(['data'=>$data, "success"=>true]);
            
        }
        
        // $stages = EntityHelper::getTableList($this->adapter, 'HRIS_REC_STAGES', ['REC_STAGE_ID','STAGE_EDESC'], ['STATUS' => 'E','VACANCY_APPLICATION'=>'A'],'','ORDER_NO', 'DESC');
        // var_dump($stages);die;
        return $this->stickFlashMessagesTo([
            'searchValues' => EntityHelper::getSearchData($this->adapter),
            'Stages' => EntityHelper::getTableList($this->adapter, 'HRIS_REC_STAGES', ['REC_STAGE_ID','STAGE_EDESC'], ['STATUS' => 'E','VACANCY_APPLICATION'=>'A'],'','ORDER_NO', 'DSC'),
        ]);
    }


}