<?php
namespace Recruitment\Controller;

use Application\Controller\HrisController;
use Application\Helper\EmailHelper;
use Zend\Db\Adapter\AdapterInterface;
use Zend\Authentication\Storage\StorageInterface;
use Recruitment\Repository\UserApplicationRepository;
use Zend\View\Model\JsonModel; 
use Exception;
use Zend\Mail\Message;
use Zend\Mime\Message as MimeMessage;
use Zend\Mime\Part as MimePart;

Class ResultController extends HrisController{

    function __construct(AdapterInterface $adapter, StorageInterface $storage) {
        parent::__construct($adapter, $storage);
        $this->initializeRepository(UserApplicationRepository::class);
        
    }
    public function indexAction(){
       
    }
    public function excelUploadAction(){
        $excelData = $_POST['data'];
        $columnName = $_POST['type'];
        // var_dump($type);die;
        $count = count($excelData);

        for ($i=1; $i < $count ; $i++) { 
            

            $rollNo= $excelData[$i]['A'];
            $adNo= $excelData[$i]['B'];

            $userInfo = $this->repository->getRollNo($rollNo, $adNo);

            $applicationId = $userInfo['APPLICATION_ID'];
            // var_dump($applicationId);die;

            $resultUpdate = $this->repository->updateFlag($columnName, $applicationId);

            $updateRecVacancyApplication = $this->repository->updateRecVacancyApplication($applicationId);


            if (true) {
                if($_POST['IS_PASS']){
                $htmlDescription = "Dear ".$userInfo['FIRST_NAME']." ".$userInfo['MIDDLE_NAME']. " ". $userInfo['LAST_NAME']
                ."<br><br>Congratulations. You passed the examination "
                ."<br><br>Regards, <br>Nepal Oil Corporation Limited.";
                // $htmlDescription .= self::mailFooter();
                }
                elseif($_POST['IS_SHORTLISTED']){
                    $htmlDescription = "Dear ".$userInfo['FIRST_NAME']." ".$userInfo['MIDDLE_NAME']. " ". $userInfo['LAST_NAME']
                ."<br><br>You have been shortlisted."
                ."<br><br>Regards, <br>Nepal Oil Corporation Limited.";
                }
                else{
                    $htmlDescription = "Dear ".$userInfo['FIRST_NAME']." ".$userInfo['MIDDLE_NAME']. " ". $userInfo['LAST_NAME']
                ."<br><br>Congratulations. You passed the interview and you are selected as an employee of NEPAL OIL CORPORATION "
                ."<br><br>Regards, <br>Nepal Oil Corporation Limited.";
                }

                date_default_timezone_set("Asia/Kathmandu");
                $htmlPart = new MimePart($htmlDescription);
                $htmlPart->type = "text/html";

                $body = new MimeMessage();
                $body->setParts(array($htmlPart));

                // print_r($body);die;
                try{
                    $mail = new Message();
                    $mail->setSubject('NOC Result Published');
                    $mail->setBody($body);
                    $mail->setFrom('nepaloil.noreply@gmail.com', 'NOC');
                    if($userInfo['EMAIL_ID'] != null){
                        $mail->addTo($applicationData[0]['EMAIL_ID'], $applicationData[0]['FIRST_NAME']);
                        // $mail->addTo('srbunitydeveloper@gmail.com', $applicationData[0]['FIRST_NAME']);

                        // Commented for testing purpose
                        EmailHelper::sendEmailZOHO($mail);
                    }else{
                        continue;
                    }
                }catch(Exception $e){
                    continue;
                }

            }
            
        }

        return new JsonModel(['success' => true, 'data' => 'Successfully Excel File Uploaded']);

    }

}