<?php

namespace SelfService\Controller;

use Application\Controller\HrisController;

use Application\Helper\AppraisalHelper;
use Application\Helper\EntityHelper as ApplicationHelper;

use Application\Helper\CustomFormElement;
use Application\Helper\EntityHelper;
use Application\Helper\Helper;
use Zend\View\Model\JsonModel;
use Appraisal\Model\AppraisalAnswer;
use Appraisal\Model\AppraisalStatus;
use Appraisal\Model\Question;
use Appraisal\Model\Stage;
use Appraisal\Repository\AppraisalRepository;
use Appraisal\Repository\AppraisalAnswerRepository;
use Appraisal\Repository\AppraisalAssignRepository;
use Appraisal\Repository\AppraisalStatusRepository;
use Appraisal\Repository\HeadingRepository;
use Appraisal\Model\AppraisalEmp;
use Exception;
use Notification\Controller\HeadNotification;
use Notification\Model\NotificationEvents;
use SelfService\Repository\AppraisalCompetenciesRepo;
use SelfService\Repository\AppraisalKPIRepository;
use Setup\Repository\EmployeeRepository;
use Zend\Authentication\AuthenticationService;
use Zend\Db\Adapter\AdapterInterface;
use Zend\Mvc\Controller\AbstractActionController;
use Appraisal\Form\AppraisalEmpForm;
use Appraisal\Model\AppraisalRemarks;
use Appraisal\Model\AppraisalEval;
use Appraisal\Model\AppraisalEvalDetails;

class PerformanceAppraisal extends HrisController {

    protected $repository;
    protected $adapter;
    protected $form;
    protected $employeeId;

    public function __construct(AdapterInterface $adapter) {
        $this->adapter = $adapter;
        $this->initializeForm(AppraisalEmpForm::class);
        $authService = new AuthenticationService();
        $this->employeeId = $authService->getStorage()->read()['employee_id'];
        $this->repository = new AppraisalRepository($this->adapter);
    }

    // public function indexAction() {
    //     $appraisalAssignRepo = new AppraisalAssignRepository($this->adapter);
    //     $result = $appraisalAssignRepo->fetchByEmployeeId($this->employeeId);
    //     $list = [];
    //     foreach ($result as $row) {
    //         $result = $this->repository->fetchByEmpAppraisalId($this->employeeId, $row['APPRAISAL_ID']);
    //         if ($result != null) {
    //             $row['ALLOW_ADD'] = false;
    //             $row['ALLOW_EDIT'] = true;
    //         } else {
    //             $row['ALLOW_ADD'] = true;
    //             $row['ALLOW_EDIT'] = false;
    //         }
    //         array_push($list, $row);
    //     }
    //     return Helper::addFlashMessagesToArray($this, ['list' => $list]);
    // }

    public function indexAction() {
        // $request = $this->getRequest();
        // $ra=$this->repository->getAppraisalReq($this->employeeId);
        // if ($request->isPost()) {
        //     try {
        //         $list=$this->repository->getAppraisalReq($this->employeeId);
        //         return new JsonModel(['success' => true, 'data' => $list, 'error' => '']);
        //     } catch (Exception $e) {
        //         return new JsonModel(['success' => false, 'data' => [], 'error' => $e->getMessage()]);
        //     }
        // }
        
        // return Helper::addFlashMessagesToArray($this, [
        //     'test' => $ra
        // ]);
    }

    public function appraisalRequestAction() {
        $request = $this->getRequest();
        if ($request->isPost()) {
            try {
                $list=$this->repository->getAppraisalReqSupervisor($this->employeeId);
                return new JsonModel(['success' => true, 'data' => $list, 'error' => '']);
            } catch (Exception $e) {
                return new JsonModel(['success' => false, 'data' => [], 'error' => $e->getMessage()]);
            }
        }
        
        return Helper::addFlashMessagesToArray($this, [
            'test' => 'success'
        ]);
    }

    

    public function addAction(){

        //get employee details
        $empDet= $this->repository->getEmpDet($this->employeeId)  ;
        $appraisal= new AppraisalEmp();
        $appraisal->exchangeArrayFromDB($empDet);
        $i=5;
        $this->form->bind($appraisal);

        $checkAppReq=$this->repository->checkAppReq($this->employeeId);

        $potentialSupervisor=$this->repository->getSupervisors($this->employeeId);

        $potSuper = array_column($potentialSupervisor, 'FULL_NAME', 'EMPLOYEE_ID');
        

        return $this->stickFlashMessagesTo([
            'form' => $this->form,
            'searchValues' => EntityHelper::getSearchData($this->adapter),
            'employeeName'=>$empDet['FULL_NAME'],
            'employeeCODE'=>$empDet['EMPLOYEE_CODE'],
            'position' => $empDet['POSITION_NAME'],
            'positionID' => $empDet['POSITION_ID'],
            'functionalLevel'=>$empDet['FUNCTIONAL_LEVEL_EDESC'],
            'funcLevelId'=>$empDet['FUNCTIONAL_LEVEL_ID'],
            'departmentID'=>$empDet['DEPARTMENT_ID'],
            'departmentName'=>$empDet['DEPARTMENT_NAME'],
            'branchID'=>$empDet['BRANCH_ID'],
            'branchName'=>$empDet['BRANCH_NAME'],
            'potentialSId'=>$potSuper,
            'i'=>$i,
            'checkAppReq'=>$checkAppReq,
            

        ]);
        

    }

    public function deleteAction(){
        $appraisalId = (int) $this->params()->fromRoute("appraisalId", 0);
        // print_r($appraisalId);die;

        if ($id === 0) {
            return $this->redirect()->toRoute("performanceAppraisal");
        }

        //to delete
        // try{
        $this->repository->cancelReq($this->employeeId,$appraisalId);
        // }
        // catch(Exception $e){
        // }
        

    }

    public function editAction(){
        $appraisalId = (int) $this->params()->fromRoute("appraisalId", 0);
        // print_r($appraisalId);die;

        if ($id === 0) {
            return $this->redirect()->toRoute("performanceAppraisal");
        }

        $empDet= $this->repository->appraisalDetails($appraisalId)  ;

        
        //get employee details
        // $empDet= $this->repository->getEmpDet($this->employeeId)  ;
        $appraisal= new AppraisalEmp();
        $appraisal->exchangeArrayFromDB($empDet);
        
        // print_r($appraisal);die;
        

        $this->form->bind($appraisal);


        $potentialSupervisor=$this->repository->getSupervisors($this->employeeId);

        $potSuper = array_column($potentialSupervisor, 'FULL_NAME', 'EMPLOYEE_ID');
        

        return $this->stickFlashMessagesTo([
            'form' => $this->form,
            'searchValues' => EntityHelper::getSearchData($this->adapter),
            'position' => $empDet['POSITION_NAME'],
            'positionID' => $empDet['POSITION_ID'],
            'functionalLevel'=>$empDet['FUNCTIONAL_LEVEL_EDESC'],
            'funcLevelId'=>$empDet['FUNCTIONAL_LEVEL_ID'],
            'potentialSId'=>$potSuper,
            

        ]);
        

    }

    public function supervisorIndexAction() {
        // print_r('hello');die;
        $request = $this->getRequest();
        if ($request->isPost()) {
            try {
                $list=$this->repository->getAppraisalReq($this->employeeId);
                // print_r($list);die;
                return new JsonModel(['success' => true, 'data' => $list, 'error' => '']);
            } catch (Exception $e) {
                return new JsonModel(['success' => false, 'data' => [], 'error' => $e->getMessage()]);
            }
        }
        
        return Helper::addFlashMessagesToArray($this, [
        ]);
    }

    public function reviewerIndexAction() {
        // print_r('hello');die;
        $request = $this->getRequest();
        if ($request->isPost()) {
            try {
                $list=$this->repository->getAppraisalRevReq($this->employeeId);
                // print_r($list);die;
                return new JsonModel(['success' => true, 'data' => $list, 'error' => '']);
            } catch (Exception $e) {
                return new JsonModel(['success' => false, 'data' => [], 'error' => $e->getMessage()]);
            }
        }
        
        return Helper::addFlashMessagesToArray($this, [
        ]);
    }

    public function addSupervisorAction(){

        $appraisalId = (int) $this->params()->fromRoute("appraisalId", 0);
        // print_r($appraisalId);die;

        //###### in case no id is sent in route
        if ($appraisalId === 0) {
            return $this->redirect()->toRoute("performanceAppraisal");
        }

        //get employee's details from aprrasial_employee table and supervisor's detail too
        $appraisalDetails= $this->repository->appraisalDetails($appraisalId);
        
        //so that others cannot access the data even if they give the url and also supervisor cannot review the application again
        if($appraisalDetails['SUPERVISOR_ID']==$this->employeeId && $appraisalDetails['APPLICATION_STAGE']=='RQ'){
            
            $appraisal= new AppraisalEmp();
            $appraisal->exchangeArrayFromDB($appraisalDetails);
    
            //get remarks data of employee from appraisal_reamrks_detail table
            $remarkData=$this->repository->getRemarkDataFromDb($appraisalId);
    
            // ############  EVALUATION PART ####################
    
            // print_r($evalData);die;
            $questions=$this->repository->getQuestions();
    
            // print_r($questions);die;
    
            // ############ ENDS HERE ###########################
    
            $this->form->bind($appraisal);
        }
        else{
            return $this->redirect()->toRoute("performanceAppraisal",['action' => 'supervisorIndex']);
        }    

        $potentialSupervisor=$this->repository->getSupervisors($this->employeeId);

        $potSuper = array_column($potentialSupervisor, 'FULL_NAME', 'EMPLOYEE_ID');

        // echo '<pre>';
        // print_r($appraisal);die;

        return $this->stickFlashMessagesTo([
            'form' => $this->form,
            'remarkData'=>$remarkData,
            'appraisalDetails'=>$appraisalDetails,
            'questions' => $questions,
            'appraisalID'=>$appraisalId,//add in review
            'potentialSId'=>$potSuper,


        ]);
    }


    public function submitAction(){
        $request=$this->getRequest();
        try {
            if($request->isPost()){
                $data=$request->getPost();
                // print_r($data);die;
                $appraisal= new AppraisalEmp();
                $appraisal->employeeId=$this->employeeId;
                $appraisal->appraisalId=((int) Helper::getMaxId($this->adapter, "HRIS_APPRAISAL_EMPLOYEE", "APPRAISAL_ID")) + 1;
                $appraisal->positionId=$data['positionId'] ;
                $appraisal->departmentId=$data['departmentId'];
                $appraisal->branchId=$data['branchId'];
                $appraisal->fiscalYearId=$data['fiscalYearId'];
                // print_r($data);die;
                $appraisal->functionalLevelId = $data['functionalLevelId'];
                $appraisal->supervisorId = $data['supervisorId'];
                $appraisal->requestedDate = Helper::getExpressionDate($data['requestedDate']);
                $appraisal->status='E';

                    // print_r($appraisal);die;
                $this->repository->add($appraisal);
                
                $tempId=((int) Helper::getMaxId($this->adapter, "HRIS_APPRAISAL_REMARKS_DETAIL", "APP_REMARK_ID"));

                for ($i = 0; $i < count($data['wp']); $i++){
                    $remarks=new AppraisalRemarks() ;
                    $remarks->appraisalId=$appraisal->appraisalId;
                    $remarks->appRemarkId=$tempId + 1;
                    $remarks->workPerformedRemark=$data['wp'][$i];
                    $remarks->workAchievedRemark=$data['wa'][$i];
                    $remarks->status='E';
                    $tempId=$tempId+1;
                    $this->repository->addDetailRemarks($remarks);
                }
                return $this->redirect()->toRoute("performanceAppraisal",['action' => 'index']);
            }
        }
        catch (Exception $e){
            $this->flashmessenger()->addMessage("Appraisal Submit Failed!!");
                $this->flashmessenger()->addMessage($e->getMessage());
        }

        // print_r('nicweeeeeeeee');die;


    }

    public function submitSupervisorAction(){
        //get data
        $request=$this->getRequest();
        if($request->isPost()){
            $data=$request->getPost();
            $appraisalId=$data['appraisalId'];
            // print_r($data);die;
            
            // ################## in main appraisal table
            $appraisal= new AppraisalEmp();
            $appraisal->reviewerId= $data['reviewerId'] ;
            $appraisal->applicationStage='SU';
            $appraisal->approvedBySupervisorDate=date('Y-m-d');
            
            $this->repository->update($appraisal,$appraisalId);
            // print_r('hello');die;
        //########################## ends here

        // ###################### IN  REMAKRS TABLE
            for ($i = 0; $i < count($data['supervisorRemarks']); $i++){
                $remarks=new AppraisalRemarks() ;
                $remarks->supervisorRemark=$data['supervisorRemarks'][$i];
                $id=$i+1;
                $this->repository->updateRemark($remarks,$appraisalId,$id);
            }
            // ################ ENDS HERE

// ######### FOR EVALUATION IN EVAL MAIN TABLE
            $appEval= new AppraisalEval();
            $appEval->appraisalId=$appraisalId;
            $appEval->evaluationId=((int) Helper::getMaxId($this->adapter, "HRIS_APPRAISAL_EVALUATION", "EVALUATION_ID")) + 1;
            $appEval->remark=$data['supervisorEvalRemark'];
            $appEval->evaluatorId=$this->employeeId;
            $appEval->evaluatorRole='SU';
            $appEval->totalMark=array_sum($data['scores1']);
            $this->repository->insertAppraisalEval($appEval);
// ######### ends herer

            $evaluationId=$appEval->evaluationId;

############ FOR EVAUATION DETAIL IN EVAL DETAIL TABLE
            for ($i = 0; $i < count($data['questionId']); $i++){
                $appEvalDet= new AppraisalEvalDetails();
                $appEvalDet->evaluationId=$evaluationId;
                $appEvalDet->detailId=((int) Helper::getMaxId($this->adapter, "HRIS_APPRAISAL_EVALUATION_DETAILS", "DETAIL_ID")) + 1;
                $appEvalDet->marks=$data['scores1'][$i];
                $appEvalDet->questionId=$data['questionId'][$i];
                $this->repository->insertAppraisalEvalDetails($appEvalDet);
            }
// ############### ENDS HERE


        }
        return $this->redirect()->toRoute("performanceAppraisal",['action' => 'supervisorIndex']);
    }

    public function monthlyAction() {
        $appraisalAssignRepo = new AppraisalAssignRepository($this->adapter);
        $result = $appraisalAssignRepo->fetchByEmployeeId($this->employeeId, true);
        $list = [];
        foreach ($result as $row) {
            $result = $this->repository->fetchByEmpAppraisalId($this->employeeId, $row['APPRAISAL_ID']);
            if ($result != null) {
                $row['ALLOW_ADD'] = false;
                $row['ALLOW_EDIT'] = true;
            } else {
                $row['ALLOW_ADD'] = true;
                $row['ALLOW_EDIT'] = false;
            }
            array_push($list, $row);
        }
        return Helper::addFlashMessagesToArray($this, ['list' => $list]);
    }

    public function viewAction() {
        $request = $this->getRequest();
        $appraisalId = $this->params()->fromRoute('appraisalId');
        $appraisalAssignRepo = new AppraisalAssignRepository($this->adapter);
        $appraisalDurationType = (array) $appraisalAssignRepo->getDurationType($appraisalId);
        $action = null;
        if ($appraisalDurationType != null) {
            $action = ['action' => $appraisalDurationType['DURATION_TYPE'] == 'M' ? 'monthly' : 'index'];
        }
        $employeeRepo = new EmployeeRepository($this->adapter);
        $headingRepo = new HeadingRepository($this->adapter);

        $assignedAppraisalDetail = $appraisalAssignRepo->getEmployeeAppraisalDetail($this->employeeId, $appraisalId);
        $fromDate = $assignedAppraisalDetail['FROM_DATE'];
        $employeeDetail = $employeeRepo->fetchForProfileById($this->employeeId, $fromDate);
        $appraisalTypeId = $assignedAppraisalDetail['APPRAISAL_TYPE_ID'];
        $currentStageId = $assignedAppraisalDetail['STAGE_ID'];
        $headingList = $headingRepo->fetchByAppraisalTypeId($appraisalTypeId);
        $questionTemplate = [];

        $appraiseeFlag = ["(Q." . Question::APPRAISEE_FLAG . "='Y' OR Q." . Question::APPRAISEE_RATING . "='Y')"];
        $appraiserFlag = ["(Q." . Question::APPRAISER_FLAG . "='Y' OR Q." . Question::APPRAISER_RATING . "='Y') AND (Q." . Question::APPRAISEE_FLAG . "='N' AND Q." . Question::APPRAISEE_RATING . "='N')"];
        $reviewerFlag = ["(Q." . Question::REVIEWER_FLAG . "='Y' OR Q." . Question::REVIEWER_RATING . "='Y') AND (Q." . Question::APPRAISEE_FLAG . "='N' AND Q." . Question::APPRAISEE_RATING . "='N') AND (Q." . Question::APPRAISER_FLAG . "='N' AND Q." . Question::APPRAISER_RATING . "='N')"];

        $appraiserQuestionTemplate = [];
        $appraiseeQuestionTemplate = [];
        $reviewerQuestionTemplate = [];
        $questionForCurStage = 0;
        $questionForCurStageAppraisee = 0;
        $appraiserAvailableAnswer = false;
        $reviewerAvailableAnswer = false;
        foreach ($headingList as $headingRow) {
            //get question list for appraisee with current stage id
            $questionList = AppraisalHelper::getAllQuestionWidOptions($this->adapter, $headingRow['HEADING_ID'], $currentStageId, $appraiseeFlag, $appraisalId, $this->employeeId, $this->employeeId, "=1", [$assignedAppraisalDetail['APPRAISER_ID'], $assignedAppraisalDetail['ALT_APPRAISER_ID']], [$assignedAppraisalDetail['REVIEWER_ID'], $assignedAppraisalDetail['ALT_REVIEWER_ID']]);
            $appraiserQuestionList = AppraisalHelper::getAllQuestionWidOptions($this->adapter, $headingRow['HEADING_ID'], $currentStageId, $appraiserFlag, $appraisalId, $this->employeeId, [$assignedAppraisalDetail['APPRAISER_ID'], $assignedAppraisalDetail['ALT_APPRAISER_ID']], null, null, [$assignedAppraisalDetail['REVIEWER_ID'], $assignedAppraisalDetail['ALT_REVIEWER_ID']]);
            $appraiseeQuestionList = AppraisalHelper::getAllQuestionWidOptions($this->adapter, $headingRow['HEADING_ID'], $currentStageId, $appraiseeFlag, $appraisalId, $this->employeeId, $this->employeeId, "!=1");
            $reviewerQuestionList = AppraisalHelper::getAllQuestionWidOptions($this->adapter, $headingRow['HEADING_ID'], $currentStageId, $reviewerFlag, $appraisalId, $this->employeeId, [$assignedAppraisalDetail['REVIEWER_ID'], $assignedAppraisalDetail['ALT_REVIEWER_ID']]);

            if ($appraiseeQuestionList['questionForCurStage']) {
                $questionForCurStageAppraisee += 1;
            }
            if ($questionList['questionForCurStage']) {
                $questionForCurStage += 1;
            }
            if ($appraiserQuestionList['availableAnswer']) {
                $appraiserAvailableAnswer = true;
            }
            if ($reviewerQuestionList['availableAnswer']) {
                $reviewerAvailableAnswer = true;
            }
            if (count($questionList['questionList']) > 0) {
                array_push($questionTemplate, [
                    'HEADING_ID' => $headingRow['HEADING_ID'],
                    'HEADING_EDESC' => $headingRow['HEADING_EDESC'],
                    'QUESTIONS' => $questionList['questionList']]);
            }
            if (count($appraiserQuestionList['questionList']) > 0) {
                array_push($appraiserQuestionTemplate, [
                    'HEADING_ID' => $headingRow['HEADING_ID'],
                    'HEADING_EDESC' => $headingRow['HEADING_EDESC'],
                    'QUESTIONS' => $appraiserQuestionList['questionList']]);
            }
            if (count($appraiseeQuestionList['questionList']) > 0) {
                array_push($appraiseeQuestionTemplate, [
                    'HEADING_ID' => $headingRow['HEADING_ID'],
                    'HEADING_EDESC' => $headingRow['HEADING_EDESC'],
                    'QUESTIONS' => $appraiseeQuestionList['questionList']]);
            }
            if (count($reviewerQuestionList['questionList']) > 0) {
                array_push($reviewerQuestionTemplate, [
                    'HEADING_ID' => $headingRow['HEADING_ID'],
                    'HEADING_EDESC' => $headingRow['HEADING_EDESC'],
                    'QUESTIONS' => $reviewerQuestionList['questionList']]);
            }
        }
        if ($request->isPost()) {
            try {
                $appraisalStatusRepo = new AppraisalStatusRepository($this->adapter);
                $appraisalStatus = new AppraisalStatus();
                $appraisalStatus->exchangeArrayFromDB($appraisalStatusRepo->fetchByEmpAppId($this->employeeId, $appraisalId)->getArrayCopy());
                $appraisalAnswerModel = new AppraisalAnswer();
                $postData = $request->getPost()->getArrayCopy();
                $answer = $postData['answer'];
                $appraiseeAgree = (isset($postData['appraiseeAgree'])) ? $postData['appraiseeAgree'] : null;
                $i = 0;
                $editMode = false;
                foreach ($answer as $key => $value) {
                    if (strpos($key, 'sr') !== false) {
                        $appraisalAnswerModel->rating = $value;
                        $appraisalAnswerModel->modifiedDate = Helper::getcurrentExpressionDate();
                        $appraisalAnswerModel->modifiedBy = $this->employeeId;
                        $maxAnswerId = (int) (Helper::getMaxId($this->adapter, AppraisalAnswer::TABLE_NAME, AppraisalAnswer::ANSWER_ID));
                        $answerId = ($postData['answerId'][$i] == 0) ? $maxAnswerId : $postData['answerId'][$i];
                        $this->repository->edit($appraisalAnswerModel, $answerId);
                        unset($appraisalAnswerModel);
                    } else {
                        $appraisalAnswerModel = new AppraisalAnswer();
                        $appraisalAnswerModel->answer = (gettype($value) == 'array') ? json_encode($value) : $value;
                        if ($postData['answerId'][$i] == 0) {
                            $appraisalAnswerModel->answerId = (int) (Helper::getMaxId($this->adapter, AppraisalAnswer::TABLE_NAME, AppraisalAnswer::ANSWER_ID)) + 1;
                            $appraisalAnswerModel->appraisalId = $appraisalId;
                            $appraisalAnswerModel->employeeId = $this->employeeId;
                            $appraisalAnswerModel->userId = $this->employeeId;
                            $appraisalAnswerModel->questionId = $key;
                            $appraisalAnswerModel->stageId = $currentStageId;
                            $appraisalAnswerModel->createdDate = Helper::getcurrentExpressionDate();
                            $appraisalAnswerModel->status = 'E';
                            $appraisalAnswerModel->createdBy = $this->employeeId;
                            $appraisalAnswerModel->approvedDate = Helper::getcurrentExpressionDate();
                            $appraisalAnswerModel->companyId = $employeeDetail['COMPANY_ID'];
                            $appraisalAnswerModel->branchId = $employeeDetail['BRANCH_ID'];
                            $this->repository->add($appraisalAnswerModel);
                        } else {
                            $editMode = true;
                            $appraisalAnswerModel->modifiedDate = Helper::getcurrentExpressionDate();
                            $appraisalAnswerModel->modifiedBy = $this->employeeId;
                            $this->repository->edit($appraisalAnswerModel, $key);
                        }
                    }
                    $i += 1;
                }
                $appraisalStatusRepo->updateColumnByEmpAppId([AppraisalStatus::APPRAISEE_AGREE => $appraiseeAgree], $appraisalId, $this->employeeId);

//                if ($assignedAppraisalDetail['HR_FEEDBACK_ENABLE'] != null && $assignedAppraisalDetail['HR_FEEDBACK_ENABLE'] == 'Y') {
//                    $nextStageId = 9; //hr comment stage
//                } else {
                    $nextStageId = AppraisalHelper::getNextStageId($this->adapter, $assignedAppraisalDetail['STAGE_ORDER_NO'] + 1);
//                }
                $appraisalAssignRepo->updateCurrentStageByAppId($nextStageId, $appraisalId, $this->employeeId);
                if ($assignedAppraisalDetail['STAGE_ID'] != 1) {
                    HeadNotification::pushNotification(NotificationEvents::APPRAISEE_FEEDBACK, $appraisalStatus, $this->adapter, $this, null, ['ID' => ($assignedAppraisalDetail['REVIEWED_BY'] != null) ? $assignedAppraisalDetail['REVIEWED_BY'] : $assignedAppraisalDetail['REVIEWER_ID'], 'USER_TYPE' => "REVIEWER"]);
                    HeadNotification::pushNotification(NotificationEvents::APPRAISEE_FEEDBACK, $appraisalStatus, $this->adapter, $this, null, ['ID' => $assignedAppraisalDetail['APPRAISED_BY'], 'USER_TYPE' => "APPRAISER"]);
                    if ($assignedAppraisalDetail['SUPER_REVIEWER_ID'] != null) {
                        HeadNotification::pushNotification(NotificationEvents::APPRAISEE_FEEDBACK, $appraisalStatus, $this->adapter, $this, null, ['ID' => $assignedAppraisalDetail['SUPER_REVIEWER_ID'], 'USER_TYPE' => "SUPER_REVIEWER"]);
                    }
                }
                $this->flashmessenger()->addMessage("Appraisal Successfully Submitted!!");
                $this->redirect()->toRoute("performanceAppraisal", $action);
            } catch (Exception $e) {
                $this->flashmessenger()->addMessage("Appraisal Submit Failed!!");
                $this->flashmessenger()->addMessage($e->getMessage());
            }
        }
        $defaultRatingDtl = AppraisalHelper::checkDefaultRatingForEmp($this->adapter, $this->employeeId, $appraisalTypeId);
        $appraisalKPI = new AppraisalKPIRepository($this->adapter);
        $appraisalCompetencies = new AppraisalCompetenciesRepo($this->adapter);
        $keyAchievementDtlNum = $appraisalKPI->countKeyAchievementDtl($this->employeeId, $appraisalId)['NUM'];
        $appraiserRatingDtlNum = $appraisalKPI->countAppraiserRatingDtl($this->employeeId, $appraisalId)['NUM'];
        $appCompetenciesRatingDtlNum = $appraisalCompetencies->countCompetenciesRatingDtl($this->employeeId, $appraisalId)['NUM'];
        
        
        return Helper::addFlashMessagesToArray($this, [
                    'assignedAppraisalDetail' => $assignedAppraisalDetail,
                    'employeeDetail' => $employeeDetail,
                    'questionTemplate' => $questionTemplate,
                    'appraiserQuestionTemplate' => $appraiserQuestionTemplate,
                    'appraiseeQuestionTemplate' => $appraiseeQuestionTemplate,
                    'reviewerQuestionTemplate' => $reviewerQuestionTemplate,
                    'performanceAppraisalObj' => CustomFormElement::formElement(),
                    'customRenderer' => Helper::renderCustomView(),
                    'customRendererForCheckbox' => Helper::renderCustomViewForCheckbox(),
                    'appraisalId' => $appraisalId,
                    'questionForCurStage' => $questionForCurStage,
                    'questionForCurStageAppraisee' => $questionForCurStageAppraisee,
                    'reviewerAvailableAnswer' => $reviewerAvailableAnswer,
                    'appraiserAvailableAnswer' => $appraiserAvailableAnswer,
                    'keyAchievementDtlNum' => $keyAchievementDtlNum,
                    'appraiserRatingDtlNum' => $appraiserRatingDtlNum,
                    'appCompetenciesRatingDtlNum' => $appCompetenciesRatingDtlNum,
                    'defaultRatingDtl' => $defaultRatingDtl,
                    'stagesInstrunction' => EntityHelper::getTableKVListWithSortOption($this->adapter, Stage::TABLE_NAME, Stage::STAGE_ID, [Stage::INSTRUCTION]),
                    'listUrl' => $this->url()->fromRoute('performanceAppraisal', $action)
        ]);
    }

    
    //##########################################################################################################################
    // FOR EVALUATION PART

    public function evaluationAppraisalAction(){
        $appraisalId = $this->params()->fromRoute('appraisalId');
        // print_r($appraisalId);die;        
        $evalData=$this->repository->getAppraisalForEval($appraisalId);
        $questions=$this->repository->getQuestions();


        return Helper::addFlashMessagesToArray($this, [
            'appraisalEval' => $evalData[0],
            'questions' => $questions,
        ]);

    }

    public function evaluationAppraisalReviewerAction(){
        $appraisalId = (int) $this->params()->fromRoute("appraisalId", 0);
        // print_r($appraisalId);die;

        if ($id === 0) {
            return $this->redirect()->toRoute("performanceAppraisal");
        }
        //get employee details
        $appraisalDetails= $this->repository->appraisalDetails($appraisalId);
        // print_r($appraisalDetails);die;

        if($appraisalDetails['REVIEWER_ID']!=$this->employeeId || $appraisalDetails['REVIEWER_ID']!='RE'){
            return $this->redirect()->toRoute("performanceAppraisal",['action' => 'reviewerIndex']);
        }

        $appraisal= new AppraisalEmp();
        $appraisal->exchangeArrayFromDB($appraisalDetails);
        $remarkData=$this->repository->getRemarkDataFromDb($appraisalId);

        // ############  EVALUATION PART ####################
        $evalData=$this->repository->getAppraisalForEval($appraisalId);

        // print_r($evalData);die;
        $questions=$this->repository->getQuestionsEval($appraisalId);

        // echo '<pre>';
        // print_r($questions);die;

        // ############ ENDS HERE ###########################


        $this->form->bind($appraisal);

        // echo '<pre>';
        // print_r($appraisal);die;

        // ###################### evaluation part #################
        $request=$this->getRequest();
        if($request->isPost()){
            $data=$request->getPost();
            // print_r($data);die;
            $appraisalId=$data['appraisalId'];

            // ################## in main appraisal table
            $appraisal= new AppraisalEmp();
            $appraisal->applicationStage='RE';
            $appraisal->approvedByReviewerDate=date('Y-m-d');
            
            $this->repository->update($appraisal,$appraisalId);
            // print_r('hello');die;
        //########################## ends here

// ######### FOR EVALUATION IN EVAL MAIN TABLE
            $appEval= new AppraisalEval();
            $appEval->appraisalId=$appraisalId;
            $appEval->evaluationId=((int) Helper::getMaxId($this->adapter, "HRIS_APPRAISAL_EVALUATION", "EVALUATION_ID")) + 1;
            $appEval->remark=$data['reviewerRemark'];
            $appEval->evaluatorId=$this->employeeId;
            $appEval->evaluatorRole='RE';
            $appEval->totalMark=array_sum($data['reviewerScore']);
            $this->repository->insertAppraisalEval($appEval);
// ######### ends herer

            $evaluationId=$appEval->evaluationId;

############ FOR EVAUATION DETAIL IN EVAL DETAIL TABLE
            for ($i = 0; $i < count($data['questionId']); $i++){
                $appEvalDet= new AppraisalEvalDetails();
                $appEvalDet->evaluationId=$evaluationId;
                $appEvalDet->detailId=((int) Helper::getMaxId($this->adapter, "HRIS_APPRAISAL_EVALUATION_DETAILS", "DETAIL_ID")) + 1;
                $appEvalDet->marks=$data['reviewerScore'][$i];
                $appEvalDet->questionId=$data['questionId'][$i];
                $this->repository->insertAppraisalEvalDetails($appEvalDet);
            }
// ############### ENDS HERE

            return $this->redirect()->toRoute("performanceAppraisal",['action' => 'reviewerIndex']);

        
        }
        

        return $this->stickFlashMessagesTo([
            'form' => $this->form,
            'remarkData'=>$remarkData,
            'appraisalDetails'=>$appraisalDetails,
            'appraisalEval' => $evalData[0],
            'questions' => $questions,
            'appraisalID'=>$appraisalId,
            

        ]);
    }


    public function reviewingCommiteeAction(){
        $appraisalId = (int) $this->params()->fromRoute("appraisalId", 0);
        // print_r($appraisalId);die;

        if ($id === 0) {
            return $this->redirect()->toRoute("performanceAppraisal");
        }
        //get employee details
        $appraisalDetails= $this->repository->appraisalDetails($appraisalId);
        // print_r($appraisalDetails);die;
        // print_r($empDet);die;
        $appraisal= new AppraisalEmp();
        $appraisal->exchangeArrayFromDB($appraisalDetails);
        $remarkData=$this->repository->getRemarkDataFromDb($appraisalId);

        // ############  EVALUATION PART ####################
        $evalData=$this->repository->getAppraisalForEval($appraisalId);

        // print_r($evalData);die;
        $questions=$this->repository->getQuestionsEval($appraisalId);
        // echo '<pre>';
        // print_r($questions);die;
        // ############ ENDS HERE ###########################
        $commiteeQuestions=$this->repository->getCommiteeQuestion();



        $this->form->bind($appraisal);
        return $this->stickFlashMessagesTo([            
            'form' => $this->form,
            'remarkData'=>$remarkData,
            'appraisalDetails'=>$appraisalDetails,
            'appraisalEval' => $evalData[0],
            'questions' => $questions,
            'appraisalID'=>$appraisalId,
            'commiteeQuestions'=>$commiteeQuestions,

            
        ]);
    }


    


}
