<?php
namespace SelfService\Model;

use Application\Model\Model;
use function Complex\sec;

class UpdateProfileModel extends Model {

    public $updateId;
    public $employeeId;

    public $employeeCode;
    public $firstName;
    public $middleName;
    public $lastName;
    public $nameNepali;
    public $genderId;
    public $birthDate;
    public $countryId;
    public $religionId;
    public $companyId;
    public $bloodGroupId;
    public $mobileNo;
    public $telephoneNo;
    public $socialActivity;
    public $extensionNo;
    public $emailOfficial;
    public $emailPersonal;
    public $socialNetwork;
    public $ethnicityId;

    public $emergContactName;
    public $emergContactNo;
    public $emergContactAddress;
    public $emergContactRelationship;

    public $addrPermHouseNo;
    public $addrPermWardNo;
    public $addrPermStreetAddress;
    public $addrTempZoneId;
    public $addrTempDistrictId;
    public $addrPermVdcMunicipalityId;
    public $addrPermProvinceId;
    
    public $addrTempProvinceId;
    public $addrTempHouseNo;
    public $addrTempWardNo;
    public $addrTempStreetAddress;
    public $addrPermZoneId;
    public $addrPermDistrictId;
    public $addrTempVdcMunicipalityId;
    
    public $famFatherName;
    public $famFatherOccupation;
    public $famGrandFatherName;
    public $maritualStatus;
    public $famSpouseName;
    public $famSpouseOccupation;
    public $famMotherName;
    public $famMotherOccupation;
    public $famGrandMotherName;
    public $famSpouseBirthDate;
    public $famSpouseWeddingAnniversary;
    



    const TABLE_NAME = "HRIS_UPDATE_PROFILE";

    const UPDATE_ID="UPDATE_ID";
    const EMPLOYEE_ID = "EMPLOYEE_ID";
    
    const EMPLOYEE_CODE = "EMPLOYEE_CODE";
    const FIRST_NAME = 'FIRST_NAME';
    const MIDDLE_NAME = 'MIDDLE_NAME';
    const LAST_NAME = 'LAST_NAME';
    const NAME_NEPALI = 'NAME_NEPALI';
    const GENDER_ID = 'GENDER_ID';
    const BIRTH_DATE = "BIRTH_DATE";
    const COUNTRY_ID = "COUNTRY_ID";
    const RELIGION_ID = 'RELIGION_ID';
    const COMPANY_ID = "COMPANY_ID";
    const BLOOD_GROUP_ID = "BLOOD_GROUP_ID";
    const MOBILE_NO = 'MOBILE_NO';
    const TELEPHONE_NO = 'TELEPHONE_NO';
    const SOCIAL_ACTIVITY = 'SOCIAL_ACTIVITY';
    const EXTENSION_NO = 'EXTENSION_NO';
    const ETHNICITY_ID = 'ETHNICITY_ID';
    const EMAIL_OFFICIAL = "EMAIL_OFFICIAL";
    const EMAIL_PERSONAL = "EMAIL_PERSONAL";
    const SOCIAL_NETWORK = "SOCIAL_NETWORK";


    const EMRG_CONTACT_NAME = "EMRG_CONTACT_NAME";
    const EMERG_CONTACT_NO = "EMERG_CONTACT_NO";
    const EMERG_CONTACT_ADDRESS = "EMERG_CONTACT_ADDRESS";
    const EMERG_CONTACT_RELATIONSHIP = "EMERG_CONTACT_RELATIONSHIP";


    const ADDR_PERM_HOUSE_NO = 'ADDR_PERM_HOUSE_NO';
    const ADDR_PERM_WARD_NO = 'ADDR_PERM_WARD_NO';
    const ADDR_PERM_STREET_ADDRESS = "ADDR_PERM_STREET_ADDRESS";
    const ADDR_PERM_VDC_MUNICIPALITY_ID = "ADDR_PERM_VDC_MUNICIPALITY_ID";
    const ADDR_PERM_ZONE_ID = "ADDR_PERM_ZONE_ID";
    const ADDR_PERM_DISTRICT_ID = "ADDR_PERM_DISTRICT_ID";
    const ADDR_PERM_PROVINCE_ID = "ADDR_PERM_PROVINCE_ID";

    const ADDR_TEMP_PROVINCE_ID = "ADDR_TEMP_PROVINCE_ID";
    const ADDR_TEMP_ZONE_ID = "ADDR_TEMP_ZONE_ID";
    const ADDR_TEMP_DISTRICT_ID = "ADDR_TEMP_DISTRICT_ID";
    const ADDR_TEMP_HOUSE_NO = "ADDR_TEMP_HOUSE_NO";
    const ADDR_TEMP_WARD_NO = 'ADDR_TEMP_WARD_NO';
    const ADDR_TEMP_STREET_ADDRESS = "ADDR_TEMP_STREET_ADDRESS";
    const ADDR_TEMP_VDC_MUNICIPALITY_ID = "ADDR_TEMP_VDC_MUNICIPALITY_ID";

    const FAM_FATHER_NAME = "FAM_FATHER_NAME";
    const FAM_FATHER_OCCUPATION = "FAM_FATHER_OCCUPATION";
    const FAM_GRAND_FATHER_NAME = "FAM_GRAND_FATHER_NAME";
    const MARITAL_STATUS = "MARITAL_STATUS";
    const FAM_SPOUSE_NAME = "FAM_SPOUSE_NAME";
    const FAM_SPOUSE_OCCUPATION = "FAM_SPOUSE_OCCUPATION";
    const FAM_MOTHER_NAME = "FAM_MOTHER_NAME";
    const FAM_MOTHER_OCCUPATION = "FAM_MOTHER_OCCUPATION";
    const FAM_GRAND_MOTHER_NAME = "FAM_GRAND_MOTHER_NAME";
    const FAM_SPOUSE_BIRTH_DATE = 'FAM_SPOUSE_BIRTH_DATE';
    const FAM_SPOUSE_WEDDING_ANNIVERSARY = "FAM_SPOUSE_WEDDING_ANNIVERSARY";



    
    public $mappings = [
        'updateId'=> self::UPDATE_ID,
        'employeeId' => self::EMPLOYEE_ID,
        'companyId' => self::COMPANY_ID,
        'employeeCode' => self::EMPLOYEE_CODE,
        'firstName' => self::FIRST_NAME,
        'middleName' => self::MIDDLE_NAME,
        'lastName' => self::LAST_NAME,
        'nameNepali' => self::NAME_NEPALI,
        'genderId' => self::GENDER_ID,
        'birthDate' => self::BIRTH_DATE,
        'countryId' => self::COUNTRY_ID,
        'bloodGroupId' => self::BLOOD_GROUP_ID,
        'religionId' => self::RELIGION_ID,
        'ethnicityId' => self::ETHNICITY_ID,
        'socialActivity' => self::SOCIAL_ACTIVITY,
        'telephoneNo' => self::TELEPHONE_NO,
        'mobileNo' => self::MOBILE_NO,
        'extensionNo' => self::EXTENSION_NO,
        'emailOfficial' => self::EMAIL_OFFICIAL,
        'emailPersonal' => self::EMAIL_PERSONAL,
        'socialNetwork' => self::SOCIAL_NETWORK,

        'emergContactName' => self::EMRG_CONTACT_NAME,
        'emergContactNo' => self::EMERG_CONTACT_NO,
        'emergContactAddress' => self::EMERG_CONTACT_ADDRESS,
        'emergContactRelationship' => self::EMERG_CONTACT_RELATIONSHIP,

        'addrPermHouseNo' => self::ADDR_PERM_HOUSE_NO,
        'addrPermWardNo' => self::ADDR_PERM_WARD_NO,
        'addrPermStreetAddress' => self::ADDR_PERM_STREET_ADDRESS,
        'addrPermZoneId' => self::ADDR_PERM_ZONE_ID,
        'addrPermDistrictId' => self::ADDR_PERM_DISTRICT_ID,
        'addrPermVdcMunicipalityId' => self::ADDR_PERM_VDC_MUNICIPALITY_ID,
        'addrPermProvinceId' =>self::ADDR_PERM_PROVINCE_ID,

        'addrTempProvinceId' =>self::ADDR_TEMP_PROVINCE_ID,
        'addrTempHouseNo' => self::ADDR_TEMP_HOUSE_NO,
        'addrTempWardNo' => self::ADDR_TEMP_WARD_NO,
        'addrTempStreetAddress' => self::ADDR_TEMP_STREET_ADDRESS,
        'addrTempZoneId' => self::ADDR_TEMP_ZONE_ID,
        'addrTempDistrictId' => self::ADDR_TEMP_DISTRICT_ID,
        'addrTempVdcMunicipalityId' => self::ADDR_TEMP_VDC_MUNICIPALITY_ID,

        'famFatherName' => self::FAM_FATHER_NAME,
        'famFatherOccupation' => self::FAM_FATHER_OCCUPATION,
        'famMotherName' => self::FAM_MOTHER_NAME,
        'famMotherOccupation' => self::FAM_MOTHER_OCCUPATION,
        'famGrandFatherName' => self::FAM_GRAND_FATHER_NAME,
        'famGrandMotherName' => self::FAM_GRAND_MOTHER_NAME,
        'maritualStatus' => self::MARITAL_STATUS,
        'famSpouseName' => self::FAM_SPOUSE_NAME,
        'famSpouseOccupation' => self::FAM_SPOUSE_OCCUPATION,
        'famSpouseBirthDate' => self::FAM_SPOUSE_BIRTH_DATE,
        'famSpouseWeddingAnniversary' => self::FAM_SPOUSE_WEDDING_ANNIVERSARY


    ];

}
