<?php

namespace SelfService\Repository;

use Application\Helper\EntityHelper;
use Application\Helper\Helper;
use Application\Model\Model;
use Application\Repository\HrisRepository;
use Application\Repository\RepositoryInterface;
// use Workforce\Model\WorkforceModel;
use Zend\Db\Adapter\AdapterInterface;
use Zend\Db\Sql\Select;
use Zend\Db\TableGateway\TableGateway;
use Zend\Db\Sql\Expression;
use Zend\Db\Sql\Sql; 

class ProfileRepository extends HrisRepository 
{

    protected $tableGateway;
    protected $adapter;
    protected $profileGateway;

    public function __construct(AdapterInterface $adapter)
    {
        $this->adapter = $adapter;
        $this->tableGateway = new TableGateway('HRIS_UPDATE_CONTROLLER',$adapter);
        $this->profileGateway = new TableGateway('HRIS_UPDATE_PROFILE',$adapter);

    }

    public function updateControl($updateId,$empId,$which){
        if($which=='PI'){
            $field='IS_PERSONAL_INFORMATION';
        }
        elseif ($which=='QU') {
            $field='IS_QUALIFICATION';
        }
        elseif ($which=='EX') {
            $field='IS_EXPERIENCE';
        }
        elseif($which=='TR'){
            $field='IS_TRAINING';
        }
        elseif($which=='RE'){
            $field='IS_RELATION';
        }

        // print_r('new new new');die;
        $data = array(
            'UPDATE_ID' => $updateId,
            'EMPLOYEE_ID'  => $empId,
            $field => 1
        );
        // print_r($data);die;
        $this->tableGateway->insert($data);
    }

    public function addProfile(Model $model){
        $employeeData = $model->getArrayCopyForDB();
        // print_r($employeeData);die;

        $this->profileGateway->insert($employeeData);


    }

  
}