<?php

namespace SelfService\Repository;

use Application\Helper\Helper;
use Application\Helper\EntityHelper;
use Application\Model\Model;
use Application\Repository\RepositoryInterface;
use SelfService\Model\TrainingFeedback;
use Zend\Db\Adapter\AdapterInterface;
use Zend\Db\Sql\Expression;
use Zend\Db\Sql\Select;
use Zend\Db\Sql\Sql;
use Zend\Db\TableGateway\TableGateway;

class TrainingFeedbackRepository implements RepositoryInterface {

    private $tableGateway;
    private $adapter;

    public function __construct(AdapterInterface $adapter) {
        $this->adapter = $adapter;
        $this->tableGateway = new TableGateway(TrainingFeedback::TABLE_NAME, $adapter);
    }

    public function add(Model $model) {
        $this->tableGateway->insert($model->getArrayCopyForDB());
       
    }

    public function delete($id) {
        }

    public function edit(Model $model, $id) {
        
    }

    public function fetchAll() {
        
    }

    public function fetchById($id) {

        $sql = "
            select * from hris_training_feedback where feedback_id = {$id}
        ";

        return $this->adapter->query($sql)->execute()->current();

    }

    public function questions($trainingId, $employeeId){

        $sql = "
            select feedback_choices from hris_training_master_setup where training_id = {$trainingId}
        ";

        $choices = $this->adapter->query($sql)->execute()->current()['FEEDBACK_CHOICES'];

        if($choices != null){
            $sql = "
                select  
                cs.choice_id,
                title,
                feedback_type,
                value
                from hris_training_feedback_choice_setup cs
                left join hris_training_feedback tf on (tf.training_id = {$trainingId} and employee_id = {$employeeId})
                left join hris_training_feedback_detail fd on (cs.choice_id = fd.choice_id and tf.feedback_id = fd.feedback_id)
                where cs.choice_id in ({$choices});
            "; 

            return iterator_to_array($this->adapter->query($sql)->execute(), false);
        }

        return null;

    }

    public function insertFeedbackDetail($feedbackId, $choiceId, $value){
        $sql = "insert into hris_training_feedback_detail values({$feedbackId}, {$choiceId}, '{$value}', 'E')";

        $this->adapter->query($sql)->execute();
    }

    public function canGiveFeedback($employeeId, $trainingId){

        $sql = "
            select employee_id, training_id from hris_employee_training_assign where employee_id = {$employeeId} and training_id = {$trainingId}
            union
            select employee_id, training_id from hris_employee_training_request where employee_id = {$employeeId} and status = 'AP' and training_id = {$trainingId}
        ";

        return count(iterator_to_array($this->adapter->query($sql)->execute(), false)) == 0 ? false : true;

    }
    
}