<?php
namespace SelfService\Controller;

use Application\Controller\HrisController;
use Application\Custom\CustomViewModel;
use Application\Helper\EntityHelper;
use Application\Helper\Helper;
use Exception;
use Payroll\Repository\PayrollReportRepo;
use Payroll\Repository\SalarySheetDetailRepo;
use Payroll\Repository\SalarySheetRepo;
use Payroll\Repository\SalSheEmpDetRepo;
use Payroll\Repository\RulesRepository;
use Payroll\Repository\TaxSheetRepo;
use Zend\Authentication\Storage\StorageInterface;
use Zend\Db\Adapter\AdapterInterface;
use Zend\View\Model\JsonModel;

class Payroll extends HrisController {

    public function __construct(AdapterInterface $adapter, StorageInterface $storage) {
        parent::__construct($adapter, $storage);
        $this->initializeRepository(PayrollReportRepo::class);
    }

//old payslip report
//     public function payslipAction() {
//         $request = $this->getRequest();
//         if ($request->isPost()) {
//             try {
//                 $postedData = $request->getPost();
//                 $salarySheetDetailRepo = new SalarySheetDetailRepo($this->adapter);
//                 $salSheEmpDetRepo = new SalSheEmpDetRepo($this->adapter);
//                 $data['pay-detail'] = $salarySheetDetailRepo->fetchEmployeePaySlip($postedData['monthId'], $postedData['employeeId']);
//                 $data['emp-detail'] = $salSheEmpDetRepo->fetchOneByWithEmpDetails($postedData['monthId'], $postedData['employeeId']);
// //                $data['emp-detail'] = $salSheEmpDetRepo->fetchOneBy([
// //                    SalarySheetEmpDetail::MONTH_ID => $postedData['monthId'],
// //                    SalarySheetEmpDetail::EMPLOYEE_ID => $postedData['employeeId']
// //                ]);
//                 return new JsonModel(['success' => true, 'data' => $data, 'error' => '']);
//             } catch (Exception $e) {
//                 return new JsonModel(['success' => false, 'data' => [], 'error' => $e->getMessage()]);
//             }
//         }
//         return ['employeeId' => $this->employeeId];
//     }


// OLD 
    // public function taxslipAction() {
    //     $request = $this->getRequest();
    //     if ($request->isPost()) {
    //         try {
    //             $postedData = $request->getPost();
    //             $taxSheetRepo = new TaxSheetRepo($this->adapter);
    //             $data = $taxSheetRepo->fetchEmployeeTaxSlip($postedData['monthId'], $postedData['employeeId']);
    //             return new JsonModel(['success' => true, 'data' => $data, 'error' => '']);
    //         } catch (Exception $e) {
    //             return new JsonModel(['success' => false, 'data' => [], 'error' => $e->getMessage()]);
    //         }
    //     }
    //     return ['employeeId' => $this->employeeId];
    // }

//NEW 23RD JUNE
public function taxslipAction() {
    $request = $this->getRequest();
    if ($request->isPost()) {
        try {
            $taxRepo = new TaxSheetRepo($this->adapter);


            $postedData = $request->getPost();
            // print_r($postedData['fiscalYearId']);die;

            $employeeId = $this->employeeId ;
            $monthId=$postedData['monthId'];
            $fiscalYearId=$postedData['fiscalYearId'];
            $salaryType=isset($postedData['salaryType'])? $postedData['salaryType'] : 1;

            $data = $taxRepo->fetchTaxSheetPivotedEmp($employeeId, $fiscalYearId,$monthId,$salaryType);

            // echo "<pre>";
            // print_r($data);die;
     
            return new JsonModel(['success' => true, 'data' => $data, 'error' => '']);
        } catch (Exception $e) {
            return new JsonModel(['success' => false, 'data' => [], 'error' => $e->getMessage()]);
        }
    }
    $ruleRepo = new RulesRepository($this->adapter);


    //extracted manually 
    $taxPayIds=[6,38,40,42,43,44,45,46,47,54,69,87,88,89,90,94,95,96,97,98,107,115,149];
    
    $taxPayIdData = iterator_to_array($ruleRepo->fetchAll(), false);
    $i=0;
    foreach($taxPayIdData as $key){
        if(in_array($key['PAY_ID'],$taxPayIds)){
            $taxdata[$i]['PAY_ID']=$key['PAY_ID'];
            $taxdata[$i]['PAY_EDESC']=$key['PAY_EDESC'];
            $taxdata[$i]['PAY_TYPE_FLAG']=$key['PAY_TYPE_FLAG'];
            $i++;
        }

    }
    $data['ruleList']=$taxdata;

    // $data['salarySheetList'] = iterator_to_array($salarySheetRepo->fetchAll(), false);
    $data['acl'] = $this->acl;
    
    $salaryTypeList =EntityHelper::getTableList($this->adapter, hris_salary_type, ['SALARY_TYPE_ID' => "SALARY_TYPE_ID", 'SALARY_TYPE_NAME'=>"SALARY_TYPE_NAME"]);
    
    $data['salaryTypeList']=$salaryTypeList;

    return $data;
}

    public function taxYearlyAction() {

        $incomes = $this->repository->gettaxYearlyByHeads('IN');
        $taxExcemptions = $this->repository->gettaxYearlyByHeads('TE');
        $otherTax = $this->repository->gettaxYearlyByHeads('OT');
        $miscellaneous = $this->repository->gettaxYearlyByHeads('MI');
        $bMiscellaneou = $this->repository->gettaxYearlyByHeads('BM');
        $cMiscellaneou = $this->repository->gettaxYearlyByHeads('CM');
        $sumOfExemption = $this->repository->gettaxYearlyByHeads('SE', 'sin');
        $sumOfOtherTax = $this->repository->gettaxYearlyByHeads('ST', 'sin');

        $salarySheetRepo = new SalarySheetRepo($this->adapter);
        $salaryType = iterator_to_array($salarySheetRepo->fetchAllSalaryType(), false);

        return Helper::addFlashMessagesToArray($this, [
                    'searchValues' => EntityHelper::getSearchData($this->adapter),
                    'salaryType' => $salaryType,
                    'preference' => $this->preference,
                    'incomes' => $incomes,
                    'taxExcemptions' => $taxExcemptions,
                    'otherTax' => $otherTax,
                    'miscellaneous' => $miscellaneous,
                    'bMiscellaneou' => $bMiscellaneou,
                    'cMiscellaneou' => $cMiscellaneou,
                    'sumOfExemption' => $sumOfExemption,
                    'sumOfOtherTax' => $sumOfOtherTax
        ]);
    }

    public function pulltaxYearlyAction() {
        try {
            $request = $this->getRequest();
            $data = $request->getPost();
            $data['employeeId']=$this->employeeId;
            $resultData = $this->repository->getTaxYearly($data);
            $result = [];
            $result['success'] = true;
            $result['data']['employees'] = Helper::extractDbData($resultData);
            $result['error'] = "";
            return new CustomViewModel($result);
        } catch (Exception $e) {
            return new CustomViewModel(['success' => false, 'data' => [], 'error' => $e->getMessage()]);
        }
    }

    //payroll report 30th may
    public function payslipAction() {
        $request = $this->getRequest();
        $salarySheetRepo = new SalarySheetRepo($this->adapter);
        $salaryType = iterator_to_array($salarySheetRepo->fetchAllSalaryType(), false);
        if ($request->isPost()) {
            try {
                $postedData = $request->getPost();
                // print_r($postedData['fiscalYearId']);die;
                $salarySheetDetailRepo = new SalarySheetDetailRepo($this->adapter);
                $salSheEmpDetRepo = new SalSheEmpDetRepo($this->adapter);

                $data['pay-detail'] = $salarySheetDetailRepo->fetchEmployeePaySlipReport($postedData['monthId'], $postedData['employeeId'],$postedData['salaryTypeId'],$postedData['fiscalYearId']);
                $data['emp-detail'] = $salSheEmpDetRepo->fetchOneByWithEmpDetailsReport($postedData['monthId'], $postedData['employeeId'],$postedData['fiscalYearId']);
                
                return new JsonModel(['success' => true, 'data' => $data, 'error' => '']);
            } catch (Exception $e) {
                return new JsonModel(['success' => false, 'data' => [], 'error' => $e->getMessage()]);
            }
        }
        // return ['employeeId' => $this->employeeId];
        return $this->stickFlashMessagesTo(['employeeId' => $this->employeeId,'salaryType' => json_encode($salaryType)]);
    }


    public function payslipReportAction() {
        $request = $this->getRequest();
        $salarySheetRepo = new SalarySheetRepo($this->adapter);
        $salaryType = iterator_to_array($salarySheetRepo->fetchAllSalaryType(), false);
        if ($request->isPost()) {
            try {
                $postedData = $request->getPost();
                $salarySheetDetailRepo = new SalarySheetDetailRepo($this->adapter);
                $temp = $salarySheetDetailRepo->fetchEmployeePaySlipPayIds($postedData['monthId'], $this->employeeId,$postedData['salaryType'],$postedData['fiscalYearId']);
                

                $data['ruleList']=$temp;

                $data['data']=$salarySheetDetailRepo->fetchPaySlipPivoted($this->employeeId,$postedData['fiscalYearId'],$postedData['monthId'],$postedData['salaryType']);


                // $data['pay-detail'] = $salarySheetDetailRepo->fetchEmployeePaySlip($postedData['monthId'], $postedData['employeeId']);
              
                return new JsonModel(['success' => true, 'data' => $data, 'error' => '']);
            } catch (Exception $e) {
                return new JsonModel(['success' => false, 'data' => [], 'error' => $e->getMessage()]);
            }
        }


        $salaryTypeList =EntityHelper::getTableList($this->adapter, hris_salary_type, ['SALARY_TYPE_ID' => "SALARY_TYPE_ID", 'SALARY_TYPE_NAME'=>"SALARY_TYPE_NAME"]);
        $data['salaryTypeList']=$salaryTypeList;

        return $data;
    }


}
