<?php

namespace SelfService\Repository;

use Application\Repository\HrisRepository;
use Zend\Db\Adapter\AdapterInterface;

class ReportRepository extends HrisRepository {

    public function __construct(AdapterInterface $adapter, $tableName = null) {
        parent::__construct($adapter, $tableName);
    }


    public function getPFStatement($data) {
        
        $sql = "SELECT 

                    SS.SHEET_NO,
                    SS.MONTH_ID,
                    M.MONTH_EDESC,
                    Y.FISCAL_YEAR_NAME,
                    SS.CREATED_DT AS DATE_AD,
                    BS_DATE(SS.CREATED_DT) AS DATE_BS,
                    SUM(CASE WHEN P.PAY_ID = 21 THEN SSD.VAL END) AS PF_LOAN,
                    SUM(CASE WHEN P.PAY_ID = 34 THEN SSD.VAL END) AS EPF_ADDITION,
                    SUM(CASE WHEN P.PAY_ID = 36 THEN SSD.VAL END) AS EPF_DEDUCTION,
                    SUM(CASE WHEN P.PAY_ID = 62 THEN SSD.VAL END) AS ADDITION_EPF_CONTRIBUTION,
                    SUM(CASE WHEN P.PAY_ID = 106 THEN SSD.VAL END) AS EPF_LOAN_DEDUCTION

                FROM HRIS_PAY_SETUP P
                LEFT JOIN HRIS_SALARY_SHEET_DETAIL SSD ON SSD.PAY_ID = P.PAY_ID
                LEFT JOIN HRIS_SALARY_SHEET SS ON SS.SHEET_NO = SSD.SHEET_NO
                LEFT JOIN HRIS_MONTH_CODE M ON M.MONTH_ID = SS.MONTH_ID
                LEFT JOIN HRIS_FISCAL_YEARS Y ON Y.FISCAL_YEAR_ID = M.FISCAL_YEAR_ID

                WHERE 
                    SSD.PAY_ID IN (
                                SELECT 
                                    PAY_ID
                                FROM HRIS_PAY_SETUP
                                WHERE LOWER(PAY_EDESC) LIKE '%".$data['statement']."%'
                                ) AND
                                
                    SSD.EMPLOYEE_ID = {$data['employeeId']} AND
                    SS.CREATED_DT >= '".date('Y-m-d', strtotime($data['fromDate']))."' AND 
                    SS.CREATED_DT <= '".date('Y-m-d', strtotime($data['toDate']))."' AND 
                    SS.SALARY_TYPE_ID = 1

                GROUP BY SS.SHEET_NO, SS.MONTH_ID, M.MONTH_EDESC, Y.FISCAL_YEAR_NAME, SS.CREATED_DT
                ORDER BY SS.SHEET_NO ASC;

                ";


        return $this->rawQuery($sql);
    }


     public function getCITStatement($data) {
        
        $sql = "SELECT 

                    SS.SHEET_NO,
                    SS.MONTH_ID,
                    M.MONTH_EDESC,
                    Y.FISCAL_YEAR_NAME,
                    SS.CREATED_DT AS DATE_AD,
                    BS_DATE(SS.CREATED_DT) AS DATE_BS,
                    SUM(CASE WHEN P.PAY_ID = 18 THEN SSD.VAL END) AS CIT,
                    SUM(CASE WHEN P.PAY_ID = 86 THEN SSD.VAL END) AS TOTAL_DEDUCTION_LOAN_CIT

                FROM HRIS_PAY_SETUP P
                LEFT JOIN HRIS_SALARY_SHEET_DETAIL SSD ON SSD.PAY_ID = P.PAY_ID
                LEFT JOIN HRIS_SALARY_SHEET SS ON SS.SHEET_NO = SSD.SHEET_NO
                LEFT JOIN HRIS_MONTH_CODE M ON M.MONTH_ID = SS.MONTH_ID
                LEFT JOIN HRIS_FISCAL_YEARS Y ON Y.FISCAL_YEAR_ID = M.FISCAL_YEAR_ID

                WHERE 
                    SSD.PAY_ID IN (
                                SELECT 
                                    PAY_ID
                                FROM HRIS_PAY_SETUP
                                WHERE LOWER(PAY_EDESC) LIKE '%".$data['statement']."%'
                                ) AND

                    SSD.EMPLOYEE_ID = {$data['employeeId']} AND
                    SS.CREATED_DT >= '".date('Y-m-d', strtotime($data['fromDate']))."' AND 
                    SS.CREATED_DT <= '".date('Y-m-d', strtotime($data['toDate']))."' AND 
                    SS.SALARY_TYPE_ID = 1

                GROUP BY SS.SHEET_NO, SS.MONTH_ID, M.MONTH_EDESC, Y.FISCAL_YEAR_NAME, SS.CREATED_DT
                ORDER BY SS.SHEET_NO ASC;

                ";


        return $this->rawQuery($sql);
    }

    

}
