<?php

namespace Setup\Repository;

use Application\Helper\EntityHelper;
use Application\Helper\Helper;
use Application\Model\Model;
use Application\Repository\RepositoryInterface;
use Setup\Model\JobHistory;
use Zend\Db\Adapter\AdapterInterface;
use Zend\Db\Sql\Expression;
use Zend\Db\Sql\Sql;
use Zend\Db\TableGateway\TableGateway;
use Application\Repository\HrisRepository;

class FiscalYearRepository{

    public function __construct(AdapterInterface $adapter) {
        $this->adapter = $adapter;
        $this->tableGateway = new TableGateway('HRIS_FISCAL_YEARS', $adapter);
    }

    public function fetchAll(){
        $sql = "SELECT * FROM HRIS_FISCAL_YEARS WHERE STATUS='E' ORDER BY START_DATE DESC";

        return $this->adapter->query($sql)->execute();
    }

    public function insertYear($fiscalYearId, $startDate, $endDate, $fiscalYear){

        $sql = "
            INSERT INTO HRIS_FISCAL_YEARS
            (FISCAL_YEAR_ID, START_DATE, END_DATE, CREATED_DT, STATUS, FISCAL_YEAR_NAME)
            VALUES({$fiscalYearId}, '{$startDate}', '{$endDate}', CURRENT_DATE, 'E', '{$fiscalYear}')
        ";

        $this->adapter->query($sql)->execute();

    }

    public function insertMonth($leaveYearId, $monthId, $monthName, $fromDate, $toDate, $year, $monthNo, $fiscalYearMonthNo){

        $sql = "
            INSERT INTO HRIS_MONTH_CODE
            (FISCAL_YEAR_ID, MONTH_ID, MONTH_EDESC, MONTH_NDESC, FROM_DATE, TO_DATE, CREATED_DT, STATUS, YEAR, MONTH_NO, FISCAL_YEAR_MONTH_NO)
            VALUES($leaveYearId, $monthId, '{$monthName}', '{$monthName}', '{$fromDate}', '{$toDate}', CURRENT_DATE, 'E', '{$year}', {$monthNo}, {$fiscalYearMonthNo})
        ";

        $this->adapter->query($sql)->execute();

    }

    public function fetchFiscalYear($id){

        $sql = "SELECT * FROM HRIS_FISCAL_YEARS WHERE FISCAL_YEAR_ID={$id}";

        return $this->adapter->query($sql)->execute()->current();

    }

    public function fetchFiscalMonth($id){

        $sql = "SELECT * FROM HRIS_MONTH_CODE WHERE FISCAL_YEAR_ID={$id}";

        return $this->adapter->query($sql)->execute();

    }

    public function updateYear($fiscalYearId, $startDate, $endDate, $fiscalName){

        $sql = "
            UPDATE HRIS_FISCAL_YEARS
            SET START_DATE = '{$startDate}', END_DATE = '{$endDate}', FISCAL_YEAR_NAME = '{$fiscalName}'
            WHERE FISCAL_YEAR_ID = {$fiscalYearId}
        ";

        $this->adapter->query($sql)->execute();

    }

    public function updateMonth($monthId, $fromDate, $toDate){

        $sql = "
            UPDATE HRIS_MONTH_CODE
            SET FROM_DATE = '{$fromDate}', TO_DATE = '{$toDate}'
            WHERE MONTH_ID = {$monthId}
        ";

        $this->adapter->query($sql)->execute();

    }

    public function deleteYear($id){

        $sql = "
            UPDATE HRIS_FISCAL_YEARS
            SET STATUS = 'D'
            WHERE FISCAL_YEAR_ID = {$id}
        ";

        $this->adapter->query($sql)->execute();

    }

    public function deleteMonth($id){

        $sql = "
            UPDATE HRIS_MONTH_CODE
            SET STATUS = 'D'
            WHERE FISCAL_YEAR_ID = {$id}
        ";

        $this->adapter->query($sql)->execute();

    }

}