<?php

namespace Setup\Repository;

use Application\Helper\EntityHelper;
use Application\Helper\Helper;
use Application\Model\Model;
use Application\Repository\RepositoryInterface;
use Setup\Model\JobHistory;
use Zend\Db\Adapter\AdapterInterface;
use Zend\Db\Sql\Expression;
use Zend\Db\Sql\Sql;
use Zend\Db\TableGateway\TableGateway;
use Application\Repository\HrisRepository;

class LeaveYearRepository{

    public function __construct(AdapterInterface $adapter) {
        $this->adapter = $adapter;
        $this->tableGateway = new TableGateway('HRIS_LEAVE_YEARS', $adapter);
    }

    public function fetchAll(){
        $sql = "SELECT * FROM HRIS_LEAVE_YEARS WHERE STATUS='E' ORDER BY START_DATE DESC";

        return $this->adapter->query($sql)->execute();
    }

    public function insertYear($leaveYearId, $startDate, $endDate, $leaveYear){

        $sql = "
            INSERT INTO HRIS_LEAVE_YEARS
            (LEAVE_YEAR_ID, START_DATE, END_DATE, CREATED_DT, STATUS, LEAVE_YEAR_NAME)
            VALUES({$leaveYearId}, '{$startDate}', '{$endDate}', CURRENT_DATE, 'E', '{$leaveYear}')
        ";

        $this->adapter->query($sql)->execute();

    }

    public function insertMonth($leaveYearId, $monthId, $monthName, $fromDate, $toDate, $year, $monthNo){

        $sql = "
            INSERT INTO HRIS_LEAVE_MONTH_CODE
            (LEAVE_YEAR_ID, MONTH_ID, MONTH_EDESC, MONTH_NDESC, FROM_DATE, TO_DATE, CREATED_DT, STATUS, YEAR, MONTH_NO, LEAVE_YEAR_MONTH_NO)
            VALUES($leaveYearId, $monthId, '{$monthName}', '{$monthName}', '{$fromDate}', '{$toDate}', CURRENT_DATE, 'E', '{$year}', {$monthNo}, {$monthNo})
        ";

        $this->adapter->query($sql)->execute();

    }

    public function fetchLeaveYear($id){

        $sql = "SELECT * FROM HRIS_LEAVE_YEARS WHERE LEAVE_YEAR_ID={$id}";

        return $this->adapter->query($sql)->execute()->current();

    }

    public function fetchLeaveMonth($id){

        $sql = "SELECT * FROM HRIS_LEAVE_MONTH_CODE WHERE LEAVE_YEAR_ID={$id}";

        return $this->adapter->query($sql)->execute();

    }

    public function updateYear($leaveYearId, $startDate, $endDate, $leaveName){

        $sql = "
            UPDATE HRIS_LEAVE_YEARS
            SET START_DATE = '{$startDate}', END_DATE = '{$endDate}', LEAVE_YEAR_NAME = '{$leaveName}'
            WHERE LEAVE_YEAR_ID = {$leaveYearId}
        ";

        $this->adapter->query($sql)->execute();

    }

    public function updateMonth($monthId, $fromDate, $toDate){

        $sql = "
            UPDATE HRIS_LEAVE_MONTH_CODE
            SET FROM_DATE = '{$fromDate}', TO_DATE = '{$toDate}'
            WHERE MONTH_ID = {$monthId}
        ";

        $this->adapter->query($sql)->execute();

    }

    public function deleteYear($id){

        $sql = "
            UPDATE HRIS_LEAVE_YEARS
            SET STATUS = 'D'
            WHERE LEAVE_YEAR_ID = {$id}
        ";

        $this->adapter->query($sql)->execute();

    }

    public function deleteMonth($id){

        $sql = "
            UPDATE HRIS_LEAVE_MONTH_CODE
            SET STATUS = 'D'
            WHERE LEAVE_YEAR_ID = {$id}
        ";

        $this->adapter->query($sql)->execute();

    }

}