<?php

namespace Setup\Repository;

use Application\Helper\EntityHelper;
use Application\Helper\Helper;
use Application\Model\Model;
use Application\Repository\RepositoryInterface;
use Setup\Model\Company;
use Setup\Model\LoanSub;
use Zend\Db\Adapter\AdapterInterface;
use Zend\Db\Sql\Expression;
use Zend\Db\Sql\Select;
use Zend\Db\Sql\Sql;
use Zend\Db\TableGateway\TableGateway;
use Application\Repository\HrisRepository;

class LoanSubRepository extends HrisRepository {

    protected $tableGateway;
    protected $adapter;

    public function __construct(AdapterInterface $adapter) {
        $this->adapter=$adapter;
        $this->tableGateway = new TableGateway(LoanSub::TABLE_NAME, $adapter);
    }

    public function add(Model $model) {
        $this->tableGateway->insert($model->getArrayCopyForDB());
    }

    public function edit(Model $model, $id) {
        $array = $model->getArrayCopyForDB();
        unset($array[Loan::LOAN_ID]);
        unset($array[Loan::CREATED_DATE]);
        $this->tableGateway->update($array, [Loan::LOAN_ID => $id]);
    }

    public function delete($id) {
        $this->tableGateway->update([Loan::STATUS => 'D'], [Loan::LOAN_ID => $id]);
    }

    public function fetchBySubId($id){
        $sql = "SELECT * FROM HRIS_LOAN_MASTER_SETUP_SUB WHERE LOAN_ID = $id";
        $statement = $this->adapter->query($sql);
        $result = $statement->execute();
        return Helper::extractDbData($result);
    }

    public function pushFileLink($data){
        $fileName = $data['file'];
        $id = $data['id'] == null ? 0 : $data['id'] ;
        $oldfile = $data['fileName'];
        $sql = "INSERT INTO HRIS_LOAN_MASTER_FILES(FILE_ID, FILE_NAME, FILE_IN_DIR_NAME, UPLOADED_DATE, LOAN_ID)
        VALUES( (select ifnull(max(FILE_ID)+1, 1) from HRIS_LOAN_MASTER_FILES), '{$fileName}', '{$oldfile}', current_date, {$id})";
        return $this->rawQuery($sql);
    }

    public function pullFilesbyLoanId($id){
        $sql = "select * from HRIS_LOAN_MASTER_FILES where LOAN_ID = $id and status = 'E'";
        return $this->rawQuery($sql);
    }

    public function deleteFileByName($name){
        $sql = "update HRIS_LOAN_MASTER_FILES set status = 'D' where FILE_NAME = '{$name}'";
        return $this->rawQuery($sql);
    }

    public function loanDetail($id)
    {
        $sql = "SELECT * FROM HRIS_LOAN_MASTER_SETUP WHERE LOAN_ID = {$id}";
        return $this->rawQuery($sql);
    }

    public function updateLoanSetup($data)
    {
        $sql = "UPDATE HRIS_LOAN_MASTER_SETUP 
                SET HAS_SUB_LOAN = '".$data['hasSubLoan']."' 
                WHERE LOAN_ID = {$data['loanId']}";
        return $this->rawQuery($sql);
    }

   
}
