<?php

namespace Setup\Repository;

use Application\Model\Model;
use Application\Repository\HrisRepository;
use Setup\Model\TrainingFeedbackChoiceModel;
use Zend\Db\Adapter\AdapterInterface;
use Zend\Db\TableGateway\TableGateway;

class TrainingFeedbackChoiceRepository extends HrisRepository {

    protected $tableGateway;
    protected $adapter;

    public function __construct(AdapterInterface $adapter) {
        $this->tableGateway = new TableGateway(TrainingFeedbackChoiceModel::TABLE_NAME, $adapter);
        $this->adapter = $adapter;
    }

    public function fetchAll(){

        $sql = "
            SELECT 
            CHOICE_ID,
            TITLE,
            CASE WHEN FEEDBACK_TYPE = 'C' THEN 'Choice' ELSE 'Descriptive' END AS FEEDBACK_TYPE,
            CASE WHEN INCLUDE_IN_ALL = 'Y' THEN 'Yes' ELSE 'No' END AS INCLUDE_IN_ALL
            FROM HRIS_TRAINING_FEEDBACK_CHOICE_SETUP
            WHERE STATUS = 'E' ORDER BY CREATED_DATE
        ";

        return $this->adapter->query($sql)->execute();
    }

    public function fetchById($id){

        $sql = "
            SELECT 
            CHOICE_ID,
            TITLE,
            FEEDBACK_TYPE,
            INCLUDE_IN_ALL
            FROM HRIS_TRAINING_FEEDBACK_CHOICE_SETUP
            WHERE STATUS = 'E' AND CHOICE_ID = {$id}
        ";

        return $this->adapter->query($sql)->execute()->current();

    }

    public function add($model) {
        $this->tableGateway->insert($model->getArrayCopyForDB());
    }

    public function edit(Model $model, $id) {
        $temp = $model->getArrayCopyForDB();

        $this->tableGateway->update($temp, [TrainingFeedbackChoiceModel::CHOICE_ID => $id]);
    }

    public function delete($id){

        $sql = "
            UPDATE HRIS_TRAINING_FEEDBACK_CHOICE_SETUP SET STATUS = 'D' WHERE CHOICE_ID = $id
        ";

        $this->adapter->query($sql)->execute();

    }

}
